// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(v) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e) {
        return e.split("");
    }
    function ze(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Me(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function K(e, n) {
        if (n <= 0) return "";
        if (n == 1) return e;
        var t = K(e, n >> 1);
        t += t;
        return n & 1 ? t + e : t;
    }
    function n(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function r(e, n) {
        this.message = e;
        this.defs = n;
    }
    r.prototype = Object.create(Error.prototype);
    r.prototype.constructor = r;
    r.prototype.name = "DefaultsError";
    n(r);
    function pe(e, n, t) {
        if (t) for (var i in e) {
            if (Le(e, i) && !Le(n, i)) throw new r("`" + i + "` is not a supported option", n);
        }
        for (var i in e) {
            if (Le(e, i)) n[i] = e[i];
        }
        return n;
    }
    function t(e, n) {
        var t = 0;
        for (var i in n) if (Le(n, i)) {
            e[i] = n[i];
            t++;
        }
        return t;
    }
    function Fe() {}
    function je() {
        return false;
    }
    function qe() {
        return true;
    }
    function Ce() {
        return this;
    }
    function Ne() {
        return null;
    }
    var He = function() {
        function e(e, n) {
            var t = [];
            for (var i = 0; i < e.length; i++) {
                var r = n(e[i], i);
                if (r === a) continue;
                if (r instanceof o) {
                    t.push.apply(t, r.v);
                } else {
                    t.push(r);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Pe(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Ie(e, i) {
        return e.replace(/\{([^}]+)\}/g, function(e, n) {
            var t = i[n];
            return t instanceof We ? t.print_to_string() : t;
        });
    }
    function Re(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function Ue(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function Be(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function Ye() {
        this._values = Object.create(null);
        this._size = 0;
    }
    Ye.prototype = {
        set: function(e, n) {
            if (!this.has(e)) ++this._size;
            this._values["$" + e] = n;
            return this;
        },
        add: function(e, n) {
            if (this.has(e)) {
                this.get(e).push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return this._values["$" + e];
        },
        del: function(e) {
            if (this.has(e)) {
                --this._size;
                delete this._values["$" + e];
            }
            return this;
        },
        has: function(e) {
            return "$" + e in this._values;
        },
        all: function(e) {
            for (var n in this._values) if (!e(this._values[n], n.substr(1))) return false;
            return true;
        },
        each: function(e) {
            for (var n in this._values) e(this._values[n], n.substr(1));
        },
        size: function() {
            return this._size;
        },
        map: function(e) {
            var n = [];
            for (var t in this._values) n.push(e(this._values[t], t.substr(1)));
            return n;
        },
        clone: function() {
            var e = new Ye();
            for (var n in this._values) e._values[n] = this._values[n];
            e._size = this._size;
            return e;
        },
        toObject: function() {
            return this._values;
        }
    };
    Ye.fromObject = function(e) {
        var n = new Ye();
        n._size = t(n._values, e);
        return n;
    };
    function Le(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Ve(e, n) {
        var t = e.parent(-1);
        for (var i = 0, r; r = e.parent(i++); t = r) {
            if (mn(r)) {
                return n && r.value === t;
            } else if (r instanceof rt) {
                if (r.left === t) continue;
            } else if (r.TYPE == "Call") {
                if (r.expression === t) continue;
            } else if (r instanceof at) {
                if (r.condition === t) continue;
            } else if (r instanceof Kn) {
                if (r.expression === t) continue;
            } else if (r instanceof Xn) {
                if (r.expressions[0] === t) continue;
            } else if (r instanceof Je) {
                return r.body === t;
            } else if (r instanceof At) {
                if (r.tag === t) continue;
            } else if (r instanceof it) {
                if (r.expression === t) continue;
            }
            return false;
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function i(e, n, t, i) {
        if (typeof i === "undefined") i = We;
        n = n ? n.split(/\s+/) : [];
        var r = n;
        if (i && i.PROPS) n = n.concat(i.PROPS);
        var a = [ "return function AST_", e, "(props){", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        var o = i && new i();
        if (o && o.initialize || t && t.initialize) a.push("this.initialize();");
        a.push("}}");
        var s = new Function(a.join(""))();
        if (o) {
            s.prototype = o;
            s.BASE = i;
        }
        if (i) i.SUBCLASSES.push(s);
        s.prototype.CTOR = s;
        s.PROPS = n || null;
        s.SELF_PROPS = r;
        s.SUBCLASSES = [];
        if (e) {
            s.prototype.TYPE = s.TYPE = e;
        }
        if (t) for (var f in t) if (Le(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.prototype[f] = t[f];
            }
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        if (typeof v !== "undefined") {
            v["AST_" + e] = s;
        }
        return s;
    }
    var Q = i("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var We = i("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Yt(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: Fe,
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Bt(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Ie("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    (We.log_function = function(n, e) {
        if (!n) {
            We.info = We.warn = Fe;
            return;
        }
        var t = Object.create(null);
        We.info = e ? function(e, n) {
            i("INFO: " + Ie(e, n));
        } : Fe;
        We.warn = function(e, n) {
            i("WARN: " + Ie(e, n));
        };
        function i(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    We.enable_validation = function() {
        We.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!Le(n.prototype, "transform")) return;
            var i = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = i.call(this, e, n);
                if (t instanceof We) {
                    t.validate();
                } else if (!(t === null || n && He.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = i;
            });
        })(this);
    };
    We.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    var Je = i("Statement", null, {
        $documentation: "Base class of all statements"
    });
    var Ge = i("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, Je);
    var Xe = i("Directive", "value quote", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Je);
    var Ke = i("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, Je);
    function o(e, n, t, i, r) {
        t = t ? "contain" : "be";
        if (!(e instanceof We)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof Wn) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof ut) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Ht && !r) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof et && !i) throw new Error(n + " cannot " + t + " AST_Spread");
        if (e instanceof Je && !_n(e)) {
            throw new Error(n + " cannot " + t + " AST_Statement");
        }
        if (e instanceof bt) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function s(e, n) {
        o(e[n], n);
    }
    var Qe = i("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "body");
        }
    }, Je);
    var Ze = i("BlockScope", "enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Object/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Object/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof Ze)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof pn)) throw new Error("must be contained within AST_Scope");
        }
    }, Je);
    function en(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var nn = i("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                en(n, e);
            });
        },
        _validate: function() {
            this.body.forEach(function(e) {
                if (!(e instanceof Je)) throw new Error("body must be AST_Statement[]");
                if (_n(e)) throw new Error("body cannot contain AST_Function");
            });
        }
    }, Ze);
    var tn = i("BlockStatement", null, {
        $documentation: "A block statement"
    }, nn);
    var O = i("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (!(this.body instanceof Je)) throw new Error("body must be AST_Statement");
            if (_n(this.body)) throw new Error("body cannot be AST_Function");
        }
    }, Ze);
    var rn = i("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var i = this.label;
                n.walk(new Bt(function(e) {
                    if (e instanceof zn) {
                        if (!e.label || e.label.thedef !== i) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof pn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof de)) throw new Error("label must be AST_Label");
        }
    }, O);
    var an = i("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it."
    }, O);
    var on = i("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            s(this, "condition");
        }
    }, an);
    var sn = i("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, on);
    var fn = i("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, on);
    var un = i("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof We)) throw new Error("init must be AST_Node");
                if (this.init instanceof Je && !(this.init instanceof Un || _n(this.init))) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) s(this, "condition");
            if (this.step != null) s(this, "step");
        }
    }, an);
    var cn = i("ForIn", "init object", {
        $documentation: "A `for ... in` statement",
        $propdoc: {
            init: "[AST_Node] the `for/in` initialization code",
            object: "[AST_Node] the object that we're looping through"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init instanceof Un) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Kn || e instanceof Dt)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            s(this, "object");
        }
    }, an);
    var ln = i("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, O);
    var pn = i("Scope", "uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Ce
    }, nn);
    var dn = i("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Object/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return Xt([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Yt(function(e) {
                if (e instanceof Xe && e.value == "$ORIG") {
                    return He.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return Xt([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Yt(function(e) {
                if (e instanceof Xe && e.value == "$ORIG") {
                    return He.splice(t);
                }
            }));
        }
    }, pn);
    var vn = i("Lambda", "argnames length_read rest uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean/S] tells whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Bt(function(e) {
                if (e instanceof Wn) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof lt) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof kt) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                en(e, n);
            });
        },
        _validate: function() {
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof kt)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof kt)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, pn);
    var hn = i("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, vn);
    function mn(e) {
        return e instanceof wn || e instanceof bn;
    }
    function _n(e) {
        return mn(e) || e instanceof xn || e instanceof kn;
    }
    function gn(e, n) {
        if (mn(e) && e.value) {
            e.value.walk(n);
        } else {
            en(e, n);
        }
    }
    var bn = i("Arrow", "inlined value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    en(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, vn);
    function yn(e) {
        return e instanceof wn || e instanceof Sn || e instanceof xn;
    }
    var wn = i("AsyncArrow", "inlined value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    en(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                s(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, vn);
    var xn = i("AsyncFunction", "inlined name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof St)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, vn);
    var kn = i("Function", "inlined name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof St)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, vn);
    function En(e) {
        return e instanceof Sn || e instanceof Tn;
    }
    var Sn = i("AsyncDefun", "inlined name", {
        $documentation: "An asynchronous function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof Et)) throw new Error("name must be AST_SymbolDefun");
        }
    }, vn);
    var Tn = i("Defun", "inlined name", {
        $documentation: "A function definition",
        $propdoc: {
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (!(this.name instanceof Et)) throw new Error("name must be AST_SymbolDefun");
        }
    }, vn);
    var Dn = i("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)"
    }, Je);
    var On = i("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        }
    }, Dn);
    var An = i("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    }, On);
    var $n = i("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            s(this, "value");
        }
    }, On);
    var zn = i("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.label != null) {
                if (!(this.label instanceof ve)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Dn);
    var Mn = i("Break", null, {
        $documentation: "A `break` statement"
    }, zn);
    var Fn = i("Continue", null, {
        $documentation: "A `continue` statement"
    }, zn);
    var jn = i("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            if (this.alternative != null) {
                if (!(this.alternative instanceof Je)) throw new Error("alternative must be AST_Statement");
                if (_n(this.alternative)) throw new error("alternative cannot be AST_Function");
            }
        }
    }, O);
    var qn = i("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                en(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Cn)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, nn);
    var Cn = i("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches"
    }, nn);
    var Nn = i("Default", null, {
        $documentation: "A `default` switch branch"
    }, Cn);
    var Hn = i("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                en(n, e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    }, Cn);
    var Pn = i("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                en(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof In)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof Rn)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, nn);
    var In = i("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                en(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof Tt)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, nn);
    var Rn = i("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, nn);
    var Un = i("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, Je);
    var Bn = i("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Vn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof yt)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, Un);
    var Yn = i("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Vn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof wt)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, Un);
    var Ln = i("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof Vn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof xt)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, Un);
    var Vn = i("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) s(this, "value");
        }
    });
    var Wn = i("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            s(this, "value");
        }
    });
    function f(e, n, t, i) {
        e[n].forEach(function(e) {
            o(e, n, true, t, i);
        });
    }
    var Jn = i("Call", "expression args pure", {
        $documentation: "A function call expression",
        $propdoc: {
            expression: "[AST_Node] expression to invoke as function",
            args: "[AST_Node*] array of arguments"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            s(this, "expression");
            f(this, "args", true);
        }
    });
    var Gn = i("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties"
    }, Jn);
    var Xn = i("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    var Kn = i("PropAccess", "expression property", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node"
        },
        getProperty: function() {
            var e = this.property;
            if (e instanceof $t) {
                return e.value;
            }
            if (e instanceof tt && e.operator == "void" && e.expression instanceof $t) {
                return;
            }
            return e;
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var Qn = i("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Kn);
    var Zn = i("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            s(this, "property");
        }
    }, Kn);
    var et = i("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var nt = i("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "expression");
        }
    });
    var tt = i("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, nt);
    var it = i("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, nt);
    var rt = i("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof ot)) s(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            s(this, "right");
        }
    });
    var at = i("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            s(this, "condition");
            s(this, "consequent");
            s(this, "alternative");
        }
    });
    var ot = i("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof ut) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Kn || e instanceof Dt)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            }
        }
    }, rt);
    var st = i("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            s(this, "expression");
        }
    });
    var ft = i("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var ut = i("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        }
    });
    function u(e, n, t) {
        if (e instanceof Wn && t) return u(e.name, n);
        if (e instanceof ut) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof ct) return e.elements.forEach(function(e) {
                if (!(e instanceof Ht)) u(e, n, true);
            });
            if (e instanceof pt) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var ct = i("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, ut);
    var lt = i("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof We) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof We)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof We)) throw new Error("value must be AST_Node");
        }
    });
    var pt = i("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof lt)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, ut);
    var dt = i("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof vt || e instanceof et)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var vt = i("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof We) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof We)) throw new Error("key must be string or AST_Node");
                s(this, "key");
            }
            if (!(this.value instanceof We)) throw new Error("value must be AST_Node");
        }
    });
    var ht = i("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            s(this, "value");
        }
    }, vt);
    var mt = i("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof hn)) throw new Error("value must be AST_Accessor");
        }
    }, vt);
    var _t = i("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof hn)) throw new Error("value must be AST_Accessor");
        }
    }, vt);
    var gt = i("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var bt = i("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, gt);
    var yt = i("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, bt);
    var wt = i("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, bt);
    var xt = i("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, bt);
    var kt = i("SymbolFunarg", null, {
        $documentation: "Symbol naming a function argument"
    }, xt);
    var Et = i("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, bt);
    var St = i("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, bt);
    var Tt = i("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, bt);
    var de = i("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, gt);
    var Dt = i("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, gt);
    var ve = i("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, gt);
    var Ot = i("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.name !== "this") throw new Error('name must be "this"');
        }
    }, gt);
    var At = i("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) s(this, "tag");
        }
    });
    var $t = i("Constant", null, {
        $documentation: "Base class for all constants"
    });
    var zt = i("String", "value quote", {
        $documentation: "A string literal",
        $propdoc: {
            value: "[string] the contents of this string",
            quote: "[string] the original quote character"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, $t);
    var Mt = i("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, $t);
    var Ft = i("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, $t);
    var jt = i("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, $t);
    var h = i("Atom", null, {
        $documentation: "Base class for atoms"
    }, $t);
    var qt = i("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, h);
    var Ct = i("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, h);
    var Nt = i("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, h);
    var Ht = i("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, h);
    var Pt = i("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, h);
    var It = i("Boolean", null, {
        $documentation: "Base class for booleans"
    }, h);
    var Rt = i("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, It);
    var Ut = i("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, It);
    function Bt(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Bt.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Fe);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            if (e instanceof vn) {
                this.directives = Object.create(this.directives);
            } else if (e instanceof Xe && !this.directives[e.value]) {
                this.directives[e.value] = e;
            }
            this.stack.push(e);
        },
        pop: function() {
            if (this.stack.pop() instanceof vn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof e) return i;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof pn) {
                for (var i = 0; i < t.body.length; ++i) {
                    var r = t.body[i];
                    if (!(r instanceof Xe)) break;
                    if (r.value == e) return r;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof rn && i.label.name == e.label.name) return i.body;
            } else for (var t = n.length; --t >= 0; ) {
                var i = n[t];
                if (i instanceof an || e instanceof Mn && i instanceof qn) return i;
            }
        },
        in_boolean_context: function() {
            var e = this.self();
            for (var n = 0, t; t = this.parent(n); n++) {
                if (t instanceof at && t.condition === e || t instanceof on && t.condition === e || t instanceof un && t.condition === e || t instanceof jn && t.condition === e || t instanceof An && t.in_bool || t instanceof Xn && t.tail_node() !== e || t instanceof Qe || t instanceof tt && t.operator == "!" && t.expression === e) {
                    return true;
                }
                if (t instanceof rt && (t.operator == "&&" || t.operator == "||") || t instanceof at || t.tail_node() === e) {
                    e = t;
                } else if (t instanceof An) {
                    for (var i, r = t; i = this.parent(++n); r = i) {
                        if (i.TYPE == "Call") {
                            if (!(r instanceof vn) || r.name) return false;
                        } else if (r instanceof vn) {
                            return false;
                        }
                    }
                } else {
                    return false;
                }
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Yt(e, n) {
        Bt.call(this);
        this.before = e;
        this.after = n;
    }
    Yt.prototype = new Bt();
    (function(e) {
        function t(e, n) {
            return He(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(We, Fe);
        e(rn, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(Qe, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(nn, function(e, n) {
            e.body = t(e.body, n);
        });
        e(sn, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(fn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(un, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(cn, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(ln, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(On, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(zn, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(jn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(qn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Hn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Pn, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(In, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(Un, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(Vn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Wn, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(vn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(bn, n);
        e(wn, n);
        e(Jn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Xn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(st, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Qn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Zn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(et, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(nt, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(rt, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(at, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(ft, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(ct, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(lt, function(e, n) {
            if (e.key instanceof We) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(pt, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(dt, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(vt, function(e, n) {
            if (e.key instanceof We) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(At, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, r) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, i;
            e.push(this);
            if (e.before) t = e.before(this, r, n);
            if (typeof t === "undefined") {
                t = this;
                r(t, e);
                if (e.after) {
                    i = e.after(t, n);
                    if (typeof i !== "undefined") t = i;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var he = "break case catch const continue debugger default delete do else finally for function if in instanceof let new return switch throw try typeof var void while with";
    var M = "false null true";
    var A = [ "await abstract boolean byte char class double enum export extends final float goto implements import int interface long native package private protected public short static super synchronized this throws transient volatile yield", M, he ].join(" ");
    var F = "return new delete throw else case";
    he = Ue(he);
    A = Ue(A);
    F = Ue(F);
    M = Ue(M);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var j = Ue([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", ">>=", "<<=", ">>>=", "|=", "^=", "&=", "&&", "||" ]);
    var q = "\n\r\u2028\u2029";
    var C = "+-*&%=<>!?|~^";
    var N = "[{(,;:";
    var H = N + "`)}]";
    var P = q + "  \t\f\v​             　\ufeff";
    var I = Ue(e("./'\"" + C + H + P));
    q = Ue(e(q));
    C = Ue(e(C));
    N = Ue(e(N));
    H = Ue(e(H));
    P = Ue(e(P));
    function Z(e) {
        return e >= 55296 && e <= 56319;
    }
    function ee(e) {
        return e >= 56320 && e <= 57343;
    }
    function R(e) {
        return e >= 48 && e <= 57;
    }
    function ne(e) {
        return !I[e];
    }
    function Lt(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Vt(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e.length == 5) {
                n = e.slice(1);
            } else if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Wt(e, n, t, i, r) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = i;
        this.pos = r;
    }
    Wt.prototype = Object.create(Error.prototype);
    Wt.prototype.constructor = Wt;
    Wt.prototype.name = "SyntaxError";
    n(Wt);
    function me(e, n, t, i, r) {
        throw new Wt(e, n, t, i, r);
    }
    function _e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var B = {};
    function ge(r, a, o, s) {
        var f = {
            text: r,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: {},
            directive_stack: [],
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = l(true, true);
                    switch (t) {
                      case "\\":
                        t += l(true, true);
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            return true;
                        }
                    }
                    n += t;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw B;
            if (q[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function v() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (q[e[n]]) return n;
            }
            return -1;
        }
        function i(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw B;
            return t;
        }
        function h() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !Jt[n] || e == "keyword" && F[n] || e == "punc" && N[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var i = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                i.raw = r.substring(i.pos, i.endpos);
            }
            if (!t) {
                i.comments_before = f.comments_before;
                i.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new Q(i);
        }
        function _() {
            while (P[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t)) n += l();
            return n;
        }
        function b(e) {
            me(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            var t = false, i = false, r = false, a = e == ".";
            var n = g(function(e) {
                var n = e.charCodeAt(0);
                switch (n) {
                  case 120:
                  case 88:
                    return r ? false : r = true;

                  case 101:
                  case 69:
                    return r ? true : t ? false : t = i = true;

                  case 43:
                  case 45:
                    return i;

                  case i = false, 46:
                    return !a && !r && !t ? a = true : false;
                }
                return R(n) || /[_0-9a-fo]/i.test(e);
            });
            if (e) n = e + n;
            if (/^0[0-7_]+$/.test(n)) {
                if (z.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(r ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function w(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return x(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var i = Vt(n);
            if (typeof i != "string") b("Invalid escape sequence: \\" + n);
            return i;
        }
        function x(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && z.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var k = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var i = l(true, true);
                if (i == "\\") i = w(true); else if (q[i]) b("Unterminated string constant"); else if (i == n) break;
                t += i;
            }
            var r = m("string", t);
            r.quote = e;
            return r;
        });
        function E(e) {
            var n = f.regex_allowed;
            var t = v(), i;
            if (t == -1) {
                i = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                i = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, i, true));
            f.regex_allowed = n;
            return z;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = i("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return z;
        });
        function S() {
            var e = false, n = "", t, i = false, r;
            while (t = c()) {
                if (!e) {
                    if (t == "\\") i = e = true, l(); else if (ne(t)) n += l(); else break;
                } else {
                    if (t != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    t = w();
                    if (!ne(t)) b("Unicode char: " + t.charCodeAt(0) + " is not valid in identifier");
                    n += t;
                    e = false;
                }
            }
            if (he[n] && i) {
                r = n.charCodeAt(0).toString(16).toUpperCase();
                n = "\\u" + "0000".substr(r.length) + r + n.slice(1);
            }
            return n;
        }
        var T = n("Unterminated regular expression", function(e) {
            var n = false, t, i = false;
            while (t = l(true)) if (q[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                i = true;
                e += t;
            } else if (t == "]" && i) {
                i = false;
                e += t;
            } else if (t == "/" && !i) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var r = S();
            try {
                var a = new RegExp(e, r);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (j[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return E("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? T("") : D("/");
        }
        function A() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return R(e.charCodeAt(0)) ? y(".") : m("punc", ".");
        }
        function $() {
            var e = S();
            if (u) return m("name", e);
            return M[e] ? m("atom", e) : !he[e] ? m("name", e) : j[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === B) b(n); else throw e;
                }
            };
        }
        function z(e) {
            if (e != null) return T(e);
            if (s && f.pos == 0 && d("#!")) {
                h();
                p(2);
                E("comment5");
            }
            for (;;) {
                _();
                h();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        E("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        E("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return k(n);

                  case 46:
                    return A();

                  case 47:
                    var i = O();
                    if (i === z) continue;
                    return i;
                }
                if (R(t)) return y();
                if (H[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (C[n]) return D();
                if (t == 92 || !I[n]) return $();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        z.context = function(e) {
            if (e) f = e;
            return f;
        };
        z.add_directive = function(e) {
            f.directive_stack[f.directive_stack.length - 1].push(e);
            if (f.directives[e]) f.directives[e]++; else f.directives[e] = 1;
        };
        z.push_directives_stack = function() {
            f.directive_stack.push([]);
        };
        z.pop_directives_stack = function() {
            var e = f.directive_stack.pop();
            for (var n = e.length; --n >= 0; ) {
                f.directives[e[n]]--;
            }
        };
        z.has_directive = function(e) {
            return f.directives[e] > 0;
        };
        return z;
    }
    var be = Ue("typeof void delete -- ++ ! ~ - +");
    var Jt = Ue("-- ++");
    var ye = Ue("= += -= /= *= %= >>= <<= >>>= |= ^= &=");
    var Gt = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var i = e[t++];
            for (var r = 0; r < i.length; r++) {
                n[i[r]] = t;
            }
        }
        return n;
    }([ [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var we = Ue("atom bigint num regexp string");
    function Xt(e, u) {
        u = pe(u, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var l = {
            input: typeof e == "string" ? ge(e, u.filename, u.html5_comments, u.shebang) : e,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        l.token = d();
        function p(e, n) {
            return _e(l.token, e, n);
        }
        function c() {
            return l.peeked || (l.peeked = l.input());
        }
        function d() {
            l.prev = l.token;
            if (l.peeked) {
                l.token = l.peeked;
                l.peeked = null;
            } else {
                l.token = l.input();
            }
            l.in_directives = l.in_directives && (l.token.type == "string" || p("punc", ";"));
            return l.token;
        }
        function v() {
            return l.prev;
        }
        function o(e, n, t, i) {
            var r = l.input.context();
            me(e, r.filename, n != null ? n : r.tokline, t != null ? t : r.tokcol, i != null ? i : r.tokpos);
        }
        function s(e, n) {
            o(n, e.line, e.col);
        }
        function t(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function h(e) {
            if (e == null) e = l.token;
            s(e, "Unexpected token: " + t(e.type, e.value));
        }
        function a(e, n) {
            if (p(e, n)) return d();
            s(l.token, "Unexpected token: " + t(l.token.type, l.token.value) + ", expected: " + t(e, n));
        }
        function m(e) {
            return a("punc", e);
        }
        function f(e) {
            return e.nlb || !Be(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function _() {
            return !u.strict && (p("eof") || p("punc", "}") || f(l.token));
        }
        function g(e) {
            if (p("punc", ";")) d(); else if (!e && !_()) m(";");
        }
        function b() {
            m("(");
            var e = ue();
            m(")");
            return e;
        }
        function n(i) {
            return function() {
                var e = l.token;
                var n = i.apply(null, arguments);
                var t = v();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function y() {
            if (p("operator", "/") || p("operator", "/=")) {
                l.peeked = null;
                l.token = l.input(l.token.value.substr(1));
            }
        }
        var w = n(function() {
            y();
            switch (l.token.type) {
              case "string":
                var e = l.in_directives;
                var n = ue();
                if (e) {
                    if (n instanceof zt) {
                        var t = n.start.raw.slice(1, -1);
                        l.input.add_directive(t);
                        n.value = t;
                    } else {
                        l.in_directives = e = false;
                    }
                }
                g();
                return e ? new Xe(n) : new Qe({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return k();

              case "name":
                switch (l.token.value) {
                  case "async":
                    if (_e(c(), "keyword", "function")) {
                        d();
                        d();
                        return O(Sn);
                    }
                    break;

                  case "await":
                    if (l.in_async) return k();
                    break;
                }
                return _e(c(), "punc", ":") ? x() : k();

              case "punc":
                switch (l.token.value) {
                  case "{":
                    return new tn({
                        start: l.token,
                        body: $(),
                        end: v()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return k();

                  case ";":
                    l.in_directives = false;
                    d();
                    return new Ke();

                  default:
                    h();
                }

              case "keyword":
                switch (l.token.value) {
                  case "break":
                    d();
                    return E(Mn);

                  case "const":
                    d();
                    var i = j();
                    g();
                    return i;

                  case "continue":
                    d();
                    return E(Fn);

                  case "debugger":
                    d();
                    g();
                    return new Ge();

                  case "do":
                    d();
                    var n = ce(w);
                    a("keyword", "while");
                    var r = b();
                    g(true);
                    return new sn({
                        body: n,
                        condition: r
                    });

                  case "while":
                    d();
                    return new fn({
                        condition: b(),
                        body: ce(w)
                    });

                  case "for":
                    d();
                    return S();

                  case "function":
                    d();
                    return O(Tn);

                  case "if":
                    d();
                    return A();

                  case "let":
                    d();
                    var i = q();
                    g();
                    return i;

                  case "return":
                    if (l.in_function == 0 && !u.bare_returns) o("'return' outside of function");
                    d();
                    var t = null;
                    if (p("punc", ";")) {
                        d();
                    } else if (!_()) {
                        t = ue();
                        g();
                    }
                    return new An({
                        value: t
                    });

                  case "switch":
                    d();
                    return new qn({
                        expression: b(),
                        body: ce(z)
                    });

                  case "throw":
                    d();
                    if (f(l.token)) o("Illegal newline after 'throw'");
                    var t = ue();
                    g();
                    return new $n({
                        value: t
                    });

                  case "try":
                    d();
                    return M();

                  case "var":
                    d();
                    var i = C();
                    g();
                    return i;

                  case "with":
                    if (l.input.has_directive("use strict")) {
                        o("Strict mode may not include a with statement");
                    }
                    d();
                    return new ln({
                        expression: b(),
                        body: w()
                    });
                }
            }
            h();
        });
        function x() {
            var n = J(de);
            if (!Be(l.labels, function(e) {
                return e.name != n.name;
            })) {
                o("Label " + n.name + " defined twice");
            }
            m(":");
            l.labels.push(n);
            var e = w();
            l.labels.pop();
            if (!(e instanceof an)) {
                n.references.forEach(function(e) {
                    if (e instanceof Fn) {
                        s(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new rn({
                body: e,
                label: n
            });
        }
        function k() {
            var e = ue();
            g();
            return new Qe({
                body: e
            });
        }
        function E(e) {
            var n = null, t;
            if (!_()) {
                n = J(ve, true);
            }
            if (n != null) {
                t = Me(function(e) {
                    return e.name == n.name;
                }, l.labels);
                if (!t) s(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (l.in_loop == 0) o(e.TYPE + " not inside a loop or switch");
            g();
            var i = new e({
                label: n
            });
            if (t) t.references.push(i);
            return i;
        }
        function S() {
            m("(");
            var e = null;
            if (!p("punc", ";")) {
                e = p("keyword", "const") ? (d(), j(true)) : p("keyword", "let") ? (d(), q(true)) : p("keyword", "var") ? (d(), 
                C(true)) : ue(true);
                if (p("operator", "in")) {
                    if (e instanceof Un) {
                        if (e.definitions.length > 1) {
                            s(e.start, "Only one variable declaration allowed in for..in loop");
                        }
                    } else if (!(oe(e) || (e = se(e)) instanceof ut)) {
                        s(e.start, "Invalid left-hand side in for..in loop");
                    }
                    d();
                    return r(e);
                }
            }
            return i(e);
        }
        function i(e) {
            m(";");
            var n = p("punc", ";") ? null : ue();
            m(";");
            var t = p("punc", ")") ? null : ue();
            m(")");
            return new un({
                init: e,
                condition: n,
                step: t,
                body: ce(w)
            });
        }
        function r(e) {
            var n = ue();
            m(")");
            return new cn({
                init: e,
                object: n,
                body: ce(w)
            });
        }
        function T(e) {
            if (e instanceof ft) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof et) {
                    n = T(e.elements.pop().expression);
                }
                return new ct({
                    start: e.start,
                    elements: e.elements.map(T),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof ot) return new Wn({
                start: e.start,
                name: T(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof Wn) {
                e.name = T(e.name);
                return e;
            }
            if (e instanceof ct) {
                e.elements = e.elements.map(T);
                if (e.rest) e.rest = T(e.rest);
                return e;
            }
            if (e instanceof pt) {
                e.properties.forEach(function(e) {
                    e.value = T(e.value);
                });
                if (e.rest) e.rest = T(e.rest);
                return e;
            }
            if (e instanceof Ht) return e;
            if (e instanceof dt) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof et) {
                    n = T(e.properties.pop().expression);
                }
                return new pt({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof ht)) s(e.start, "Invalid destructuring assignment");
                        return new lt({
                            start: e.start,
                            key: e.key,
                            value: T(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof kt) return e;
            if (e instanceof Dt) return new kt(e);
            s(e.start, "Invalid arrow parameter");
        }
        function D(e, n, t) {
            var i = l.in_async;
            l.in_async = t;
            var r = l.in_funarg;
            l.in_funarg = l.in_function;
            var a = e.map(T);
            var o = e.rest || null;
            if (o) o = T(o);
            l.in_funarg = r;
            m("=>");
            var s, f;
            var u = l.in_loop;
            var c = l.labels;
            ++l.in_function;
            l.in_directives = true;
            l.input.push_directives_stack();
            l.in_loop = 0;
            l.labels = [];
            if (p("punc", "{")) {
                s = $();
                f = null;
                if (l.input.has_directive("use strict")) {
                    a.forEach(W);
                }
            } else {
                s = [];
                f = fe();
            }
            l.input.pop_directives_stack();
            --l.in_function;
            l.in_loop = u;
            l.labels = c;
            l.in_async = i;
            return new (t ? wn : bn)({
                start: n,
                argnames: a,
                rest: o,
                body: s,
                value: f,
                end: v()
            });
        }
        var O = function(e) {
            var n = l.in_async;
            var t;
            if (e === Sn) {
                t = J(Et);
                l.in_async = true;
            } else if (e === Tn) {
                t = J(Et);
                l.in_async = false;
            } else {
                l.in_async = e === xn;
                t = J(St, true);
            }
            if (t && e !== hn && !(t instanceof bt)) h(v());
            m("(");
            var i = l.in_funarg;
            l.in_funarg = l.in_function;
            var r = I(")", !u.strict, false, function() {
                return X(kt);
            });
            l.in_funarg = i;
            var a = l.in_loop;
            var o = l.labels;
            ++l.in_function;
            l.in_directives = true;
            l.input.push_directives_stack();
            l.in_loop = 0;
            l.labels = [];
            var s = $();
            if (l.input.has_directive("use strict")) {
                if (t) W(t);
                r.forEach(W);
                if (r.rest) W(r.rest);
            }
            l.input.pop_directives_stack();
            --l.in_function;
            l.in_loop = a;
            l.labels = o;
            l.in_async = n;
            return new e({
                name: t,
                argnames: r,
                rest: r.rest || null,
                body: s
            });
        };
        function A() {
            var e = b(), n = w(), t = null;
            if (p("keyword", "else")) {
                d();
                t = w();
            }
            return new jn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function $() {
            m("{");
            var e = [];
            while (!p("punc", "}")) {
                if (p("eof")) m("}");
                e.push(w());
            }
            d();
            return e;
        }
        function z() {
            m("{");
            var e = [], n, t, i, r;
            while (!p("punc", "}")) {
                if (p("eof")) m("}");
                if (p("keyword", "case")) {
                    if (n) n.end = v();
                    t = [];
                    n = new Hn({
                        start: (r = l.token, d(), r),
                        expression: ue(),
                        body: t
                    });
                    e.push(n);
                    m(":");
                } else if (p("keyword", "default")) {
                    if (n) n.end = v();
                    if (i) o("More than one default clause in switch statement");
                    t = [];
                    n = new Nn({
                        start: (r = l.token, d(), m(":"), r),
                        body: t
                    });
                    e.push(n);
                    i = n;
                } else {
                    if (!t) h();
                    t.push(w());
                }
            }
            if (n) n.end = v();
            d();
            return e;
        }
        function M() {
            var e = $(), n = null, t = null;
            if (p("keyword", "catch")) {
                var i = l.token;
                d();
                var r = null;
                if (p("punc", "(")) {
                    d();
                    r = G(Tt);
                    m(")");
                }
                n = new In({
                    start: i,
                    argname: r,
                    body: $(),
                    end: v()
                });
            }
            if (p("keyword", "finally")) {
                var i = l.token;
                d();
                t = new Rn({
                    start: i,
                    body: $(),
                    end: v()
                });
            }
            if (!n && !t) o("Missing catch/finally blocks");
            return new Pn({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function F(e, n) {
            var t = [];
            for (;;) {
                var i = l.token;
                var r = G(e);
                var a = null;
                if (p("operator", "=")) {
                    d();
                    a = fe(n);
                } else if (!n && (e === yt || r instanceof ut)) {
                    o("Missing initializer in declaration");
                }
                t.push(new Vn({
                    start: i,
                    name: r,
                    value: a,
                    end: v()
                }));
                if (!p("punc", ",")) break;
                d();
            }
            return t;
        }
        var j = function(e) {
            return new Bn({
                start: v(),
                definitions: F(yt, e),
                end: v()
            });
        };
        var q = function(e) {
            return new Yn({
                start: v(),
                definitions: F(wt, e),
                end: v()
            });
        };
        var C = function(e) {
            return new Ln({
                start: v(),
                definitions: F(xt, e),
                end: v()
            });
        };
        var N = function(e) {
            var n = l.token;
            a("operator", "new");
            var t = P(false), i;
            if (p("punc", "(")) {
                d();
                i = I(")", !u.strict);
            } else {
                i = [];
            }
            var r = new Gn({
                start: n,
                expression: t,
                args: i,
                end: v()
            });
            K(r);
            return Z(r, e);
        };
        function H() {
            var e = l.token, n;
            switch (e.type) {
              case "num":
                n = new Mt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "bigint":
                n = new Ft({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "string":
                n = new zt({
                    start: e,
                    end: e,
                    value: e.value,
                    quote: e.quote
                });
                break;

              case "regexp":
                n = new jt({
                    start: e,
                    end: e,
                    value: e.value
                });
                break;

              case "atom":
                switch (e.value) {
                  case "false":
                    n = new Rt({
                        start: e,
                        end: e
                    });
                    break;

                  case "true":
                    n = new Ut({
                        start: e,
                        end: e
                    });
                    break;

                  case "null":
                    n = new qt({
                        start: e,
                        end: e
                    });
                    break;
                }
                break;
            }
            d();
            return n;
        }
        var P = function(e) {
            if (p("operator", "new")) {
                return N(e);
            }
            var n = l.token;
            if (p("punc")) {
                switch (n.value) {
                  case "`":
                    var t = Q(null);
                    t.start = n;
                    t.end = v();
                    return Z(t, e);

                  case "(":
                    d();
                    if (p("punc", ")")) {
                        d();
                        return D([], n);
                    }
                    var i = ue(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(i.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = i.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var a = n.comments_before[0];
                        if (!a.nlb) {
                            a.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = i.start.comments_after;
                    i.start = n;
                    m(")");
                    var o = v();
                    o.comments_before = i.end.comments_before;
                    [].push.apply(i.end.comments_after, o.comments_after);
                    o.comments_after.length = 0;
                    o.comments_after = i.end.comments_after;
                    i.end = o;
                    if (i instanceof Jn) K(i);
                    if (p("punc", "=>")) return D(i instanceof Xn ? i.expressions : [ i ], n);
                    return Z(i, e);

                  case "[":
                    return Z(R(), e);

                  case "{":
                    return Z(B(), e);
                }
                h();
            }
            if (p("keyword", "function")) {
                d();
                var s = O(kn);
                s.start = n;
                s.end = v();
                return Z(s, e);
            }
            if (p("name")) {
                var f = V(Dt, n);
                d();
                if (f.name == "async") {
                    if (p("keyword", "function")) {
                        d();
                        var s = O(xn);
                        s.start = n;
                        s.end = v();
                        return Z(s, e);
                    }
                    if (p("name")) {
                        n = l.token;
                        f = V(Dt, n);
                        d();
                        return D([ f ], n, true);
                    }
                    if (p("punc", "(")) {
                        var u = Z(f, e);
                        if (!p("punc", "=>")) return u;
                        var c = u.args;
                        if (c[c.length - 1] instanceof et) {
                            c.rest = c.pop().expression;
                        }
                        return D(c, n, true);
                    }
                }
                return p("punc", "=>") ? D([ f ], n) : Z(f, e);
            }
            if (we[l.token.type]) {
                return Z(H(), e);
            }
            h();
        };
        function I(e, n, t, i) {
            if (!i) i = fe;
            var r = true, a = [];
            while (!p("punc", e)) {
                if (r) r = false; else m(",");
                if (n && p("punc", e)) break;
                if (t && p("punc", ",")) {
                    a.push(new Ht({
                        start: l.token,
                        end: l.token
                    }));
                } else if (!p("operator", "...")) {
                    a.push(i());
                } else if (i === fe) {
                    a.push(new et({
                        start: l.token,
                        expression: (d(), i()),
                        end: v()
                    }));
                } else {
                    d();
                    a.rest = i();
                    if (a.rest instanceof Wn) s(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            m(e);
            return a;
        }
        var R = n(function() {
            m("[");
            return new ft({
                elements: I("]", !u.strict, true)
            });
        });
        var U = n(function() {
            return O(hn);
        });
        var B = n(function() {
            m("{");
            var e = true, n = [];
            while (!p("punc", "}")) {
                if (e) e = false; else m(",");
                if (!u.strict && p("punc", "}")) break;
                var t = l.token;
                if (p("operator", "...")) {
                    d();
                    n.push(new et({
                        start: t,
                        expression: fe(),
                        end: v()
                    }));
                    continue;
                }
                if (_e(c(), "operator", "=")) {
                    var i = J(Dt);
                    d();
                    n.push(new ht({
                        start: t,
                        key: t.value,
                        value: new ot({
                            start: t,
                            left: i,
                            operator: "=",
                            right: fe(),
                            end: v()
                        }),
                        end: v()
                    }));
                    continue;
                }
                if (_e(c(), "punc", ",") || _e(c(), "punc", "}")) {
                    n.push(new ht({
                        start: t,
                        key: t.value,
                        value: J(Dt),
                        end: v()
                    }));
                    continue;
                }
                var r = Y();
                if (p("punc", "(")) {
                    var a = l.token;
                    var o = O(kn);
                    o.start = a;
                    o.end = v();
                    n.push(new ht({
                        start: t,
                        key: r,
                        value: o,
                        end: v()
                    }));
                    continue;
                }
                if (p("punc", ":")) {
                    d();
                    n.push(new ht({
                        start: t,
                        key: r,
                        value: fe(),
                        end: v()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    r = Y();
                    var a = l.token;
                    var o = O(xn);
                    o.start = a;
                    o.end = v();
                    n.push(new ht({
                        start: t,
                        key: r,
                        value: o,
                        end: v()
                    }));
                    continue;

                  case "get":
                    n.push(new _t({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: v()
                    }));
                    continue;

                  case "set":
                    n.push(new mt({
                        start: t,
                        key: Y(),
                        value: U(),
                        end: v()
                    }));
                    continue;
                }
                h();
            }
            d();
            return new dt({
                properties: n
            });
        });
        function Y() {
            var e = l.token;
            switch (e.type) {
              case "operator":
                if (!he[e.value]) h();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                d();
                return "" + e.value;

              case "punc":
                m("[");
                var n = fe();
                m("]");
                return n;

              default:
                h();
            }
        }
        function L() {
            var e = l.token.value;
            a("name");
            return e;
        }
        function V(e, n) {
            var t = n.value;
            if (t === "await" && l.in_async) h(n);
            return new (t === "this" ? Ot : e)({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function W(e) {
            if (e.name == "arguments" || e.name == "eval") s(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function J(e, n) {
            if (!p("name")) {
                if (!n) o("Name expected");
                return null;
            }
            var t = V(e, l.token);
            if (l.input.has_directive("use strict") && t instanceof bt) {
                W(t);
            }
            d();
            return t;
        }
        function G(e) {
            var n = l.token;
            if (p("punc", "[")) {
                d();
                var t = I("]", !u.strict, true, function() {
                    return X(e);
                });
                return new ct({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: v()
                });
            }
            if (p("punc", "{")) {
                d();
                var i = true, r = [], a = null;
                while (!p("punc", "}")) {
                    if (i) i = false; else m(",");
                    if (!u.strict && p("punc", "}")) break;
                    var o = l.token;
                    if (p("punc", "[") || _e(c(), "punc", ":")) {
                        var s = Y();
                        m(":");
                        r.push(new lt({
                            start: o,
                            key: s,
                            value: X(e),
                            end: v()
                        }));
                        continue;
                    }
                    if (p("operator", "...")) {
                        d();
                        a = G(e);
                        break;
                    }
                    var f = J(e);
                    if (p("operator", "=")) {
                        d();
                        f = new Wn({
                            start: f.start,
                            name: f,
                            value: fe(),
                            end: v()
                        });
                    }
                    r.push(new lt({
                        start: o,
                        key: o.value,
                        value: f,
                        end: v()
                    }));
                }
                m("}");
                return new pt({
                    start: n,
                    properties: r,
                    rest: a,
                    end: v()
                });
            }
            return J(e);
        }
        function X(e) {
            var n = l.token;
            var t = G(e);
            if (!p("operator", "=")) return t;
            d();
            return new Wn({
                start: n,
                name: t,
                value: fe(),
                end: v()
            });
        }
        function K(e) {
            var n = e.start;
            var t = n.comments_before;
            var i = Le(n, "comments_before_length") ? n.comments_before_length : t.length;
            while (--i >= 0) {
                var r = t[i];
                if (/[@#]__PURE__/.test(r.value)) {
                    e.pure = r;
                    break;
                }
            }
        }
        function Q(e) {
            var n = l.input.context().read_template;
            var t = [];
            var i = [];
            while (n(t)) {
                d();
                i.push(ue());
                if (!p("punc", "}")) h();
            }
            d();
            return new At({
                expressions: i,
                strings: t,
                tag: e
            });
        }
        var Z = function(e, n) {
            var t = e.start;
            if (p("punc", ".")) {
                d();
                return Z(new Qn({
                    start: t,
                    expression: e,
                    property: L(),
                    end: v()
                }), n);
            }
            if (p("punc", "[")) {
                d();
                var i = ue();
                m("]");
                return Z(new Zn({
                    start: t,
                    expression: e,
                    property: i,
                    end: v()
                }), n);
            }
            if (n && p("punc", "(")) {
                d();
                var r = new Jn({
                    start: t,
                    expression: e,
                    args: I(")", !u.strict),
                    end: v()
                });
                K(r);
                return Z(r, true);
            }
            if (p("punc", "`")) {
                var a = Q(e);
                a.start = e.start;
                a.end = v();
                return Z(a, n);
            }
            return e;
        };
        function ee() {
            var e = l.token;
            if (p("operator") && be[e.value]) {
                d();
                y();
                var n = ne(tt, e, te());
                n.start = e;
                n.end = v();
                return n;
            }
            var t = P(true);
            while (p("operator") && Jt[l.token.value] && !f(l.token)) {
                t = ne(it, l.token, t);
                t.start = e;
                t.end = l.token;
                d();
            }
            return t;
        }
        function ne(e, n, t) {
            var i = n.value;
            switch (i) {
              case "++":
              case "--":
                if (!oe(t)) s(n, "Invalid use of " + i + " operator");
                break;

              case "delete":
                if (t instanceof Dt && l.input.has_directive("use strict")) s(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: i,
                expression: t
            });
        }
        function te() {
            var e = l.token;
            if (!(l.in_async && p("name", "await"))) return ee();
            if (l.in_funarg === l.in_function) o("Invalid use of await in function argument");
            l.input.context().regex_allowed = true;
            d();
            return new st({
                start: e,
                expression: te(),
                end: v()
            });
        }
        var ie = function(e, n, t) {
            var i = p("operator") ? l.token.value : null;
            if (i == "in" && t) i = null;
            var r = i != null ? Gt[i] : null;
            if (r != null && r > n) {
                d();
                var a = ie(te(), i == "**" ? r - 1 : r, t);
                return ie(new rt({
                    start: e.start,
                    left: e,
                    operator: i,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function re(e) {
            return ie(te(), 0, e);
        }
        var ae = function(e) {
            var n = l.token;
            var t = re(e);
            if (p("operator", "?")) {
                d();
                var i = fe();
                m(":");
                return new at({
                    start: n,
                    condition: t,
                    consequent: i,
                    alternative: fe(e),
                    end: v()
                });
            }
            return t;
        };
        function oe(e) {
            return e instanceof Kn || e instanceof Dt;
        }
        function se(e) {
            if (e instanceof ft) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof et) {
                    n = se(e.elements.pop().expression);
                    if (!(n instanceof ut || oe(n))) return e;
                }
                var t = e.elements.map(se);
                return Be(t, function(e) {
                    return e instanceof Wn || e instanceof ut || e instanceof Ht || oe(e);
                }) ? new ct({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof ot) {
                var i = se(e.left);
                return i instanceof ut || oe(i) ? new Wn({
                    start: e.start,
                    name: i,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof dt)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof et) {
                n = se(e.properties.pop().expression);
                if (!(n instanceof ut || oe(n))) return e;
            }
            var r = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof ht)) return e;
                var s = se(o.value);
                if (!(s instanceof Wn || s instanceof ut || oe(s))) {
                    return e;
                }
                r.push(new lt({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new pt({
                start: e.start,
                properties: r,
                rest: n,
                end: e.end
            });
        }
        function fe(e) {
            var n = l.token;
            var t = ae(e), i = l.token.value;
            if (p("operator") && ye[i]) {
                if (oe(t) || i == "=" && (t = se(t)) instanceof ut) {
                    d();
                    return new ot({
                        start: n,
                        left: t,
                        operator: i,
                        right: fe(e),
                        end: v()
                    });
                }
                o("Invalid assignment");
            }
            return t;
        }
        function ue(e, n) {
            var t = l.token;
            var i = [];
            while (true) {
                if (n && p("operator", "...")) {
                    d();
                    i.rest = G(kt);
                    break;
                }
                i.push(fe(e));
                if (!p("punc", ",")) break;
                d();
                if (n && p("punc", ")") && _e(c(), "punc", "=>")) break;
            }
            return i.length == 1 && !i.rest ? i[0] : new Xn({
                start: t,
                expressions: i,
                end: v()
            });
        }
        function ce(e) {
            ++l.in_loop;
            var n = e();
            --l.in_loop;
            return n;
        }
        if (u.expression) {
            y();
            var le = ue();
            a("eof");
            return le;
        }
        return function() {
            var e = l.token;
            var n = [];
            l.input.push_directives_stack();
            while (!p("eof")) n.push(w());
            l.input.pop_directives_stack();
            var t = v();
            var i = u.toplevel;
            if (i) {
                i.body = i.body.concat(n);
                i.end = t;
            } else {
                i = new dn({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return i;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, i) {
        this.eliminated = 0;
        this.global = false;
        this.id = e;
        this.init = i;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.scope = n;
        this.undeclared = false;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            var n = e.cache && e.cache.props;
            if (this.global && n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (!this.mangled_name && !this.unmangleable(e)) {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = b(this, e);
                }
                if (this.global && n) {
                    n.set(this.name, this.mangled_name);
                }
            }
        },
        redefined: function() {
            var e = this.defun;
            if (!e) return;
            var n = this.name;
            var t = e.variables.get(n) || e instanceof dn && e.globals.get(n) || this.orig[0] instanceof yt && Me(function(e) {
                return e.name == n;
            }, e.enclosed);
            if (t && t !== this) return t.redefined() || t;
        },
        unmangleable: function(e) {
            return this.global && !e.toplevel || this.undeclared || !e.eval && this.scope.pinned() || e.keep_fnames && (this.orig[0] instanceof St || this.orig[0] instanceof Et);
        }
    };
    var Kt = Ue("delete ++ --");
    function Qt(e, n) {
        if (n instanceof ot) return n.left === e && e;
        if (n instanceof Wn) return n.name === e && e;
        if (n instanceof ut) return e;
        if (n instanceof lt) return e;
        if (n instanceof nt) return Kt[n.operator] && n.expression;
    }
    dn.DEFMETHOD("figure_out_scope", function(u) {
        u = pe(u, {
            cache: null,
            ie8: false
        });
        var c = this;
        var o = null;
        var t = 0;
        var s = c.parent_scope = null;
        var l = new Bt(function(i, e) {
            if (En(i)) {
                i.name.walk(l);
                r(function() {
                    i.argnames.forEach(function(e) {
                        e.walk(l);
                    });
                    if (i.rest) i.rest.walk(l);
                    en(i, l);
                });
                return true;
            }
            if (i instanceof Cn) {
                i.init_vars(s);
                e();
                return true;
            }
            if (i instanceof Pn) {
                r(function() {
                    en(i, l);
                });
                if (i.bcatch) i.bcatch.walk(l);
                if (i.bfinally) i.bfinally.walk(l);
                return true;
            }
            if (i instanceof ln) {
                var n = s;
                do {
                    n = n.resolve();
                    if (n.uses_with) break;
                    n.uses_with = true;
                } while (n = n.parent_scope);
                r(e);
                return true;
            }
            if (i instanceof Ze) {
                r(e);
                return true;
            }
            if (i instanceof gt) {
                i.scope = s;
            }
            if (i instanceof de) {
                i.thedef = i;
                i.references = [];
            }
            if (i instanceof Tt) {
                s.def_variable(i).defun = o;
            } else if (i instanceof yt) {
                s.def_variable(i).defun = o;
            } else if (i instanceof Et) {
                o.def_function(i, l.parent());
                a(o, s);
            } else if (i instanceof kt) {
                o.def_variable(i);
                a(o, s);
            } else if (i instanceof St) {
                var t = o.def_function(i, i.name == "arguments" ? undefined : o);
                if (u.ie8) t.defun = o.parent_scope.resolve();
            } else if (i instanceof wt) {
                s.def_variable(i);
            } else if (i instanceof xt) {
                o.def_variable(i, null);
                a(o, s);
            }
            function r(e) {
                i.init_vars(s);
                var n = o;
                var t = s;
                if (i instanceof pn) o = i;
                s = i;
                e();
                s = t;
                o = n;
            }
            function a(e, n) {
                if (e === n) return;
                i.mark_enclosed(u);
                var t = n.find_variable(i.name);
                if (i.thedef === t) return;
                i.thedef = t;
                t.orig.push(i);
                i.mark_enclosed(u);
            }
        });
        c.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        c.walk(l);
        c.globals = new Ye();
        var p = [];
        var l = new Bt(function(e) {
            if (e instanceof In) {
                if (!(e.argname instanceof ut)) return;
                p.push(e);
                e.argname.walk(l);
                p.pop();
                en(e, l);
                return true;
            }
            if (e instanceof vn) {
                p.push(e);
                e.argnames.forEach(function(e) {
                    e.walk(l);
                });
                if (e.rest) e.rest.walk(l);
                p.pop();
                gn(e, l);
                return true;
            }
            if (e instanceof zn) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof bt) {
                if (e instanceof Tt) {
                    var n = e.definition().redefined();
                    if (n) for (var t = e.scope; t; t = t.parent_scope) {
                        Pe(t.enclosed, n);
                        if (t === n.scope) break;
                    }
                } else if (e instanceof yt) {
                    var i = e.definition().redefined();
                    if (i) i.const_redefs = true;
                }
                if (e.name != "arguments") return true;
                var r = e instanceof xt && l.parent();
                if (r instanceof Vn && !r.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && d(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof Dt) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = p.length; s > 0 && a; ) {
                    s = p.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof Tt || f instanceof kt || f instanceof St) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = c.def_global(e);
                } else if (o == "arguments" && d(a)) {
                    var r = l.parent();
                    if (Qt(e, r)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(r instanceof Kn && r.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var r = l.parent();
                    if (r.TYPE == "Call" && r.expression === e) {
                        var t = e.scope;
                        do {
                            t = t.resolve();
                            if (t.uses_eval) break;
                            t.uses_eval = true;
                        } while (t = t.parent_scope);
                    } else if (a.undeclared) {
                        c.uses_eval = true;
                    }
                }
                e.thedef = a;
                e.reference(u);
                return true;
            }
        });
        c.walk(l);
        if (u.ie8) c.walk(new Bt(function(e) {
            if (e instanceof Tt) {
                var n = e.thedef.defun;
                if (n.name instanceof St && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                i(e, n);
                return true;
            }
            if (e instanceof St) {
                var t = e.thedef;
                if (!i(e, e.scope.parent_scope.resolve())) {
                    delete t.defun;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function d(e) {
            return e.orig[0] instanceof kt && !(e.orig[1] instanceof kt || e.orig[2] instanceof kt) && !mn(e.scope);
        }
        function i(e, n) {
            var t = e.name;
            var i = e.thedef;
            if (!Be(i.orig, function(e) {
                return !(e instanceof yt || e instanceof wt);
            })) return false;
            var r = n.find_variable(t);
            if (r) {
                var a = r.redefined();
                if (a) r = a;
            } else {
                r = c.globals.get(t);
            }
            if (r) {
                r.orig.push(e);
            } else {
                r = n.def_variable(e);
            }
            i.defun = r.scope;
            i.forEach(function(e) {
                e.redef = i;
                e.thedef = r;
                e.reference(u);
            });
            if (r.undeclared) c.variables.set(t, r);
            return true;
        }
    });
    dn.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var i = this.make_def(e);
            i.undeclared = true;
            i.global = true;
            n.set(t, i);
            return i;
        }
    });
    function d(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new Ye();
        e.variables = new Ye();
        if (n) e.make_def = n.make_def;
    }
    function _(e, n) {
        d(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    Ze.DEFMETHOD("init_vars", function(e) {
        d(this, e);
    });
    pn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    bn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    wn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
    });
    vn.DEFMETHOD("init_vars", function(e) {
        _(this, e);
        this.uses_arguments = false;
        this.def_variable(new kt({
            name: "arguments",
            start: this.start,
            end: this.end
        }));
        return this;
    });
    gt.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Pe(t.enclosed, n);
            if (e.keep_fnames) {
                t.functions.each(function(e) {
                    Pe(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    gt.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    Ze.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    Ze.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || En(t.init)) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    Ze.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (_n(t.init)) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function g(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = Object.create(null);
            var i = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t[e.name] = true;
                if (e.global && i && i.has(e.name)) {
                    t[i.get(e.name)] = true;
                }
            });
        }
        return t;
    }
    function b(e, i) {
        var n = e.scope;
        var t = g(n, i);
        var r = n.cname_holes;
        var a = Object.create(null);
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (o.indexOf(n) < 0) {
                    for (var t in g(n, i)) {
                        a[t] = true;
                    }
                    o.push(n);
                } else break;
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < r.length; f++) {
            s = w(r[f]);
            if (a[s]) continue;
            r.splice(f, 1);
            t[s] = true;
            return s;
        }
        while (true) {
            s = w(++n.cname);
            if (t[s] || A[s] || i.reserved.has[s]) continue;
            if (!a[s]) break;
            r.push(n.cname);
        }
        t[s] = true;
        return s;
    }
    gt.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    de.DEFMETHOD("unmangleable", je);
    gt.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function y(e) {
        e = pe(e, {
            eval: false,
            ie8: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Pe(e.reserved, "arguments");
        e.reserved.has = Ue(e.reserved);
        return e;
    }
    dn.DEFMETHOD("mangle_names", function(a) {
        a = y(a);
        var o = -1;
        if (a.cache && a.cache.props) {
            var n = g(this, a);
            a.cache.props.each(function(e) {
                n[e] = true;
            });
        }
        var s = [];
        var f = new Bt(function(n, e) {
            if (n instanceof rn) {
                var t = o;
                e();
                if (!a.v8 || !l(f)) o = t;
                return true;
            }
            if (n instanceof Ze) {
                if (a.webkit && n instanceof an && n.init instanceof Yn) {
                    n.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof wt)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var i = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(i);
                            n.redefined = function() {
                                return i;
                            };
                        });
                    }, true);
                }
                n.to_mangle = [];
                n.variables.each(function(e) {
                    if (!c(e)) n.to_mangle.push(e);
                });
                e();
                if (a.cache && n instanceof dn) {
                    n.globals.each(u);
                }
                if (n instanceof Tn && f.has_directive("use asm")) {
                    var i = new Dt(n.name);
                    i.scope = n;
                    i.reference(a);
                }
                n.to_mangle.forEach(u);
                return true;
            }
            if (n instanceof de) {
                var r;
                do {
                    r = w(++o);
                } while (A[r]);
                n.mangled_name = r;
                return true;
            }
        });
        this.walk(f);
        s.forEach(u);
        function u(e) {
            if (a.reserved.has[e.name]) return;
            e.mangle(a);
        }
        function c(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof yt)) return false;
                var i = n.scope.resolve();
                if (n.scope === i) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = i.def_variable(e);
                i.to_mangle.push(t);
            }
            s.push(n);
            n.references.forEach(r);
            if (e instanceof Tt || e instanceof yt) r(e);
            return true;
            function r(e) {
                e.thedef = t;
                e.reference(a);
                e.thedef = n;
            }
        }
        function l(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof nn) return t instanceof dn && !a.toplevel;
                if (t instanceof rn) return true;
            }
        }
    });
    dn.DEFMETHOD("find_colliding_names", function(t) {
        var i = t.cache && t.cache.props;
        var n = Object.create(A);
        t.reserved.forEach(r);
        this.globals.each(a);
        this.walk(new Bt(function(e) {
            if (e instanceof Ze) e.variables.each(a);
        }));
        return n;
        function r(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && i && i.has(n)) n = i.get(n); else if (!e.unmangleable(t)) return;
            r(n);
        }
    });
    dn.DEFMETHOD("expand_names", function(i) {
        w.reset();
        w.sort();
        i = y(i);
        var n = this.find_colliding_names(i);
        var t = 0;
        this.globals.each(a);
        this.walk(new Bt(function(e) {
            if (e instanceof Ze) e.variables.each(a);
        }));
        function r() {
            var e;
            do {
                e = w(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && i.cache) return;
            if (n.unmangleable(i)) return;
            if (i.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : r();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    We.DEFMETHOD("tail_node", Ce);
    Xn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    dn.DEFMETHOD("compute_char_frequency", function(e) {
        e = y(e);
        w.reset();
        var n = gt.prototype.add_source_map;
        try {
            gt.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) w.consider(this.name, -1);
            };
            if (e.properties) {
                Qn.prototype.add_source_map = function() {
                    w.consider(this.property, -1);
                };
                Zn.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            w.consider(this.print_to_string(), 1);
        } finally {
            gt.prototype.add_source_map = n;
            delete Qn.prototype.add_source_map;
            delete Zn.prototype.add_source_map;
        }
        w.sort();
        function t(e) {
            if (e instanceof zt) {
                w.consider(e.value, -1);
            } else if (e instanceof at) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Xn) {
                t(e.tail_node());
            }
        }
    });
    var w = function() {
        var r = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var i = e[t];
                n.push(i);
                r[i] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var i, a;
        function o() {
            a = Object.create(r);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            i = t.sort(s).concat(n.sort(s));
        };
        f.reset = o;
        o();
        function f(e) {
            var n = "", t = 54;
            e++;
            do {
                e--;
                n += i[e % t];
                e = Math.floor(e / t);
                t = 64;
            } while (e > 0);
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Zt(e, n) {
        if (!(this instanceof Zt)) return new Zt(e, n);
        Yt.call(this, this.before, this.after);
        this.options = pe(e, {
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie8: false,
            if_return: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            negate_iife: !n,
            objects: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && e["top_retain"]),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var i = this.options["global_defs"];
        if (typeof i == "object") for (var r in i) {
            if (/^@/.test(r) && Le(i, r)) {
                i[r.slice(1)] = Xt(i[r], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 3;
        this.drop_fargs = this.options["keep_fargs"] ? je : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var i = t.definition();
            if (i.direct_access) return false;
            var r = i.escaped;
            return r && r.depth != 1;
        };
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                return a !== e.expression.print_to_string();
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                return !ze(e.expression.print_to_string(), a);
            };
        } else {
            this.pure_funcs = qe;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return ze(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    Zt.prototype = new Yt();
    t(Zt.prototype, {
        option: function(e) {
            return this.options[e];
        },
        exposed: function(e) {
            if (e.undeclared) return true;
            if (!(e.global || e.scope.resolve() instanceof dn)) return false;
            var n = this.toplevel;
            return !Be(e.orig, function(e) {
                return n[e instanceof Et ? "funcs" : "vars"];
            });
        },
        compress: function(e) {
            e = e.resolve_defines(this);
            if (this.option("expression")) {
                e.process_expression(true);
            }
            var n = +this.options.passes || 1;
            var t = 1 / 0;
            var i = false;
            var r = {
                ie8: this.option("ie8")
            };
            for (var a = 0; a < n; a++) {
                e.figure_out_scope(r);
                if (a > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
                e = e.transform(this);
                if (n > 1) {
                    var o = 0;
                    e.walk(new Bt(function() {
                        o++;
                    }));
                    We.info("pass {pass}: last_count: {min_count}, count: {count}", {
                        pass: a,
                        min_count: t,
                        count: o
                    });
                    if (o < t) {
                        t = o;
                        i = false;
                    } else if (i) {
                        break;
                    } else {
                        i = true;
                    }
                }
            }
            if (this.option("expression")) {
                e.process_expression(false);
            }
            return e;
        },
        before: function(e, n, t) {
            if (e._squeezed) return e;
            var i = e instanceof pn;
            if (i) {
                e.hoist_properties(this);
                e.hoist_declarations(this);
                e.process_boolean_returns(this);
            }
            n(e, this);
            n(e, this);
            var r = e.optimize(this);
            if (i && r === e && !this.has_directive("use asm") && !r.pinned()) {
                r.merge_variables(this);
                r.drop_unused(this);
                n(r, this);
            }
            if (r === e) r._squeezed = true;
            return r;
        }
    });
    (function(e) {
        e(We, function(e, n) {
            return e;
        });
        We.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        pn.DEFMETHOD("process_expression", function(t, i) {
            var r = this;
            var a = new Yt(function(e) {
                if (t && e instanceof Qe) {
                    return we(An, e, {
                        value: e.body
                    });
                }
                if (!t && e instanceof An) {
                    return i ? i(e) : we(Qe, e, {
                        body: e.value || we(tt, e, {
                            operator: "void",
                            expression: we(Mt, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof vn && e !== r) {
                    return e;
                }
                if (e instanceof nn) {
                    var n = e.body.length - 1;
                    if (n >= 0) {
                        e.body[n] = e.body[n].transform(a);
                    }
                } else if (e instanceof jn) {
                    e.body = e.body.transform(a);
                    if (e.alternative) {
                        e.alternative = e.alternative.transform(a);
                    }
                } else if (e instanceof ln) {
                    e.body = e.body.transform(a);
                }
                return e;
            });
            r.transform(a);
        });
        function T(e, n) {
            var t = n.getProperty();
            if (t instanceof We) return;
            var i;
            if (e instanceof ft) {
                var r = e.elements;
                if (t == "length") return re(r.length, e);
                if (typeof t == "number" && t in r) i = r[t];
            } else if (e instanceof vn) {
                if (t == "length") {
                    e.length_read = true;
                    return re(e.argnames.length, e);
                }
            } else if (e instanceof dt) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!(s instanceof ht)) return;
                    if (!i && a[o].key === t) i = a[o].value;
                }
            }
            return i instanceof Dt && i.fixed_value() || i;
        }
        function l(e, n) {
            if (e instanceof It) return g.Boolean[n];
            if (e instanceof Mt) return g.Number[n];
            if (e instanceof zt) return g.String[n];
            if (n == "valueOf") return false;
            if (e instanceof ft) return g.Array[n];
            if (e instanceof vn) return g.Function[n];
            if (e instanceof dt) return g.Object[n];
            if (e instanceof jt) return g.RegExp[n] && !e.value.global;
        }
        function me(e, n, t, i, r, a, o) {
            var s = n.parent(r);
            if (e.option("unsafe") && s instanceof Qn && l(i, s.property)) {
                return;
            }
            var f = Qt(t, s);
            if (f) return f;
            if (s instanceof ft) return me(e, n, s, s, r + 1);
            if (s instanceof Jn) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!_n(i) || !(s instanceof Gn) && i.contains_this());
            }
            if (s instanceof cn) return s.init === t;
            if (s instanceof ht) {
                if (s.value !== t) return;
                var u = n.parent(r + 1);
                return me(e, n, u, u, r + 2);
            }
            if (s instanceof Kn) {
                if (s.expression !== t) return;
                var c = T(i, s);
                return (!a || o) && me(e, n, s, c, r + 1);
            }
        }
        function _e(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function ge(e) {
            return e.orig[0] instanceof kt || e.orig[1] instanceof kt;
        }
        function W(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof pn) return true;
            } while (n = n.parent_scope);
        }
        function be(e, n) {
            var t = e.definition();
            if (e.in_arg && ge(t)) return false;
            return Be(t.orig, function(e) {
                return !(e instanceof yt || e instanceof wt || n && e instanceof St);
            });
        }
        var D = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(We, Fe);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_fn = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(_n(t.init) && t.init !== t.scope) && t.init;
                if (En(t.fixed) && !Be(t.references, function(e) {
                    var n = e.scope.resolve();
                    do {
                        if (t.scope === n) return true;
                    } while (_n(n) && (n = n.parent_scope.resolve()));
                })) {
                    e.defun_ids[t.id] = false;
                }
                t.recursive_refs = 0;
                t.references = [];
                t.should_replace = undefined;
                t.single_use = undefined;
            }
            function c(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                    if (e.fixed === null) {
                        e.safe_ids = n.safe_ids;
                        v(n, e);
                    } else if (e.fixed) {
                        n.loop_ids[e.id] = n.in_loop;
                        v(n, e);
                    }
                });
                e.may_call_this = function() {
                    e.may_call_this = Fe;
                    if (!e.contains_this()) return;
                    e.functions.each(function(e) {
                        if (En(e.init) && !(e.id in n.defun_ids)) {
                            n.defun_ids[e.id] = false;
                        }
                    });
                };
                if (e.uses_arguments) e.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (t.option("ie8")) e.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function u(n, t) {
                if (t.id in n.defun_ids) {
                    var e = n.defun_ids[t.id];
                    if (!e) return;
                    var i = n.defun_visited[t.id];
                    if (e === n.safe_ids) {
                        if (!i) return t.fixed;
                    } else if (i) {
                        t.init.enclosed.forEach(function(e) {
                            if (t.init.variables.get(e.name) === e) return;
                            if (!m(n, e)) e.fixed = false;
                        });
                    } else {
                        n.defun_ids[t.id] = false;
                    }
                } else {
                    if (!n.in_loop) {
                        n.defun_ids[t.id] = n.safe_ids;
                        return t.fixed;
                    }
                    n.defun_ids[t.id] = false;
                }
            }
            function l(n, e) {
                e.functions.each(function(e) {
                    if (En(e.init) && !n.defun_visited[e.id]) {
                        n.defun_ids[e.id] = n.safe_ids;
                        e.init.walk(n);
                    }
                });
            }
            function p(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function d(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function v(e, n) {
                e.safe_ids[n.id] = {};
            }
            function h(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function m(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    if (!Le(e.safe_ids, n.id)) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if (_e(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = we(Nt, n.orig[0]);
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return En(n.fixed);
            }
            function _(e, n, t) {
                if (!(t || Be(n.orig, function(e) {
                    return !(e instanceof yt);
                }))) return false;
                if (n.fixed === undefined) return t || Be(n.orig, function(e) {
                    return !(e instanceof wt);
                });
                if (n.fixed === null && n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    delete n.safe_ids;
                    return true;
                }
                if (n.fixed === false) return false;
                var i = e.safe_ids[n.id];
                if (!Le(e.safe_ids, n.id)) {
                    if (!i) return false;
                    if (i.read && n.scope !== e.find_parent(pn)) return false;
                    i.assign = i.assign && i.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && i.read) {
                    if (i.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return m(e, n) && Be(n.orig, function(e) {
                    return !(e instanceof St);
                });
            }
            function g(e, n) {
                var t = we(Dt, e, e);
                t.fixed = n || we(Nt, e);
                return t;
            }
            function b(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(ge(n) && n.scope.uses_arguments);
            }
            function y(e) {
                if (!e) return false;
                return e.is_constant() || e instanceof vn || e instanceof Ot;
            }
            function w(e, n, t) {
                if (t instanceof ot) return t.operator == "=" && t.right === n;
                if (t instanceof Jn) return t.expression !== n || t instanceof Gn;
                if (t instanceof On) return t.value === n && n.scope !== e.scope;
                if (t instanceof Vn) return t.value === n;
            }
            function x(e, n) {
                if (n instanceof ft) return true;
                if (n instanceof rt) return Se[n.operator];
                if (n instanceof at) return n.condition !== e;
                if (n instanceof Xn) return n.tail_node() === e;
            }
            function k(e, n, t, i, r, a, o) {
                var s = e.parent(a);
                if (r && r.is_constant()) return;
                if (w(n, i, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(r && r.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    return;
                } else if (x(i, s)) {
                    k(e, n, t, s, s, a + 1, o);
                } else if (s instanceof ht && s.value === i) {
                    var f = e.parent(a + 1);
                    k(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Kn && s.expression === i) {
                    r = T(r, s);
                    k(e, n, t, s, r, a + 1, o + 1);
                    if (r) return;
                }
                if (a > 0) return;
                if (s instanceof Jn && s.expression === i) return;
                if (s instanceof Xn && s.tail_node() !== i) return;
                if (s instanceof Qe) return;
                if (s instanceof nt && !Kt[s.operator]) return;
                n.direct_access = true;
            }
            function E(e) {
                if (!(e instanceof Zn)) return;
                var n = e.expression;
                if (!(n instanceof Dt)) return;
                var t = n.definition();
                if (!_e(t)) return;
                var i = e.property;
                if (i.is_constant()) i = i.value;
                if (!(i instanceof We) && !D.test(i)) return;
                t.reassigned = true;
                (i instanceof We ? t.scope.argnames : [ t.scope.argnames[i] ]).forEach(function(e) {
                    if (e instanceof kt) e.definition().fixed = false;
                });
            }
            function S(a, e, n, o, t) {
                var s = new Bt(function(i) {
                    if (i instanceof Wn) {
                        f(i);
                        p(a);
                        i.value.walk(a);
                        d(a);
                        var r = o;
                        if (r) o = function() {
                            var e = r();
                            return Ee(e) ? ie(i, [ e, i.value ]) : i;
                        };
                        i.name.walk(s);
                        o = r;
                        return true;
                    }
                    if (i instanceof ct) {
                        f(i);
                        var r = o;
                        i.elements.forEach(function(e, n) {
                            if (e instanceof Ht) return f(e);
                            if (r) o = function() {
                                return we(Zn, e, {
                                    expression: r(),
                                    property: we(Mt, e, {
                                        value: n
                                    })
                                });
                            };
                            e.walk(s);
                        });
                        if (i.rest) {
                            if (r) o = e.option("rests") && function() {
                                var e = r();
                                return e instanceof ft ? we(ft, i, {
                                    elements: e.elements.slice(i.elements.length)
                                }) : i;
                            };
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    if (i instanceof pt) {
                        f(i);
                        var r = o;
                        i.properties.forEach(function(t) {
                            f(t);
                            if (t.key instanceof We) {
                                p(a);
                                t.key.walk(a);
                                d(a);
                            }
                            if (r) o = function() {
                                var e = t.key;
                                var n = Zn;
                                if (typeof e == "string") {
                                    if (Lt(e)) {
                                        n = Qn;
                                    } else {
                                        e = re(e, t);
                                    }
                                }
                                return we(n, t, {
                                    expression: r(),
                                    property: e
                                });
                            };
                            t.value.walk(s);
                        });
                        if (i.rest) {
                            o = false;
                            i.rest.walk(s);
                        }
                        o = r;
                        return true;
                    }
                    t(i, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        i.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                n.walk(s);
            }
            function n(e, n, t) {
                var i = this.name.definition().id;
                if (e.defun_visited[i]) return true;
                if (e.defun_ids[i] !== e.safe_ids) return true;
                e.defun_visited[i] = true;
                this.inlined = false;
                p(e);
                c(e, t, this);
                n();
                d(e);
                l(e, this);
                return true;
            }
            function o(i, e, r) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var n = yn(a);
                var t = false;
                a.walk(new Bt(function(e) {
                    if (n) return t = true;
                    if (e instanceof An) return n = true;
                    if (e instanceof pn && e !== a) return true;
                }));
                if (t) p(i);
                c(i, r, a);
                var s = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(n, e) {
                    var t = o.args[e];
                    S(i, r, n, function() {
                        var e = a.argnames.indexOf(n);
                        return (e < 0 ? t : o.args[e]) || we(Nt, o);
                    }, u);
                });
                if (a.rest) S(i, r, a.rest, r.option("rests") && function() {
                    return we(ft, a, {
                        elements: o.args.slice(a.argnames.length)
                    });
                }, u);
                gn(a, i);
                var f = i.safe_ids;
                d(i);
                l(i, a);
                if (!t) i.safe_ids = f;
                return true;
                function u(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        v(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(ot, function(r, e, a) {
                var o = this;
                var s = o.left;
                if (o.operator == "=" && s.equivalent_to(o.right) && !s.has_side_effects(a)) {
                    o.right.walk(r);
                    f(s);
                    o.__drop = true;
                } else if (!(s instanceof ut || s instanceof Dt)) {
                    E(s);
                    return;
                } else if (o.operator == "=") {
                    o.right.walk(r);
                    S(r, a, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof Dt)) {
                            E(e);
                            t();
                            return;
                        }
                        var i = e.definition();
                        i.assignments++;
                        if (n && !me(a, r, o, o.right, 0) && !e.in_arg && _(r, i)) {
                            h(i, e);
                            v(r, i);
                            if (i.single_use && s instanceof ut) i.single_use = false;
                            r.loop_ids[i.id] = r.in_loop;
                            k(r, i, e.scope, o, o.right, 0, 1);
                            e.fixed = i.fixed = n;
                            e.fixed.assigns = [ o ];
                        } else {
                            t();
                            i.fixed = false;
                        }
                    });
                } else {
                    var n = s.definition();
                    n.assignments++;
                    var t = n.fixed;
                    if (me(a, r, o, o, 0)) {
                        n.fixed = false;
                        return;
                    }
                    var i = m(r, n);
                    o.right.walk(r);
                    if (i && !s.in_arg && _(r, n)) {
                        h(n, s);
                        v(r, n);
                        if (n.single_use) n.single_use = false;
                        s.fixed = n.fixed = function() {
                            return we(rt, o, {
                                operator: o.operator.slice(0, -1),
                                left: g(s, t),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !t || !t.assigns ? [] : t.assigns.slice();
                        s.fixed.assigns.push(o);
                    } else {
                        s.walk(r);
                        n.fixed = false;
                    }
                }
                return true;
                function f(e) {
                    if (e instanceof Qn) {
                        f(e.expression);
                    } else if (e instanceof Zn) {
                        f(e.expression);
                        e.property.walk(r);
                    } else if (e instanceof Dt) {
                        var n = e.definition();
                        h(n, e);
                        e.fixed = n.fixed;
                    } else {
                        e.walk(r);
                    }
                }
            });
            e(Sn, n);
            e(rt, function(e) {
                if (!Se[this.operator]) return;
                this.left.walk(e);
                p(e);
                this.right.walk(e);
                d(e);
                return true;
            });
            e(Ze, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
            });
            e(Jn, function(n, e) {
                n.find_parent(pn).may_call_this();
                var t = this.expression;
                if (_n(t)) {
                    var i = !t.name;
                    this.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof et) i = false;
                    });
                    if (i) t.reduce_vars = o;
                    t.walk(n);
                    if (i) delete t.reduce_vars;
                    return true;
                } else if (t instanceof Dt) {
                    var r = t.definition();
                    if (this.TYPE == "Call" && n.in_boolean_context()) r.bool_fn++;
                    if (!En(r.fixed)) return;
                    var a = u(n, r);
                    if (!a) return;
                    e();
                    a.walk(n);
                    return true;
                } else if (this.TYPE == "Call" && t instanceof ot && t.operator == "=" && t.left instanceof Dt && n.in_boolean_context()) {
                    t.left.definition().bool_fn++;
                }
            });
            e(at, function(e) {
                this.condition.walk(e);
                p(e);
                this.consequent.walk(e);
                d(e);
                p(e);
                this.alternative.walk(e);
                d(e);
                return true;
            });
            e(Wn, function(e) {
                this.name.walk(e);
                p(e);
                this.value.walk(e);
                d(e);
                return true;
            });
            e(Tn, n);
            e(sn, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                p(e);
                this.body.walk(e);
                if (C(this, e.parent())) {
                    d(e);
                    p(e);
                }
                this.condition.walk(e);
                d(e);
                e.in_loop = n;
                return true;
            });
            e(un, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                if (this.init) this.init.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                if (this.condition) this.condition.walk(n);
                this.body.walk(n);
                if (this.step) {
                    if (C(this, n.parent())) {
                        d(n);
                        p(n);
                    }
                    this.step.walk(n);
                }
                d(n);
                n.in_loop = i;
                return true;
            });
            e(cn, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                this.object.walk(n);
                var i = n.in_loop;
                n.in_loop = this;
                p(n);
                var r = this.init;
                if (r instanceof Un) {
                    r.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof bt) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, n);
                } else if (r instanceof ut || r instanceof Dt) {
                    r.mark_symbol(function(e) {
                        if (e instanceof Dt) {
                            var n = e.definition();
                            h(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, n);
                } else {
                    r.walk(n);
                }
                this.body.walk(n);
                d(n);
                n.in_loop = i;
                return true;
            });
            e(jn, function(e) {
                this.condition.walk(e);
                p(e);
                this.body.walk(e);
                d(e);
                if (this.alternative) {
                    p(e);
                    this.alternative.walk(e);
                    d(e);
                }
                return true;
            });
            e(rn, function(e) {
                p(e);
                this.body.walk(e);
                d(e);
                return true;
            });
            e(vn, function(e, n, t) {
                var i = this;
                i.inlined = false;
                p(e);
                c(e, t, i);
                n();
                d(e);
                if (i.name) k(e, i.name.definition(), i, i.name, i, 0, 1);
                l(e, i);
                return true;
            });
            e(qn, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                this.expression.walk(n);
                var i = true;
                this.body.forEach(function(e) {
                    if (e instanceof Nn) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        p(n);
                    }
                });
                if (!i) d(n);
                en(this, n);
                return true;
            });
            e(Cn, function(e) {
                p(e);
                en(this, e);
                d(e);
                return true;
            });
            e(Tt, function() {
                this.definition().fixed = false;
            });
            e(Dt, function(e, n, t) {
                var i = this.definition();
                h(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof Et) {
                    e.loop_ids[i.id] = e.in_loop;
                }
                if (i.fixed === false) {
                    var r = i.redefined();
                    if (r && W(i.scope, this.scope)) r.single_use = false;
                } else if (i.fixed === undefined || !m(e, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof St) this.fixed = i.scope;
                    var a = this.fixed_value();
                    var o = Oe(e, i);
                    if (o) {
                        i.recursive_refs++;
                    } else if (a && b(t, i)) {
                        i.in_loop = e.loop_ids[i.id] !== e.in_loop;
                        i.single_use = a instanceof vn && !a.pinned() && (!i.in_loop || e.parent() instanceof Jn) || !i.in_loop && i.scope === this.scope.resolve() && a.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (me(t, e, this, a, 0, y(a), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = false;
                        }
                    }
                    if (i.fixed && e.loop_ids[i.id] !== e.in_loop) {
                        i.cross_loop = true;
                    }
                    k(e, i, this.scope, this, a, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (En(i.fixed) && !((s = e.parent()) instanceof Jn && s.expression === this)) {
                    var f = u(e, i);
                    if (f) f.walk(e);
                }
            });
            e(dn, function(n, e, t) {
                this.globals.each(function(e) {
                    a(n, t, e);
                });
                p(n);
                c(n, t, this);
                e();
                d(n);
                l(n, this);
                return true;
            });
            e(Pn, function(n, e, t) {
                this.variables.each(function(e) {
                    a(n, t, e);
                });
                p(n);
                en(this, n);
                d(n);
                if (this.bcatch) {
                    p(n);
                    this.bcatch.walk(n);
                    d(n);
                }
                if (this.bfinally) this.bfinally.walk(n);
                return true;
            });
            e(nt, function(e, n) {
                var t = this;
                if (!Jt[t.operator]) return;
                var i = t.expression;
                if (!(i instanceof Dt)) {
                    E(i);
                    return;
                }
                var r = i.definition();
                r.assignments++;
                var a = r.fixed;
                if (m(e, r) && !i.in_arg && _(e, r)) {
                    h(r, i);
                    v(e, r);
                    if (r.single_use) r.single_use = false;
                    r.fixed = function() {
                        return we(rt, t, {
                            operator: t.operator.slice(0, -1),
                            left: we(tt, t, {
                                operator: "+",
                                expression: g(i, a)
                            }),
                            right: we(Mt, t, {
                                value: 1
                            })
                        });
                    };
                    r.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    r.fixed.assigns.push(t);
                    if (t instanceof tt) {
                        i.fixed = r.fixed;
                    } else {
                        i.fixed = function() {
                            return we(tt, t, {
                                operator: "+",
                                expression: g(i, a)
                            });
                        };
                        i.fixed.assigns = a && a.assigns;
                    }
                } else {
                    i.walk(e);
                    r.fixed = false;
                }
                return true;
            });
            e(Vn, function(i, e, n) {
                var r = this;
                if (!r.value) return;
                r.value.walk(i);
                S(i, n, r.name, function() {
                    return r.value;
                }, function(e, n) {
                    var t = e.definition();
                    if (n && _(i, t, true)) {
                        v(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ r ];
                        if (e instanceof yt && t.redefined() || !(be(e) || G(t))) {
                            t.single_use = false;
                        }
                    } else {
                        t.fixed = false;
                    }
                });
                return true;
            });
            e(fn, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                p(e);
                n();
                d(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function f(e) {
            e._squeezed = false;
            e._optimized = false;
            delete e.fixed;
            if (e instanceof pn) delete e._var_names;
        }
        dn.DEFMETHOD("reset_opt_flags", function(t) {
            var i = new Bt(t.option("reduce_vars") ? function(e, n) {
                f(e);
                return e.reduce_vars(i, n, t);
            } : f);
            i.defun_ids = Object.create(null);
            i.defun_visited = Object.create(null);
            i.in_loop = null;
            i.loop_ids = Object.create(null);
            i.safe_ids = Object.create(null);
            this.walk(i);
        });
        gt.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (!e) return e;
            if (this.fixed) e = this.fixed;
            return e instanceof We ? e : e();
        });
        Dt.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            return e.orig.length == 1 && e.orig[0] instanceof St;
        });
        We.DEFMETHOD("convert_symbol", Fe);
        function n(t, i) {
            return this.transform(new Yt(function(e, n) {
                if (e instanceof Wn) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof ut) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof lt) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, i);
            }));
        }
        Wn.DEFMETHOD("convert_symbol", n);
        ut.DEFMETHOD("convert_symbol", n);
        function t(e, n) {
            var t = we(e, this, this);
            n(t, this);
            return t;
        }
        bt.DEFMETHOD("convert_symbol", t);
        Dt.DEFMETHOD("convert_symbol", t);
        function i(n, t) {
            var i = new Bt(function(e) {
                if (e instanceof Wn) {
                    e.value.walk(t);
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof lt) {
                    if (e.key instanceof We) e.key.walk(t);
                    e.value.walk(i);
                    return true;
                }
                return n(e);
            });
            this.walk(i);
        }
        Wn.DEFMETHOD("mark_symbol", i);
        ut.DEFMETHOD("mark_symbol", i);
        function r(e) {
            return e(this);
        }
        bt.DEFMETHOD("mark_symbol", r);
        Dt.DEFMETHOD("mark_symbol", r);
        We.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        ut.DEFMETHOD("match_symbol", function(n, t) {
            var i = false;
            var r = new Bt(function(e) {
                if (i) return true;
                if (e instanceof Wn) {
                    if (!t) return i = true;
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof lt) {
                    if (!t && e.key instanceof We) return i = true;
                    e.value.walk(r);
                    return true;
                }
                if (n(e)) return i = true;
            });
            this.walk(r);
            return i;
        });
        function te(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        function ye(e, n) {
            if (e instanceof Ot) return true;
            if (e instanceof Dt) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && ue[t.name];
            }
            if (e instanceof Kn) {
                e = e.expression;
                if (e instanceof Dt) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.is_constant()) return true;
                return ye(e, n);
            }
            return false;
        }
        function we(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function ie(e, n) {
            if (n.length == 1) return n[0];
            return we(Xn, e, {
                expressions: n.reduce(m, [])
            });
        }
        function re(e, n) {
            switch (typeof e) {
              case "string":
                return we(zt, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return we(Ct, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? we(tt, n, {
                        operator: "-",
                        expression: we(Mt, n, {
                            value: -e
                        })
                    }) : we(Mt, n, {
                        value: e
                    });
                }
                return e < 0 ? we(tt, n, {
                    operator: "-",
                    expression: we(Pt, n)
                }) : we(Pt, n);

              case "boolean":
                return we(e ? Ut : Rt, n);

              case "undefined":
                return we(Nt, n);

              default:
                if (e === null) {
                    return we(qt, n, {
                        value: null
                    });
                }
                if (e instanceof RegExp) {
                    return we(jt, n, {
                        value: e
                    });
                }
                throw new Error(Ie("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function ae(e, n) {
            return n instanceof Kn || fe(n) && n.name == "eval";
        }
        function xe(e, n, t, i) {
            var r = false;
            if (n.TYPE == "Call") {
                r = n.expression === t && ae(e, i);
            } else if (n instanceof tt) {
                r = n.operator == "delete" || n.operator == "typeof" && fe(i);
            }
            return r ? ie(t, [ we(Mt, t, {
                value: 0
            }), i ]) : i;
        }
        function m(e, n) {
            if (n instanceof Xn) {
                e.push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function A(e) {
            if (e === null) return [];
            if (e instanceof tn) return Be(e.body, function(e) {
                return !(e instanceof Bn || e instanceof Yn);
            }) ? e.body : [ e ];
            if (e instanceof Ke) return [];
            if (e instanceof Je) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function oe(e) {
            if (e === null) return true;
            if (e instanceof Ke) return true;
            if (e instanceof tn) return e.body.length == 0;
            return false;
        }
        function x(e) {
            return Be(e.body, function(e) {
                return oe(e) || e instanceof Tn || e instanceof Ln && Be(e.definitions, function(e) {
                    return !e.value;
                });
            });
        }
        function $(e) {
            if (e instanceof an) {
                return e.body instanceof tn ? e.body : e;
            }
            return e;
        }
        function ke(e) {
            while (e instanceof Kn) e = e.expression;
            return e;
        }
        function se(e) {
            if (e.TYPE != "Call") return false;
            var n = e.expression;
            return n instanceof xn || n instanceof kn || se(n);
        }
        function fe(e) {
            return e instanceof Dt && e.definition().undeclared;
        }
        var a = Ue("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Math Number parseFloat parseInt RangeError ReferenceError RegExp Object setInterval setTimeout String SyntaxError TypeError unescape URIError");
        Dt.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && a[this.name];
        });
        var ue = Ue("Infinity NaN undefined");
        function o(e) {
            return e instanceof Pt || e instanceof Ct || e instanceof Nt;
        }
        function _(e) {
            return Be(e.definitions, function(e) {
                return !e.value;
            });
        }
        function z(e) {
            return e instanceof Tn || e instanceof Ln && _(e);
        }
        function u(e, f) {
            var pe, de, ve;
            t();
            var he, n = 10;
            do {
                he = false;
                r(e);
                if (f.option("dead_code")) {
                    o(e, f);
                }
                if (f.option("if_return")) {
                    a(e, f);
                }
                if (f.sequences_limit > 0) {
                    s(e, f);
                    u(e, f);
                }
                if (f.option("join_vars")) {
                    h(e);
                }
                if (f.option("collapse_vars")) {
                    i(e, f);
                }
            } while (he && n-- > 0);
            return e;
            function t() {
                var e = f.self(), n = 0;
                do {
                    if (e instanceof In) {
                        if (!f.parent(n).bfinally) n++;
                    } else if (e instanceof Rn) {
                        n++;
                    } else if (e instanceof an) {
                        pe = true;
                    } else if (e instanceof pn) {
                        ve = e;
                        break;
                    } else if (e instanceof Pn) {
                        if (!de) de = e;
                    }
                } while (e = f.parent(n++));
            }
            function i(o, p) {
                if (ve.pinned()) return o;
                var d;
                var a = Object.create(null);
                var v = [];
                var s = Object.create(null);
                var t;
                var f = o.length;
                var l = new Yt(function(e, n) {
                    if (M) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        if (c < u.length) return P(e, l);
                        z = true;
                        _ = (m ? J : W)(e, 0);
                        if (_ === e) M = true;
                        return e;
                    }
                    var t = l.parent();
                    if (R(e, t)) {
                        M = true;
                        return e;
                    }
                    if (!g && U(e, t)) {
                        g = t;
                    }
                    if (e.single_use && t instanceof Vn && t.value === e) return e;
                    var i;
                    if (!(e instanceof bt) && (w && b.equivalent_to(e) || x && (i = x(e, this)))) {
                        if (!q || g && (i || !D || !$)) {
                            if (!i && !m) M = true;
                            return e;
                        }
                        if (Qt(e, t)) {
                            if (m && !i) {
                                j = true;
                                F++;
                            }
                            return e;
                        } else if (m) {
                            if (!i) F++;
                            return e;
                        } else {
                            F++;
                        }
                        he = M = true;
                        We.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (h.TYPE == "Binary") return we(ot, h, {
                            operator: "=",
                            left: h.right.left,
                            right: we(at, h, {
                                condition: h.operator == "&&" ? h.left : h.left.negate(p),
                                consequent: h.right.right,
                                alternative: e
                            })
                        });
                        if (h instanceof it) {
                            if (b instanceof Dt) b.definition().fixed = false;
                            return we(tt, h, h);
                        }
                        if (h instanceof Vn) {
                            var r = h.name.definition();
                            if (r.references.length - r.replaced == 1 && !p.exposed(r)) {
                                r.replaced++;
                                return xe(p, t, e, h.value);
                            }
                            return we(ot, h, {
                                operator: "=",
                                left: we(Dt, h.name, h.name),
                                right: h.value
                            });
                        }
                        h.write_only = false;
                        return h;
                    }
                    if (B(e, t) || k(e)) {
                        _ = e;
                        if (e instanceof pn) M = true;
                    }
                    if (e instanceof hn) {
                        var a = q;
                        q = false;
                        n(e, l);
                        q = a;
                        return H(e);
                    }
                    if (e instanceof ut) {
                        var a = q;
                        q = false;
                        n(e, l);
                        q = a;
                        return H(e);
                    }
                    if (e instanceof Wn) {
                        e.name = e.name.transform(l);
                        var a = q;
                        q = false;
                        e.value = e.value.transform(l);
                        q = a;
                        return H(e);
                    }
                    return P(e, l);
                }, H);
                var i = new Yt(function(e) {
                    if (M) return e;
                    if (!z) {
                        if (e !== u[c]) return e;
                        c++;
                        switch (u.length - c) {
                          case 0:
                            z = true;
                            if (j) return e;
                            if (e instanceof Vn) return e;
                            C.replaced++;
                            var n = i.parent();
                            if (n instanceof Xn && n.tail_node() !== e) {
                                m.replaced++;
                                return He.skip;
                            }
                            return O;

                          case 1:
                            if (!j && e.body === h) {
                                z = true;
                                C.replaced++;
                                m.replaced++;
                                return null;
                            }

                          default:
                            return;
                        }
                    }
                    if (e instanceof Dt && e.name == C.name) {
                        if (!--F) M = true;
                        if (Qt(e, i.parent())) return e;
                        C.replaced++;
                        var t = O.clone();
                        m.references.push(t);
                        return t;
                    }
                    if (e instanceof Nn || e instanceof pn) return e;
                }, ae);
                while (--f >= 0) {
                    if (f == 0 && p.option("unused")) L();
                    var u = [];
                    V(o[f]);
                    while (v.length > 0) {
                        u = v.pop();
                        var c = 0;
                        var h = u[u.length - 1];
                        var m = null;
                        var _ = null;
                        var g = null;
                        var b = K(h);
                        var y = b && b.has_side_effects(p);
                        var w = b && !y && !ye(b, p);
                        var x = ee(h);
                        if (!w && !x) continue;
                        var r = h.name instanceof kt;
                        var k = je;
                        if (h.may_throw(p)) {
                            if (r && yn(ve)) continue;
                            k = de ? function(e) {
                                return e.has_side_effects(p);
                            } : le;
                        }
                        var E = false;
                        var S = false;
                        var T = ie(h);
                        var D = oe(b);
                        var O = Q(h);
                        if (!y) y = se();
                        var A = de || !D ? function(e) {
                            return e instanceof ut;
                        } : je;
                        var $ = fe(h);
                        var z = r;
                        var M = false;
                        var F = 0;
                        var j = false;
                        var q = !d || !z;
                        if (!q) {
                            for (var e = h.arg_index + 1; !M && e < d.length; e++) {
                                if (d[e]) d[e].transform(l);
                            }
                            q = true;
                        }
                        for (var n = f; !M && n < o.length; n++) {
                            o[n].transform(l);
                        }
                        if (m) {
                            var C = b.definition();
                            var N = C.references.length - C.replaced;
                            if (h instanceof ot) N--;
                            if (F && N == F) {
                                M = false;
                            } else {
                                v.push(u);
                                t = true;
                                continue;
                            }
                            if (F) {
                                c = 0;
                                z = r;
                                for (var n = f; !M && n < o.length; n++) {
                                    if (!o[n].transform(i)) o.splice(n--, 1);
                                }
                                if (h instanceof Vn) {
                                    F = !p.exposed(C) && C.references.length == C.replaced;
                                }
                                m.single_use = false;
                            }
                        }
                        if (F && !re(h)) o.splice(f, 1);
                    }
                }
                function H(e) {
                    if (M) return e;
                    if (_ === e) M = true;
                    if (g === e) g = null;
                    return e;
                }
                function P(e, n) {
                    if (!(e instanceof Ze)) return;
                    if (e instanceof pn) return e;
                    if (!(e.variables && e.variables.all(function(e) {
                        return !T.has(e.name);
                    }))) {
                        M = true;
                        return e;
                    }
                    if (e instanceof cn) {
                        e.object = e.object.transform(n);
                        M = true;
                        return e;
                    }
                    if (e instanceof qn) {
                        e.expression = e.expression.transform(n);
                        for (var t = 0; !M && t < e.body.length; t++) {
                            var i = e.body[t];
                            if (i instanceof Hn) {
                                if (!z) {
                                    if (i !== u[c]) continue;
                                    c++;
                                }
                                i.expression = i.expression.transform(n);
                                if (!$) break;
                                x = false;
                            }
                        }
                        M = true;
                        return e;
                    }
                }
                function I(e, n) {
                    if (n instanceof ot) return n.operator == "=" && n.left === e;
                    if (n instanceof Wn) return n.name === e;
                    if (n instanceof ct) return true;
                    if (n instanceof lt) return n.value === e;
                }
                function R(e, n) {
                    if (e === O) return true;
                    if (n instanceof un) return e !== n.init;
                    if (e instanceof ot) {
                        return e.operator != "=" && b.equivalent_to(e.left);
                    }
                    if (e instanceof Jn) {
                        if (!(b instanceof Kn)) return false;
                        if (!b.equivalent_to(e.expression)) return false;
                        return !(_n(O) && !O.contains_this());
                    }
                    if (e instanceof Ge) return true;
                    if (e instanceof Tn) return r && b.name === e.name.name;
                    if (e instanceof lt) return e.key instanceof We;
                    if (e instanceof on) return true;
                    if (e instanceof zn) return true;
                    if (e instanceof Dt) {
                        if (e.is_declared(p)) {
                            if (e.fixed_value()) return false;
                            if (be(e)) {
                                return !(n instanceof Kn && n.expression === e) && _e(e.definition());
                            }
                        } else if (I(e, n)) {
                            return false;
                        }
                        if (!$) return true;
                        x = false;
                        return false;
                    }
                    if (e instanceof Pn) return true;
                    if (e instanceof ln) return true;
                    return false;
                }
                function U(e, n) {
                    if (n instanceof rt) return Se[n.operator] && n.left !== e;
                    if (n instanceof Hn) return n.expression !== e;
                    if (n instanceof at) return n.condition !== e;
                    return n instanceof jn && n.condition !== e;
                }
                function B(e, n) {
                    if (e instanceof st) return true;
                    if (e.TYPE == "Binary") return e.operator == "in" && !De(e.right);
                    if (e instanceof Jn) {
                        var t, i = e.expression;
                        if (i instanceof Dt) {
                            t = i.definition();
                            i = i.fixed_value();
                        }
                        if (!(i instanceof vn)) return true;
                        if (t && Oe(p, t)) return true;
                        if (i.collapse_scanning) return false;
                        i.collapse_scanning = true;
                        var r = q;
                        q = false;
                        var a = _;
                        var o = g;
                        if (!Be(i.argnames, function(e) {
                            if (e instanceof Wn) {
                                e.value.transform(l);
                                if (M) return false;
                                e = e.name;
                            }
                            return !(e instanceof ut);
                        })) {
                            M = true;
                        } else if (mn(i) && i.value) {
                            i.value.transform(l);
                        } else for (var s = 0; !M && s < i.body.length; s++) {
                            var f = i.body[s];
                            if (f instanceof An) {
                                if (f.value) f.value.transform(l);
                                break;
                            }
                            f.transform(l);
                        }
                        g = o;
                        _ = a;
                        q = r;
                        delete i.collapse_scanning;
                        if (!M) return false;
                        M = false;
                        return true;
                    }
                    if (e instanceof On) {
                        if (de) {
                            if (de.bfinally) return true;
                            if (de.bcatch && e instanceof $n) return true;
                        }
                        return y || b instanceof Kn || ce(b);
                    }
                    if (e instanceof kn) {
                        return p.option("ie8") && e.name && T.has(e.name.name);
                    }
                    if (e instanceof Kn) {
                        var u = e.expression;
                        return y || !m && u.may_throw_on_access(p) || u instanceof Dt && _e(u.definition());
                    }
                    if (e instanceof et) return true;
                    if (e instanceof Dt) {
                        if (ue(e, n)) return !I(e, n);
                        if (y && ce(e)) return true;
                        var t = e.definition();
                        return (de || t.scope.resolve() !== ve) && !be(e);
                    }
                    if (e instanceof At) return e.tag && !Ae(p, e.tag);
                    if (e instanceof Ot) return ue(e, n);
                    if (e instanceof Vn) {
                        if (A(e.name)) return true;
                        return (e.value || n instanceof Yn) && e.name.match_symbol(function(e) {
                            return e instanceof bt && (T.has(e.name) || y && ce(e));
                        }, true);
                    }
                    var c = Qt(e.left, e);
                    if (!c) return false;
                    if (c instanceof Kn) return true;
                    if (A(c)) return true;
                    return c.match_symbol(function(e) {
                        return e instanceof Dt && (T.has(e.name) || E && p.exposed(e.definition()));
                    }, true);
                }
                function Y(e, n) {
                    if (!n) return !(e instanceof gt);
                    if (e instanceof Wn) {
                        return n.has_side_effects(p) || e.value.has_side_effects(p) || Y(e.name, Ee(n) && e.value);
                    }
                    if (e instanceof ut) {
                        if (e.rest && Y(e.rest)) return true;
                        if (e instanceof ct) {
                            if (!(n instanceof ft || n.is_string(p))) return true;
                            return !Be(e.elements, function(e) {
                                return !Y(e);
                            });
                        }
                        if (e instanceof pt) {
                            if (!n.is_defined(p)) return true;
                            return !Be(e.properties, function(e) {
                                if (e instanceof We && e.has_side_effects(p)) return false;
                                return !Y(e.value);
                            });
                        }
                    }
                }
                function L() {
                    var e, t = p.self();
                    if (_n(t) && !t.name && !t.uses_arguments && !t.pinned() && (e = p.parent()) instanceof Jn && e.expression === t && Be(e.args, function(e) {
                        return !(e instanceof et);
                    })) {
                        var i = p.has_directive("use strict");
                        if (i && !ze(i, t.body)) i = false;
                        var r = yn(t) ? function(e) {
                            return e instanceof gt && e.name == "await";
                        } : function(e) {
                            return e instanceof st && !a.find_parent(pn);
                        };
                        var a = new Bt(function(e) {
                            if (!u) return true;
                            if (r(e)) {
                                u = null;
                                return true;
                            }
                            if (e instanceof Dt && t.variables.has(e.name)) {
                                var n = e.definition().scope;
                                if (n !== ve) while (n = n.parent_scope) {
                                    if (n === ve) return true;
                                }
                                u = null;
                            }
                            if (e instanceof Ot && (i || !a.find_parent(pn))) {
                                u = null;
                                return true;
                            }
                        });
                        d = e.args.slice();
                        var n = d.length;
                        var o = Object.create(null);
                        for (var s = t.argnames.length; --s >= 0; ) {
                            var f = t.argnames[s];
                            var u = d[s];
                            var c;
                            if (f instanceof Wn) {
                                c = f.value;
                                f = f.name;
                                d[n + s] = c;
                            }
                            if (f instanceof ut) {
                                if (!Y(f, u)) continue;
                                v.length = 0;
                                break;
                            }
                            if (f.name in o) continue;
                            o[f.name] = true;
                            if (c) u = !u || Ee(u) ? c : null;
                            if (!u && !c) {
                                u = we(Nt, f).transform(p);
                            } else if (u instanceof vn && u.pinned()) {
                                u = null;
                            } else if (u) {
                                u.walk(a);
                            }
                            if (!u) continue;
                            var l = we(Vn, f, {
                                name: f,
                                value: u
                            });
                            l.name_index = s;
                            l.arg_index = c ? n + s : s;
                            v.unshift([ l ]);
                        }
                    }
                }
                function V(e, n) {
                    u.push(e);
                    if (e instanceof ft) {
                        e.elements.forEach(function(e) {
                            V(e, n);
                        });
                    } else if (e instanceof ot) {
                        if (!(e.left instanceof ut)) v.push(u.slice());
                        V(e.left);
                        V(e.right);
                        if (e.left instanceof Dt) {
                            a[e.left.name] = (a[e.left.name] || 0) + 1;
                        }
                    } else if (e instanceof st) {
                        V(e.expression, n);
                    } else if (e instanceof rt) {
                        var t = Se[e.operator];
                        if (n && t && e.right instanceof ot && e.right.operator == "=" && !(e.right.left instanceof ut)) {
                            v.push(u.slice());
                        }
                        V(e.left, !t && n);
                        V(e.right, n);
                    } else if (e instanceof Jn) {
                        V(e.expression);
                        e.args.forEach(V);
                    } else if (e instanceof Hn) {
                        V(e.expression);
                    } else if (e instanceof at) {
                        V(e.condition);
                        V(e.consequent, n);
                        V(e.alternative, n);
                    } else if (e instanceof Un) {
                        e.definitions.forEach(V);
                    } else if (e instanceof Qn) {
                        V(e.expression);
                    } else if (e instanceof on) {
                        V(e.condition);
                        if (!(e.body instanceof nn)) {
                            V(e.body);
                        }
                    } else if (e instanceof On) {
                        if (e.value) V(e.value);
                    } else if (e instanceof un) {
                        if (e.init) V(e.init, true);
                        if (e.condition) V(e.condition);
                        if (e.step) V(e.step, true);
                        if (!(e.body instanceof nn)) {
                            V(e.body);
                        }
                    } else if (e instanceof cn) {
                        V(e.object);
                        if (!(e.body instanceof nn)) {
                            V(e.body);
                        }
                    } else if (e instanceof jn) {
                        V(e.condition);
                        if (!(e.body instanceof nn)) {
                            V(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof nn)) {
                            V(e.alternative);
                        }
                    } else if (e instanceof dt) {
                        e.properties.forEach(function(e) {
                            u.push(e);
                            if (e.key instanceof We) V(e.key);
                            if (e instanceof ht) V(e.value, n);
                            u.pop();
                        });
                    } else if (e instanceof Xn) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            V(e, n < i);
                        });
                    } else if (e instanceof Qe) {
                        V(e.body, true);
                    } else if (e instanceof et) {
                        V(e.expression);
                    } else if (e instanceof Zn) {
                        V(e.expression);
                        V(e.property);
                    } else if (e instanceof qn) {
                        V(e.expression);
                        e.body.forEach(V);
                    } else if (e instanceof nt) {
                        if (Jt[e.operator]) {
                            v.push(u.slice());
                        } else {
                            V(e.expression);
                        }
                    } else if (e instanceof Vn) {
                        if (e.name instanceof xt) {
                            if (e.value) {
                                var r = e.name.definition();
                                if (r.references.length > r.replaced) {
                                    v.push(u.slice());
                                }
                            } else {
                                s[e.name.name] = (s[e.name.name] || 0) + 1;
                            }
                        }
                        if (e.value) V(e.value);
                    }
                    u.pop();
                }
                function W(e, n) {
                    var t = l.parent(n);
                    if (t instanceof ft) return e;
                    if (t instanceof ot) return e;
                    if (t instanceof st) return e;
                    if (t instanceof rt) return e;
                    if (t instanceof Jn) return e;
                    if (t instanceof Hn) return e;
                    if (t instanceof at) return e;
                    if (t instanceof Un) return G(t, n + 1);
                    if (t instanceof On) return e;
                    if (t instanceof jn) return e;
                    if (t instanceof an) return e;
                    if (t instanceof vt) return e;
                    if (t instanceof Kn) return e;
                    if (t instanceof Xn) {
                        return (t.tail_node() === e ? W : G)(t, n + 1);
                    }
                    if (t instanceof Qe) return G(t, n + 1);
                    if (t instanceof et) return e;
                    if (t instanceof qn) return e;
                    if (t instanceof nt) return e;
                    if (t instanceof Vn) return e;
                    return null;
                }
                function J(e, n) {
                    var t = l.parent(n);
                    if (t instanceof ft) return J(t, n + 1);
                    if (t instanceof ot) return k(t) || t.left.match_symbol(function(e) {
                        return e instanceof Dt && (b.name == e.name || m.name == e.name);
                    }) ? e : J(t, n + 1);
                    if (t instanceof rt) {
                        if (Se[t.operator] && t.left !== e) {
                            do {
                                e = t;
                                t = l.parent(++n);
                            } while (t instanceof rt && t.operator == e.operator);
                            return e;
                        }
                        return J(t, n + 1);
                    }
                    if (t instanceof Jn) return t;
                    if (t instanceof Hn) {
                        if (t.expression !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof at) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof Un) return G(t, n + 1);
                    if (t instanceof sn) return e;
                    if (t instanceof On) return G(t, n + 1);
                    if (t instanceof un) {
                        if (t.init !== e && t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof cn) {
                        if (t.init !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof jn) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof vt) {
                        var i = l.parent(n + 1);
                        return Be(i.properties, function(e) {
                            return e instanceof ht;
                        }) ? J(i, n + 2) : i;
                    }
                    if (t instanceof Kn) return J(t, n + 1);
                    if (t instanceof Xn) {
                        return (t.tail_node() === e ? J : G)(t, n + 1);
                    }
                    if (t instanceof Qe) return G(t, n + 1);
                    if (t instanceof et) return J(t, n + 1);
                    if (t instanceof qn) {
                        if (t.expression !== e) return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof nt) {
                        if (t.operator == "delete") return e;
                        return J(t, n + 1);
                    }
                    if (t instanceof Vn) return t.name.match_symbol(function(e) {
                        return e instanceof bt && (b.name == e.name || m.name == e.name);
                    }) ? e : J(t, n + 1);
                    if (t instanceof fn) {
                        if (t.condition !== e) return e;
                        return J(t, n + 1);
                    }
                    return null;
                }
                function G(a, o) {
                    var s = l.parent(o);
                    if (B(a, s)) return a;
                    if (U(a, s)) return a;
                    if (s instanceof ft) return G(s, o + 1);
                    if (s instanceof ot) return r(s.left);
                    if (s instanceof st) return a;
                    if (s instanceof rt) return G(s, o + 1);
                    if (s instanceof Jn) return G(s, o + 1);
                    if (s instanceof Hn) return G(s, o + 1);
                    if (s instanceof at) return G(s, o + 1);
                    if (s instanceof Un) return G(s, o + 1);
                    if (s instanceof On) return G(s, o + 1);
                    if (s instanceof jn) return G(s, o + 1);
                    if (s instanceof an) return a;
                    if (s instanceof vt) {
                        var e = l.parent(o + 1);
                        return Be(e.properties, function(e) {
                            return e instanceof ht;
                        }) ? G(e, o + 2) : e;
                    }
                    if (s instanceof Kn) {
                        var n = s.expression;
                        if (n === a) return G(s, o + 1);
                        var t = ke(n);
                        if (!(t instanceof Dt)) return G(s, o + 1);
                        var i = T.get(t.name);
                        return !i || Be(i, function(e) {
                            return !(e instanceof Kn);
                        }) ? G(s, o + 1) : a;
                    }
                    if (s instanceof Xn) return G(s, o + 1);
                    if (s instanceof Qe) return G(s, o + 1);
                    if (s instanceof et) return a;
                    if (s instanceof qn) return G(s, o + 1);
                    if (s instanceof nt) return G(s, o + 1);
                    if (s instanceof Vn) return r(s.name);
                    return null;
                    function r(e) {
                        if (k(s)) return a;
                        if (e !== a && e instanceof ut) {
                            var n = q;
                            q = false;
                            var t = _;
                            var i = g;
                            var r = l.stack;
                            l.stack = [ s ];
                            e.transform(l);
                            l.stack = r;
                            g = i;
                            _ = t;
                            q = n;
                            if (M) {
                                M = false;
                                return a;
                            }
                        }
                        return G(s, o + 1);
                    }
                }
                function X(e) {
                    if (t) {
                        t = false;
                        return;
                    }
                    if (!(e instanceof Dt)) return;
                    var n = e.definition();
                    if (n.undeclared) return;
                    if (_e(n)) return;
                    return m = n;
                }
                function K(e) {
                    if (e instanceof ot) {
                        var n, t = e.left;
                        if (e.operator == "=" && t instanceof Dt && (n = t.definition()).references[0] === t && !(ve.uses_arguments && ge(n)) && !p.exposed(n)) {
                            var i = n.references.length - n.replaced;
                            if (i > 1) X(e.right);
                        }
                        return t;
                    }
                    if (e instanceof rt) return e.right.left;
                    if (e instanceof nt) return e.expression;
                    if (e instanceof Vn) {
                        var n = e.name.definition();
                        if (n.const_redefs) return;
                        if (!ze(e.name, n.orig)) return;
                        if (ve.uses_arguments && ge(n)) return;
                        var r = n.orig.length - n.eliminated - (s[n.name] || 0);
                        var i = n.references.length - n.replaced - (a[n.name] || 0);
                        if (r > 1 && !(e.name instanceof kt)) {
                            X(e.value);
                            return we(Dt, e.name, e.name);
                        }
                        if (X(e.value) || i == 1 && !p.exposed(n)) {
                            return we(Dt, e.name, e.name);
                        }
                        return;
                    }
                }
                function Q(e) {
                    if (e instanceof ot) return e.right;
                    if (e instanceof rt) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof Vn) return e.value;
                }
                function Z(e) {
                    if (e instanceof ft) return false;
                    if (e instanceof rt && Se[e.operator]) {
                        return Z(e.left) && Z(e.right);
                    }
                    if (e instanceof Jn) return false;
                    if (e instanceof at) {
                        return Z(e.consequent) && Z(e.alternative);
                    }
                    if (e instanceof dt) return false;
                    return !e.has_side_effects(p);
                }
                function ee(n) {
                    if (n instanceof ot && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Bt(function(e) {
                        if (e instanceof Dt) t[e.definition().id] = true;
                    });
                    while (n instanceof ot && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Dt) {
                        var i = n.evaluate(p);
                        if (i === n) return o;
                        return ne(i, o);
                    }
                    if (n instanceof Ot) return o;
                    if (n.is_truthy()) return ne(true, je);
                    if (n.is_constant()) {
                        var r = n.evaluate(p);
                        if (!(r instanceof We)) return ne(r, o);
                    }
                    if (!(b instanceof Dt)) return false;
                    if (!Z(n)) return false;
                    var a;
                    n.walk(new Bt(function(e) {
                        if (a) return true;
                        if (e instanceof Dt && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function ne(i, r) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (i && e.is_truthy() && !e.has_side_effects(p)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(p);
                                if (!(t instanceof We)) return !t == !i;
                            }
                        }
                        return r(e);
                    };
                }
                function te(e) {
                    if (e instanceof Dt) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof ot) return e.operator == "=" && te(e.right);
                    return e instanceof Kn || e instanceof Ot;
                }
                function ie(i) {
                    var r = new Ye();
                    if (i instanceof Vn) r.add(i.name.name, b);
                    var a = ve.uses_arguments && !p.has_directive("use strict");
                    var o = ve instanceof dn;
                    var s = new Bt(function(e) {
                        var n;
                        if (e instanceof Dt) {
                            n = e.fixed_value() || e;
                        } else if (e instanceof Ot) {
                            n = e;
                        }
                        if (n) r.add(e.name, me(p, s, e, n, 0));
                        if (a && e instanceof Zn) {
                            ve.each_argname(function(e) {
                                if (!p.option("reduce_vars") || e.definition().assignments) {
                                    r.add(e.name, true);
                                }
                            });
                            a = false;
                        }
                        if (!o) return;
                        if (e.TYPE == "Call") {
                            if (S) return;
                            var t = e.expression;
                            if (t instanceof Kn) return;
                            if (_n(t) && !t.contains_this()) return;
                            S = true;
                        } else if (e instanceof Kn && te(e.expression)) {
                            if (e === b && !(i instanceof nt)) {
                                S = true;
                            } else {
                                E = true;
                            }
                        }
                    });
                    i.walk(s);
                    return r;
                }
                function re(e) {
                    var n = e.name_index;
                    if (n >= 0) {
                        var t = ve.argnames[n];
                        if (t instanceof Wn) {
                            t.value = we(Mt, t, {
                                value: 0
                            });
                            t.name.definition().fixed = false;
                        } else {
                            var i = p.parent().args;
                            if (i[n]) {
                                i[n] = we(Mt, i[n], {
                                    value: 0
                                });
                                t.definition().fixed = false;
                            }
                        }
                        return true;
                    }
                    var r = u.length - 1;
                    if (u[r - 1].body === u[r]) r--;
                    var a = new Yt(function(e, n, t) {
                        if (z) return e;
                        if (e !== u[c]) return e;
                        c++;
                        if (c <= r) return P(e, a);
                        z = true;
                        if (e instanceof Vn) {
                            e.value = null;
                            s[e.name.name] = (s[e.name.name] || 0) + 1;
                            if (m) m.replaced++;
                            return e;
                        }
                        return t ? He.skip : null;
                    }, ae);
                    M = false;
                    z = false;
                    c = 0;
                    return o[f].transform(a);
                }
                function ae(e) {
                    if (e instanceof Xn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return e.expressions[0];
                    }
                }
                function oe(e) {
                    var n = ke(e);
                    return n instanceof Dt && n.definition().scope === ve && !(pe && (T.has(n.name) && T.get(n.name)[0] !== e || h instanceof nt || h instanceof ot && h.operator != "="));
                }
                function se() {
                    if (h instanceof nt) return false;
                    return O.has_side_effects(p);
                }
                function fe(e) {
                    if (e instanceof nt) return false;
                    if (y) return false;
                    if (m) return true;
                    if (!(b instanceof Dt)) return false;
                    var n;
                    if (e instanceof Vn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = b.definition();
                    return t.references.length - t.replaced == n;
                }
                function ue(e, n) {
                    var t = T.get(e.name);
                    if (!t || Be(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== b) return true;
                    x = false;
                }
                function ce(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Et) return false;
                    if (n.scope !== ve) return true;
                    if (S && p.exposed(n)) return true;
                    return !Be(n.references, function(e) {
                        return e.scope.resolve() === ve;
                    });
                }
                function le(e, n) {
                    if (e instanceof ot) return le(e.left, true);
                    if (e instanceof nt) return le(e.expression, true);
                    if (e instanceof Vn) return e.value && le(e.value);
                    if (n) {
                        if (e instanceof Qn) return le(e.expression, true);
                        if (e instanceof Zn) return le(e.expression, true);
                        if (e instanceof Dt) return e.definition().scope !== ve;
                    }
                    return false;
                }
            }
            function r(e) {
                var n = [];
                for (var t = 0; t < e.length; ) {
                    var i = e[t];
                    if (i instanceof tn) {
                        if (Be(i.body, function(e) {
                            return !(e instanceof Bn || e instanceof Yn);
                        })) {
                            he = true;
                            r(i.body);
                            [].splice.apply(e, [ t, 1 ].concat(i.body));
                            t += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof Xe) {
                        if (ze(i.value, n)) {
                            he = true;
                            e.splice(t, 1);
                            continue;
                        }
                        n.push(i.value);
                    }
                    if (i instanceof Ke) {
                        he = true;
                        e.splice(t, 1);
                        continue;
                    }
                    t++;
                }
            }
            function a(t, r) {
                var a = r.self();
                var e = r.parent();
                var i = x(function(e) {
                    return e instanceof vn;
                });
                var n = i && e && e.TYPE == "Call";
                var o = b(t);
                for (var s = t.length; --s >= 0; ) {
                    var f = t[s];
                    var u = D(s);
                    var c = t[u];
                    if (i && !c && f instanceof An) {
                        if (!f.value) {
                            he = true;
                            t.splice(s, 1);
                            continue;
                        }
                        var l = f.value.tail_node();
                        if (l instanceof tt && l.operator == "void") {
                            he = true;
                            var p;
                            if (l === f.value) {
                                p = l.expression;
                            } else {
                                p = f.value.clone();
                                p.expressions[p.length - 1] = l.expression;
                            }
                            t[s] = we(Qe, f, {
                                body: p
                            });
                            continue;
                        }
                    }
                    if (f instanceof jn) {
                        var d = M(f.body);
                        if (E(d)) {
                            if (d.label) Re(d.label.thedef.references, d);
                            he = true;
                            f = f.clone();
                            f.condition = f.condition.negate(r);
                            var p = T(f.body, d);
                            f.body = we(tn, f, {
                                body: A(f.alternative).concat(S())
                            });
                            f.alternative = we(tn, f, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (d && !f.alternative && f.body instanceof tn && c instanceof Dn) {
                            var v = f.condition.negate(r);
                            if (v.print_to_string().length <= f.condition.print_to_string().length) {
                                he = true;
                                f = f.clone();
                                f.condition = v;
                                t[u] = f.body;
                                f.body = c;
                                t[s] = f;
                                t[s] = f.transform(r);
                                continue;
                            }
                        }
                        var h = M(f.alternative);
                        if (E(h)) {
                            if (h.label) Re(h.label.thedef.references, h);
                            he = true;
                            f = f.clone();
                            f.body = we(tn, f.body, {
                                body: A(f.body).concat(S())
                            });
                            var p = T(f.alternative, h);
                            f.alternative = we(tn, f.alternative, {
                                body: p
                            });
                            t[s] = f;
                            t[s] = f.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (d && !h) {
                                H(f.condition, null, we(tn, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                            if (!d && h) {
                                H(f.condition, we(tn, a, {
                                    body: t.slice(s + 1)
                                }));
                            }
                        }
                    }
                    if (f instanceof jn && f.body instanceof An) {
                        var m = f.body.value;
                        var _ = f.body.in_bool || c instanceof An && c.in_bool;
                        if (!m && !f.alternative && (i && !c || c instanceof An && !c.value)) {
                            he = true;
                            t[s] = we(Qe, f.condition, {
                                body: f.condition
                            });
                            continue;
                        }
                        if (!f.alternative && c instanceof An) {
                            he = true;
                            f = f.clone();
                            f.alternative = c;
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                        if (!f.alternative && !c && i && (_ || m && o)) {
                            he = true;
                            f = f.clone();
                            f.alternative = we(An, f, {
                                value: null
                            });
                            t.splice(s, 1, f.transform(r));
                            continue;
                        }
                        var g = t[O(s)];
                        if (r.option("sequences") && i && !f.alternative && (!g && n || g instanceof jn && g.body instanceof An) && D(u) == t.length && c instanceof Qe) {
                            he = true;
                            f = f.clone();
                            f.alternative = we(tn, c, {
                                body: [ c, we(An, c, {
                                    value: null
                                }) ]
                            });
                            t.splice(s, 1, f.transform(r));
                            t.splice(u, 1);
                            continue;
                        }
                    }
                }
                function b(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var i = e[t];
                        if (i instanceof jn && i.body instanceof An) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function y(e) {
                    return !e || e instanceof tt && e.operator == "void";
                }
                function w(e, n) {
                    var t = e.lastIndexOf(n);
                    if (t < 0) return false;
                    while (++t < e.length) {
                        if (!z(e[t])) return false;
                    }
                    return true;
                }
                function x(e) {
                    var n = a, t, i = 0;
                    do {
                        do {
                            if (e(n)) return true;
                            n = r.parent(i++);
                        } while (n instanceof jn && (t = n));
                    } while ((n instanceof tn || n instanceof pn) && w(n.body, t));
                }
                function k(n) {
                    return x(function(e) {
                        return e === n;
                    });
                }
                function E(e) {
                    if (e instanceof An) return i && y(e.value);
                    if (!(e instanceof zn)) return false;
                    var n = r.loopcontrol_target(e);
                    if (e instanceof Fn) return k($(n));
                    if (n instanceof an) return false;
                    return k(n);
                }
                function S() {
                    var e = t.slice(s + 1);
                    t.length = s + 1;
                    return e.filter(function(e) {
                        if (e instanceof Tn) {
                            t.push(e);
                            return false;
                        }
                        return true;
                    });
                }
                function T(e, n) {
                    var t = A(e);
                    var i = t, r;
                    while ((r = i[i.length - 1]) !== n) {
                        i = r.body;
                    }
                    i.pop();
                    if (n.value) i.push(we(Qe, n.value, {
                        body: n.value.expression
                    }));
                    return t;
                }
                function D(e) {
                    for (var n = e + 1; n < t.length; n++) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
                function O(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!z(t[n])) break;
                    }
                    return n;
                }
            }
            function o(n, t) {
                var e;
                var i = t.self();
                for (var r = 0, a = 0, o = n.length; r < o; r++) {
                    var s = n[r];
                    if (s instanceof zn) {
                        var f = t.loopcontrol_target(s);
                        if (s instanceof Mn && !(f instanceof an) && $(f) === i || s instanceof Fn && $(f) === i) {
                            if (s.label) Re(s.label.thedef.references, s);
                        } else {
                            n[a++] = s;
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (M(s)) {
                        e = n.slice(r + 1);
                        break;
                    }
                }
                n.length = a;
                he = a != o;
                if (e) e.forEach(function(e) {
                    k(t, e, n);
                });
            }
            function s(n, e) {
                if (n.length < 2) return;
                var t = [], i = 0;
                function r() {
                    if (!t.length) return;
                    var e = ie(t[0], t);
                    n[i++] = we(Qe, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof Qe) {
                        if (t.length >= e.sequences_limit) r();
                        var f = s.body;
                        if (t.length > 0) f = f.drop_side_effect_free(e);
                        if (f) m(t, f);
                    } else if (z(s)) {
                        n[i++] = s;
                    } else {
                        r();
                        n[i++] = s;
                    }
                }
                r();
                n.length = i;
                if (i != o) he = true;
            }
            function p(e, n) {
                if (!(e instanceof tn)) return e;
                var t = null;
                for (var i = 0; i < e.body.length; i++) {
                    var r = e.body[i];
                    if (r instanceof Ln && _(r)) {
                        n.push(r);
                    } else if (t || r instanceof Bn || r instanceof Yn) {
                        return false;
                    } else {
                        t = r;
                    }
                }
                return t;
            }
            function u(e, n) {
                function t(e) {
                    i--;
                    he = true;
                    var n = r.body;
                    return ie(n, [ n, e ]);
                }
                var i = 0, r;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (r) {
                        if (o instanceof On) {
                            o.value = t(o.value || we(Nt, o)).transform(n);
                        } else if (o instanceof un) {
                            if (!(o.init instanceof Un)) {
                                var s = false;
                                r.body.walk(new Bt(function(e) {
                                    if (s || e instanceof pn) return true;
                                    if (e instanceof rt && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = t(o.init); else {
                                        o.init = r.body;
                                        i--;
                                        he = true;
                                    }
                                }
                            }
                        } else if (o instanceof cn) {
                            o.object = t(o.object);
                        } else if (o instanceof jn) {
                            o.condition = t(o.condition);
                        } else if (o instanceof qn) {
                            o.expression = t(o.expression);
                        } else if (o instanceof ln) {
                            o.expression = t(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof jn) {
                        var f = [];
                        var u = p(o.body, f);
                        var c = p(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(we(jn, o, {
                                condition: o.condition,
                                body: u || we(Ke, o.body),
                                alternative: c
                            }));
                            f.unshift(i, 1);
                            [].splice.apply(e, f);
                            a += l;
                            i += l + 1;
                            r = null;
                            he = true;
                            continue;
                        }
                    }
                    e[i++] = o;
                    r = o instanceof Qe ? o : null;
                }
                e.length = i;
            }
            function c(e, n, t) {
                var i;
                if (n instanceof ot) {
                    i = [ n ];
                } else if (n instanceof Xn) {
                    i = n.expressions.slice();
                }
                if (!i) return;
                var r = false;
                for (var a = i.length - 1; --a >= 0; ) {
                    var o = i[a];
                    if (!(o instanceof ot)) continue;
                    if (o.operator != "=") continue;
                    if (!(o.left instanceof Dt)) continue;
                    var s = i.slice(a + 1);
                    if (!v(o.left, o.right, s)) continue;
                    r = true;
                    i = i.slice(0, a + 1).concat(s);
                }
                if (e instanceof Un) {
                    t = t || 0;
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var f = e.definitions[a];
                        if (!f.value) continue;
                        if (v(f.name, f.value, i)) r = true;
                        if (l(f, i, t)) r = true;
                        break;
                    }
                    if (e instanceof Ln && d(e.definitions, i, t)) r = true;
                }
                return r && i;
            }
            function l(e, n, t) {
                if (!f.option("conditionals")) return;
                if (e.name instanceof ut) return;
                var i = false;
                var r = e.name.definition();
                while (n.length > t) {
                    var a = B(f, r, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function d(e, n, t) {
                var i = false;
                while (n.length > t) {
                    var r = n[0];
                    if (!(r instanceof ot)) break;
                    if (r.operator != "=") break;
                    var a = r.left;
                    if (!(a instanceof Dt)) break;
                    if (fe(a)) break;
                    if (a.scope.resolve() !== ve) break;
                    var o = a.definition();
                    if (o.scope !== ve) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = we(xt, a, a);
                    e.push(we(Vn, r, {
                        name: s,
                        value: r.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    i = true;
                }
                return i;
            }
            function v(e, n, t) {
                if (!(n instanceof dt)) return;
                var i = false;
                do {
                    var r = t[0];
                    if (!(r instanceof ot)) break;
                    if (r.operator != "=") break;
                    if (!(r.left instanceof Kn)) break;
                    var a = r.left.expression;
                    if (!(a instanceof Dt)) break;
                    if (e.name != a.name) break;
                    if (!r.right.is_constant_expression(ve)) break;
                    var o = r.left.property;
                    if (o instanceof We) {
                        o = o.evaluate(f);
                    }
                    if (o instanceof We) break;
                    o = "" + o;
                    var s = o == "__proto__" || f.has_directive("use strict") ? function(e) {
                        return typeof e.key == "string" && e.key != o;
                    } : function(e) {
                        if (e instanceof _t || e instanceof mt) {
                            return typeof e.key == "string" && e.key != o;
                        }
                        return true;
                    };
                    if (!Be(n.properties, s)) break;
                    n.properties.push(we(ht, r, {
                        key: o,
                        value: r.right
                    }));
                    t.shift();
                    i = true;
                } while (t.length);
                return i;
            }
            function h(e) {
                var r;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var i = e[n];
                    var a = e[t];
                    if (i instanceof Un) {
                        if (a && a.TYPE == i.TYPE) {
                            a.definitions = a.definitions.concat(i.definitions);
                            he = true;
                        } else if (r && r.TYPE == i.TYPE && _(i)) {
                            r.definitions = r.definitions.concat(i.definitions);
                            he = true;
                        } else {
                            e[++t] = i;
                            if (i instanceof Ln) r = i;
                        }
                        continue;
                    } else if (i instanceof On) {
                        i.value = f(i.value);
                    } else if (i instanceof un) {
                        var o = c(a, i.init);
                        if (o) {
                            he = true;
                            i.init = o.length ? ie(i.init, o) : null;
                        } else if (a instanceof Ln && (!i.init || i.init.TYPE == a.TYPE)) {
                            if (i.init) {
                                a.definitions = a.definitions.concat(i.init.definitions);
                            }
                            r = i.init = a;
                            e[t] = u(i);
                            he = true;
                            continue;
                        } else if (r && i.init && r.TYPE == i.init.TYPE && _(i.init)) {
                            r.definitions = r.definitions.concat(i.init.definitions);
                            i.init = null;
                            he = true;
                        } else if (i.init instanceof Ln) {
                            r = i.init;
                        }
                    } else if (i instanceof cn) {
                        if (r && r.TYPE == i.init.TYPE) {
                            var s = r.definitions.slice();
                            i.init = i.init.definitions[0].name.convert_symbol(Dt, function(e, n) {
                                s.push(we(Vn, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            r.definitions = s;
                            he = true;
                        }
                        i.object = f(i.object);
                    } else if (i instanceof jn) {
                        i.condition = f(i.condition);
                    } else if (i instanceof Qe) {
                        var o = c(a, i.body);
                        if (o) {
                            he = true;
                            if (!o.length) continue;
                            i.body = ie(i.body, o);
                        }
                    } else if (i instanceof qn) {
                        i.expression = f(i.expression);
                    } else if (i instanceof ln) {
                        i.expression = f(i.expression);
                    }
                    e[++t] = r ? u(i) : i;
                }
                e.length = t + 1;
                function f(e) {
                    var n = c(a, e, 1);
                    if (!n) return e;
                    he = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return ie(e, n);
                }
                function u(e) {
                    return e.transform(new Yt(function(e, n, t) {
                        if (e instanceof Un) {
                            if (r === e) return e;
                            if (r.TYPE != e.TYPE) return e;
                            var i = this.parent();
                            if (i instanceof cn && i.init === e) return e;
                            if (!_(e)) return e;
                            r.definitions = r.definitions.concat(e.definitions);
                            he = true;
                            if (i instanceof un && i.init === e) return null;
                            return t ? He.skip : we(Ke, e);
                        }
                        if (e instanceof pn) return e;
                        if (!(e instanceof Je)) return e;
                    }));
                }
            }
        }
        function k(r, a, o) {
            if (!(a instanceof Un || En(a))) {
                We.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            }
            var s;
            a.walk(new Bt(function(e, n) {
                if (e instanceof Un) {
                    var t = [];
                    if (e.remove_initializers(r, t)) {
                        We.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        f(e);
                    }
                    return true;
                }
                if (En(e)) {
                    f(e);
                    return true;
                }
                if (e instanceof pn) return true;
                if (e instanceof Ze) {
                    var i = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(we(tn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = i;
                    return true;
                }
            }));
            function f(e) {
                if (s) {
                    s.push(e);
                    if (e instanceof Bn || e instanceof Yn) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Ee(e, n) {
            return e.is_undefined || e instanceof Nt || e instanceof tt && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(We, je);
            e(ft, qe);
            e(ot, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(vn, qe);
            e(dt, qe);
            e(jt, qe);
            e(Xn, function() {
                return this.tail_node().is_truthy();
            });
            e(Dt, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = je;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(We, qe);
            e(ft, je);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof $t) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                    return true;

                  default:
                    return false;
                }
            }
            e(ot, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(rt, function() {
                return n(this.operator, this.left, this.right);
            });
            e($t, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(vn, je);
            e(dt, je);
            e(jt, je);
            e(Xn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Dt, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = qe;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(tt, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            We.DEFMETHOD("may_throw_on_access", function(e) {
                return !e.option("pure_getters") || this._dot_throw(e);
            });
            function i(e) {
                return /strict/.test(e.option("pure_getters"));
            }
            e(We, i);
            e(ft, je);
            e(ot, function(e) {
                if (this.operator != "=") return false;
                var n = this.right;
                if (!n._dot_throw(e)) return false;
                var t = this.left;
                if (!(t instanceof Dt)) return true;
                if (n instanceof rt && n.operator == "||" && t.name == n.left.name) {
                    return n.right._dot_throw(e);
                }
                return true;
            });
            e(rt, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left._dot_throw(e) || this.right._dot_throw(e);

                  case "||":
                    return this.right._dot_throw(e);

                  default:
                    return false;
                }
            });
            e(at, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e($t, je);
            e(Qn, function(e) {
                if (!i(e)) return false;
                var n = this.expression;
                if (n instanceof Dt) n = n.fixed_value();
                return !(n instanceof vn && this.property == "prototype");
            });
            e(vn, je);
            e(qt, qe);
            e(dt, function(e) {
                return i(e) && !Be(this.properties, function(e) {
                    return e instanceof ht;
                });
            });
            e(Xn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Dt, function(e) {
                if (this.is_undefined) return true;
                if (!i(e)) return false;
                if (fe(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var n = this.definition();
                if (_e(n) && !n.scope.rest && Be(n.scope.argnames, function(e) {
                    return e instanceof kt;
                })) return n.scope.uses_arguments > 2;
                var t = this.fixed_value();
                if (!t) return true;
                this._dot_throw = qe;
                if (t._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = je;
                return false;
            });
            e(Ot, function(e) {
                return i(e) && !this.scope.new;
            });
            e(tt, function() {
                return this.operator == "void";
            });
            e(it, je);
            e(Nt, qe);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(We, je);
            e(ft, qe);
            e(ot, function(e) {
                return this.operator != "=" || this.right.is_defined(e);
            });
            e(rt, function(e) {
                switch (this.operator) {
                  case "&&":
                    return this.left.is_defined(e) && this.right.is_defined(e);

                  case "||":
                    return this.left.is_truthy() || this.right.is_defined(e);

                  default:
                    return true;
                }
            });
            e(at, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e($t, qe);
            e(Ht, je);
            e(vn, qe);
            e(dt, qe);
            e(Xn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Dt, function(e) {
                if (this.is_undefined) return false;
                if (fe(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = je;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(tt, function() {
                return this.operator != "void";
            });
            e(it, qe);
            e(Nt, je);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(We, je);
            e(ot, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = Ue("in instanceof == != === !== < <= >= >");
            e(rt, function(e) {
                return n[this.operator] || Se[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(It, qe);
            var t = Ue("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Jn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Qn && (t[n.property] || n.property == "test" && n.expression instanceof jt);
            });
            e(at, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(Gn, je);
            e(Xn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Dt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = je;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var i = Ue("! delete");
            e(tt, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(We, je);
            var n = Ue("- * / % & | ^ << >> >>>");
            e(ot, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(rt, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = Ue([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear", "toExponential", "toFixed", "toPrecision" ]);
            e(Jn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Qn && (t[n.property] || fe(n.expression) && n.expression.name == "Math");
            });
            e(at, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(Gn, je);
            e(Mt, qe);
            e(Xn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Dt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_number = je;
                var t = n.is_number(e);
                delete this.is_number;
                return t;
            });
            var i = Ue("+ - ~ ++ --");
            e(nt, function() {
                return i[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(We, je);
            e(ot, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(rt, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = Ue([ "charAt", "substr", "substring", "toLowerCase", "toString", "toUpperCase", "trim" ]);
            e(Jn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof Qn && t[n.property];
            });
            e(at, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Xn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(zt, qe);
            e(Dt, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = je;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(At, function(e) {
                return !this.tag || Ae(e, this.tag);
            });
            e(tt, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var Se = Ue("&& ||");
        (function(e) {
            function r(e, n) {
                if (e instanceof We) return e.clone(true);
                if (Array.isArray(e)) return we(ft, n, {
                    elements: e.map(function(e) {
                        return r(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var i in e) if (Le(e, i)) {
                        t.push(we(ht, n, {
                            key: i,
                            value: r(e[i], n)
                        }));
                    }
                    return we(dt, n, {
                        properties: t
                    });
                }
                return re(e, n);
            }
            function o(e) {
                We.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            dn.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie8: a.option("ie8")
                });
                return this.transform(new Yt(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, i = e, r;
                    while (r = this.parent(t++)) {
                        if (!(r instanceof Kn)) break;
                        if (r.expression !== i) break;
                        i = r;
                    }
                    if (Qt(i, r)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(We, Fe);
            e(Qn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(bt, function(e) {
                if (!this.definition().global) return;
                if (Le(e.option("global_defs"), this.name)) o(this);
            });
            e(Dt, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var i = this.name + n;
                if (Le(t, i)) return r(t[i], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function ce(e, n, t) {
            var i = n.print_to_string().length - e.print_to_string().length;
            return i < (t || 0) ? n : e;
        }
        function s(e, n, t) {
            return ce(we(Qe, e, {
                body: e
            }), we(Qe, n, {
                body: n
            }), t).body;
        }
        function le(e, n, t, i) {
            return (Ve(e) ? s : ce)(n, t, i);
        }
        function d(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = Ue(n[e]);
            });
            return t;
        }
        function c(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof Xe)) return t;
            }
        }
        function p() {
            if (this.value) return we(An, this.value, {
                value: this.value
            });
            return c(this.body);
        }
        bn.DEFMETHOD("first_statement", p);
        wn.DEFMETHOD("first_statement", p);
        vn.DEFMETHOD("first_statement", function() {
            return c(this.body);
        });
        vn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof Wn) break;
            }
            return n;
        });
        function pe(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = re(t, n).optimize(e);
            return le(e, n, t, e.eval_threshold);
        }
        var v = [ "constructor", "toString", "valueOf" ];
        var g = d({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(v),
            Boolean: v,
            Function: v,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(v),
            Object: v,
            RegExp: [ "exec", "test" ].concat(v),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(v)
        });
        var b = d({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode" ]
        });
        (function(e) {
            e(We, je);
            e($t, qe);
            e(jt, je);
            var n = Ue("! ~ - + void");
            e(tt, function() {
                return n[this.operator] && this.expression instanceof $t;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            We.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var i = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return i;
                if (!i || i instanceof RegExp) return i;
                if (typeof i == "function" || typeof i == "object") return this;
                return i;
            });
            var h = new Bt(function(e) {
                if (e instanceof ot) u(e.left);
                if (e instanceof nt && Jt[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof ct) {
                    e.elements.forEach(u);
                } else if (e instanceof pt) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Kn) {
                    u(e.expression);
                } else if (e instanceof Dt) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(Je, function() {
                throw new Error(Ie("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(hn, Ce);
            e(Ft, Ce);
            e(We, Ce);
            e($t, function() {
                return this.value;
            });
            e(ot, function(e, n, t, i) {
                var r = this.left;
                if (!n) {
                    if (!(r instanceof Dt)) return this;
                    if (!Le(r, "_eval")) {
                        if (!r.fixed) return this;
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Le(r, "_eval") && r instanceof Dt && r.fixed && r.definition().fixed) {
                    s = r;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = we(rt, this, {
                        operator: o.slice(0, -1),
                        left: r,
                        right: this.right
                    });
                }
                r.walk(h);
                var f = s._eval(e, n, t, i);
                if (typeof f == "object") return this;
                u(r);
                return f;
            });
            e(Xn, function(e, n, t, i) {
                if (!n) return this;
                var r = this.expressions;
                for (var a = 0, o = r.length - 1; a < o; a++) {
                    r[a].walk(h);
                }
                var s = r[o];
                var f = s._eval(e, n, t, i);
                return f === s ? this : f;
            });
            e(vn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(ft, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Ht) return this;
                        var s = o._eval(e, n, t, i);
                        if (o === s) return this;
                        r.push(s);
                    }
                    return r;
                }
                return this;
            });
            e(dt, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof ht)) return this;
                        var s = o.key;
                        if (s instanceof We) {
                            s = s._eval(e, n, t, i);
                            if (s === o.key) return this;
                        }
                        if (s == "toString" || s == "valueOf") return this;
                        r[s] = o.value._eval(e, n, t, i);
                        if (r[s] === o.value) return this;
                    }
                    return r;
                }
                return this;
            });
            var f = Ue("! typeof void");
            e(tt, function(e, n, t, i) {
                var r = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (r instanceof vn || r instanceof Dt && r.fixed_value() instanceof vn)) {
                    return typeof function() {};
                }
                var o = r instanceof Dt && r.definition();
                if (!f[a] && !(o && o.fixed)) i++;
                r.walk(h);
                var s = r._eval(e, n, t, i);
                if (s === r) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== r) return this;
                    }
                    if (Le(r, "_eval")) s = +(a[0] + 1) + +s;
                    u(r);
                    return s;
                }
                return this;
            });
            e(it, function(e, n, t, i) {
                var r = this.expression;
                if (!(r instanceof Dt)) {
                    if (!n) return this;
                } else if (!Le(r, "_eval")) {
                    if (!r.fixed) return this;
                    if (!n) {
                        var a = r.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== r) return this;
                    }
                }
                if (!(r instanceof Dt && r.definition().fixed)) i++;
                r.walk(h);
                var o = r._eval(e, n, t, i);
                if (o === r) return this;
                u(r);
                return +o;
            });
            var c = Ue("&& || === !==");
            e(rt, function(e, n, t, i) {
                if (!c[this.operator]) i++;
                var r = this.left._eval(e, n, t, i);
                if (r === this.left) return this;
                if (this.operator == (r ? "||" : "&&")) return r;
                var a = n && !(r && typeof r == "object");
                var o = this.right._eval(e, a, t, i);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = r && o;
                    break;

                  case "||":
                    s = r || o;
                    break;

                  case "|":
                    s = r | o;
                    break;

                  case "&":
                    s = r & o;
                    break;

                  case "^":
                    s = r ^ o;
                    break;

                  case "+":
                    s = r + o;
                    break;

                  case "-":
                    s = r - o;
                    break;

                  case "*":
                    s = r * o;
                    break;

                  case "/":
                    s = r / o;
                    break;

                  case "%":
                    s = r % o;
                    break;

                  case "<<":
                    s = r << o;
                    break;

                  case ">>":
                    s = r >> o;
                    break;

                  case ">>>":
                    s = r >>> o;
                    break;

                  case "==":
                    s = r == o;
                    break;

                  case "===":
                    s = r === o;
                    break;

                  case "!=":
                    s = r != o;
                    break;

                  case "!==":
                    s = r !== o;
                    break;

                  case "<":
                    s = r < o;
                    break;

                  case "<=":
                    s = r <= o;
                    break;

                  case ">":
                    s = r > o;
                    break;

                  case ">=":
                    s = r >= o;
                    break;

                  case "**":
                    s = Math.pow(r, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && Le(o, r)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(ln) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(r), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e.+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(at, function(e, n, t, i) {
                var r = this.condition._eval(e, n, t, i);
                if (r === this.condition) return this;
                var a = r ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, i);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var i = false;
                    t[0].walk(new Bt(function(e) {
                        if (i) return true;
                        if (e === n) return i = true;
                        if (e instanceof pn) return true;
                    }));
                    return i;

                  default:
                    return e <= t.depth;
                }
            }
            e(Dt, function(e, n, t, i) {
                var r = this.fixed_value();
                if (!r) return this;
                var a;
                if (Le(r, "_eval")) {
                    a = r._eval();
                } else {
                    this._eval = Ce;
                    a = r._eval(e, n, t, i);
                    delete this._eval;
                    if (a === r) return this;
                    r._eval = function() {
                        return a;
                    };
                    t.push(r);
                }
                return a && typeof a == "object" && !o(this, i) ? this : a;
            });
            var m = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = d({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = Ue("global ignoreCase multiline source");
            e(Kn, function(e, n, t, i) {
                if (e.option("unsafe")) {
                    var r;
                    var a = this.expression;
                    if (!fe(a)) {
                        r = a._eval(e, n, t, i + 1);
                        if (r == null || r === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof We) {
                        o = o._eval(e, n, t, i);
                        if (o === this.property) return this;
                    }
                    if (r === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        r = m[a.name];
                    } else if (r instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof r == "object") {
                        if (!Le(r, o)) return this;
                    } else if (typeof r == "function") switch (o) {
                      case "name":
                        return r.node.name ? r.node.name.name : "";

                      case "length":
                        return r.node.length();

                      default:
                        return this;
                    }
                    return r[o];
                }
                return this;
            });
            function _(e, n, t, i, r) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, i, r);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(Jn, function(i, r, a, o) {
                var e = this.expression;
                var n = e instanceof Dt ? e.fixed_value() : e;
                if (n instanceof bn || n instanceof Tn || n instanceof kn) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(i)) return this;
                    var s = _(this.args, i, r, a, o);
                    if (!Be(n.argnames, function(e, n) {
                        if (e instanceof Wn) {
                            if (!s) return false;
                            if (s[n] !== undefined) return false;
                            var t = e.value._eval(i, r, a, o);
                            if (t === e.value) return false;
                            s[n] = t;
                            e = e.name;
                        }
                        return !(e instanceof ut);
                    })) return this;
                    if (!s && !r) return this;
                    var t = n.first_statement();
                    if (!(t instanceof An)) {
                        if (r) {
                            n.walk(h);
                            var f = false;
                            n.evaluating = true;
                            en(n, new Bt(function(e) {
                                if (f) return true;
                                if (e instanceof An) {
                                    if (e.value && e.value._eval(i, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof pn && e !== n) return true;
                            }));
                            delete n.evaluating;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || Be(n.argnames, function(e, n) {
                        if (e instanceof Wn) e = e.name;
                        var t = e.definition();
                        if (t.orig[t.orig.length - 1] !== e) return false;
                        var i = s[n];
                        t.references.forEach(function(e) {
                            e._eval = function() {
                                return i;
                            };
                            c.push(e);
                        });
                        return true;
                    }) || r) {
                        n.evaluating = true;
                        u = u._eval(i, r, a, o);
                        delete n.evaluating;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (i.option("unsafe") && e instanceof Kn) {
                    var l = e.property;
                    if (l instanceof We) {
                        l = l._eval(i, r, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (fe(p)) {
                        var d = b[p.name];
                        if (!d || !d[l]) return this;
                        u = m[p.name];
                    } else {
                        u = p._eval(i, r, a, o + 1);
                        if (u == null || u === p) return this;
                        var v = g[u.constructor.name];
                        if (!v || !v[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof jt)) return this;
                    }
                    var s = _(this.args, i, r, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        We.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
            });
            e(Gn, Ce);
            e(At, function(e, n, t, i) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Ae(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var r = _(this.expressions, e, n, t, i);
                if (!r) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < r.length; s++) {
                    o += r[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = Ce;
                return this;
                function f(e) {
                    return e.replace(/\\(u\{[^}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                        var t = Vt(n);
                        if (typeof t != "string") a = true;
                        return t;
                    });
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return we(tt, e, {
                    operator: "!",
                    expression: e
                });
            }
            function r(e, n, t) {
                var i = a(e);
                if (t) {
                    var r = we(Qe, n, {
                        body: n
                    });
                    return ce(i, r) === r ? n : i;
                }
                return ce(i, n);
            }
            e(We, function() {
                return a(this);
            });
            e(Je, function() {
                throw new Error("Cannot negate a statement");
            });
            e(bn, function() {
                return a(this);
            });
            e(wn, function() {
                return a(this);
            });
            e(xn, function() {
                return a(this);
            });
            e(kn, function() {
                return a(this);
            });
            e(tt, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
            e(Xn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return ie(this, n);
            });
            e(at, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return r(this, t, n);
            });
            e(rt, function(e, n) {
                var t = this.clone(), i = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (i) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (i) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return r(this, t, n);
                }
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var h = Ue("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        Jn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (fe(n) && h[n.name]) return true;
                if (n instanceof Qn && fe(n.expression)) {
                    var t = b[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return this.pure || !e.pure_funcs(this);
        });
        We.DEFMETHOD("is_call_pure", je);
        Jn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof Qn)) return false;
            var t = n.expression;
            var i;
            var r = n.property;
            if (t instanceof ft) {
                i = g.Array;
            } else if (t.is_boolean(e)) {
                i = g.Boolean;
            } else if (t.is_number(e)) {
                i = g.Number;
            } else if (t instanceof jt) {
                i = g.RegExp;
            } else if (t.is_string(e)) {
                i = g.String;
                if (r == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                i = g.Object;
            }
            return i && i[r];
        });
        function y(e) {
            while ((e = e.tail_node()) instanceof Dt) {
                e = e.fixed_value();
                if (!e) return true;
            }
            return !(e instanceof ft || e.TYPE == "Binary" && !Se[e.operator] || e instanceof $t || e instanceof vn || e instanceof dt && Be(e.properties, function(e) {
                return !(e instanceof _t || e instanceof et);
            }) || e instanceof Ot || e instanceof nt);
        }
        (function(e) {
            function n(e, n, t) {
                return !Be(e, t ? function(e) {
                    return e instanceof et ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function t(e, n) {
                return !e.expression.is_string(n) || e.expression.has_side_effects(n);
            }
            e(We, qe);
            e(ft, function(e) {
                return n(this.elements, e, t);
            });
            e(ot, function(e) {
                var n = this.left;
                if (!(n instanceof Kn)) return true;
                var t = n.expression;
                return !(t instanceof Ot) || !t.scope.new || n instanceof Zn && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(rt, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || this.operator == "in" && !De(this.right);
            });
            e(nn, function(e) {
                return n(this.body, e);
            });
            e(Jn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return n(this.args, e, t);
            });
            e(Hn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(at, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e($t, je);
            e(Un, function(e) {
                return n(this.definitions, e);
            });
            e(ct, function(e) {
                return n(this.elements, e);
            });
            e(lt, function(e) {
                return this.key instanceof We && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(pt, function(e) {
                return n(this.properties, e);
            });
            e(Qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(Ke, je);
            e(jn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(rn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(vn, je);
            e(dt, function(e) {
                return n(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return y(t) || t.has_side_effects(n);
                });
            });
            e(vt, function(e) {
                return this.key instanceof We && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Xn, function(e) {
                return n(this.expressions, e);
            });
            e(Qe, function(e) {
                return this.body.has_side_effects(e);
            });
            e(Zn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(qn, function(e) {
                return this.expression.has_side_effects(e) || n(this.body, e);
            });
            e(bt, je);
            e(Dt, function(e) {
                return !this.is_declared(e) || !be(this);
            });
            e(At, function(e) {
                return this.tag && !Ae(e, this.tag) || n(this.expressions, e);
            });
            e(Ot, je);
            e(Pn, function(e) {
                return n(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(nt, function(e) {
                return Kt[this.operator] || this.expression.has_side_effects(e);
            });
            e(Vn, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(We, qe);
            e($t, je);
            e(Ke, je);
            e(vn, je);
            e(bt, je);
            e(Ot, je);
            function n(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            e(ft, function(e) {
                return n(this.elements, e);
            });
            e(ot, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Dt) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(rt, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || this.operator == "in" && !De(this.right);
            });
            e(nn, function(e) {
                return n(this.body, e);
            });
            e(Jn, function(e) {
                if (n(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (this.expression.may_throw(e)) return true;
                return !(this.expression instanceof vn) || n(this.expression.body, e);
            });
            e(Hn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(at, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Un, function(e) {
                return n(this.definitions, e);
            });
            e(Qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(jn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(rn, function(e) {
                return this.body.may_throw(e);
            });
            e(dt, function(e) {
                return n(this.properties, e);
            });
            e(vt, function(e) {
                return this.key instanceof We && this.key.may_throw(e) || this.value.may_throw(e);
            });
            e(An, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Xn, function(e) {
                return n(this.expressions, e);
            });
            e(Qe, function(e) {
                return this.body.may_throw(e);
            });
            e(Zn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(qn, function(e) {
                return this.expression.may_throw(e) || n(this.body, e);
            });
            e(Dt, function(e) {
                return !this.is_declared(e);
            });
            e(Pn, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : n(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(nt, function(e) {
                if (this.operator == "typeof" && this.expression instanceof Dt) return false;
                return this.expression.may_throw(e);
            });
            e(Vn, function(e) {
                if (!this.value) return false;
                return this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function n(e) {
                for (var n = e.length; --n >= 0; ) if (!e[n].is_constant_expression()) return false;
                return true;
            }
            e(We, je);
            e(ft, function() {
                return n(this.elements);
            });
            e(rt, function() {
                return this.left.is_constant_expression() && this.right.is_constant_expression() && (this.operator != "in" || De(this.right));
            });
            e($t, qe);
            e(vn, function(r) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Bt(function(e, n) {
                    if (!o) return true;
                    if (e instanceof Ze) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Dt) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (ze(t.scope, s)) return true;
                        if (r && !t.redefined()) {
                            var i = r.find_variable(e.name);
                            if (t.undeclared ? !i : i === t) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof Ot) {
                        if (s.length == 0 && mn(a)) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(dt, function() {
                return n(this.properties);
            });
            e(vt, function() {
                return typeof this.key == "string" && this.value.is_constant_expression();
            });
            e(nt, function() {
                return this.expression.is_constant_expression();
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function M(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(Je, Ne);
            e(Dn, Ce);
            function n() {
                var e = this.body.length;
                return e > 0 && M(this.body[e - 1]);
            }
            e(tn, n);
            e(Cn, n);
            e(jn, function() {
                return this.alternative && M(this.body) && M(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var w = Ue([ "use asm", "use strict" ]);
        e(Xe, function(e, n) {
            if (n.option("directives") && (!w[e.value] || n.has_directive(e.value) !== e)) {
                return we(Ke, e);
            }
            return e;
        });
        e(Ge, function(e, n) {
            if (n.option("drop_debugger")) return we(Ke, e);
            return e;
        });
        e(rn, function(e, n) {
            if (n.option("dead_code") && e.body instanceof Mn && n.loopcontrol_target(e.body) === e.body) {
                return we(Ke, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(nn, function(e, n) {
            e.body = u(e.body, n);
            return e;
        });
        function J(e, n) {
            switch (e.body.length) {
              case 0:
                return n ? He.skip : we(Ke, e);

              case 1:
                var t = e.body[0];
                if (!(t instanceof Bn || t instanceof Yn)) return t;
            }
            return e;
        }
        e(tn, function(e, n) {
            e.body = u(e.body, n);
            return J(e);
        });
        function E(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof ct)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = null;
        }
        function S(e, n) {
            if (!n.option("arrows")) return e;
            E(e, n);
            var t = u(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var i = t[0];
                if (i instanceof An) {
                    e.body.length = 0;
                    e.value = i.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(bn, S);
        e(wn, S);
        e(Tn, function(e, n) {
            E(e, n);
            e.body = u(e.body, n);
            return e;
        });
        e(kn, function(n, e) {
            E(n, e);
            n.body = u(n.body, e);
            if (e.option("inline")) for (var t = 0; t < n.body.length; t++) {
                var i = n.body[t];
                if (i instanceof Xe) continue;
                if (i instanceof An) {
                    if (t != n.body.length - 1) break;
                    var r = i.value;
                    if (!r || r.TYPE != "Call") break;
                    if (r.is_expr_pure(e)) break;
                    var a = r.expression;
                    if (a instanceof Dt) {
                        if (n.name && n.name.definition() === a.definition()) break;
                        a = a.fixed_value();
                    }
                    if (!(a instanceof Tn || a instanceof kn)) break;
                    if (a.uses_arguments) break;
                    if (a === r.expression) {
                        if (a.parent_scope !== n) break;
                        if (!Be(a.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (a.contains_this()) break;
                    var o = a.argnames.length;
                    if (o > 0 && e.option("inline") < 2) break;
                    if (o > n.argnames.length) break;
                    if (!Be(n.argnames, function(e) {
                        return e instanceof kt;
                    })) break;
                    if (!Be(r.args, function(e) {
                        return !(e instanceof et);
                    })) break;
                    for (var s = 0; s < o; s++) {
                        var f = r.args[s];
                        if (!(f instanceof Dt)) break;
                        if (f.definition() !== n.argnames[s].definition()) break;
                    }
                    if (s < o) break;
                    for (;s < r.args.length; s++) {
                        if (r.args[s].has_side_effects(e)) break;
                    }
                    if (s < r.args.length) break;
                    if (o < n.argnames.length && !e.drop_fargs(n, e.parent())) {
                        if (!e.drop_fargs(a, r)) break;
                        do {
                            a.argnames.push(a.make_var(kt, a, "argument_" + o));
                        } while (++o < n.argnames.length);
                    }
                    return r.expression;
                }
                break;
            }
            return n;
        });
        pn.DEFMETHOD("merge_variables", function(a) {
            if (!a.option("merge_vars")) return;
            var c = this, l = {}, p;
            var o = [], s = [], f = 0;
            var d = new Ye();
            var v = Object.create(null);
            var u = Object.create(null);
            var h = new Bt(function(r, e) {
                if (r instanceof ot) {
                    var n = r.left;
                    if (n instanceof ut) {
                        r.right.walk(h);
                        var t = new Bt(function(e) {
                            if (e instanceof ut) return;
                            if (e instanceof Wn) {
                                w();
                                e.value.walk(h);
                                x();
                                e.name.walk(t);
                            } else if (e instanceof lt) {
                                if (e.key instanceof We) {
                                    w();
                                    l.block = e;
                                    e.key.walk(h);
                                    e.value.walk(t);
                                    x();
                                } else {
                                    e.value.walk(t);
                                }
                            } else if (e instanceof Dt) {
                                k(e);
                            } else {
                                e.walk(h);
                            }
                            return true;
                        });
                        n.walk(t);
                        return true;
                    }
                    if (n instanceof Dt) {
                        if (r.operator != "=") k(n, true);
                        r.right.walk(h);
                        k(n);
                        return true;
                    }
                    return;
                }
                if (r instanceof rt) {
                    if (!Se[r.operator]) return;
                    r.left.walk(h);
                    w();
                    r.right.walk(h);
                    x();
                    return true;
                }
                if (r instanceof Mn) {
                    var i = h.loopcontrol_target(r);
                    if (!(i instanceof an)) E(i);
                    return true;
                }
                if (r instanceof Jn) {
                    var a = r.expression;
                    var o = a.tail_node();
                    if (!_n(o)) return;
                    if (a !== o) a.expressions.slice(0, -1).forEach(function(e) {
                        e.walk(h);
                    });
                    r.args.forEach(function(e) {
                        e.walk(h);
                    });
                    o.walk(h);
                    return true;
                }
                if (r instanceof at) {
                    r.condition.walk(h);
                    w();
                    r.consequent.walk(h);
                    x();
                    w();
                    r.alternative.walk(h);
                    x();
                    return true;
                }
                if (r instanceof Fn) {
                    var i = h.loopcontrol_target(r);
                    if (i instanceof sn) E(i);
                    return true;
                }
                if (r instanceof sn) {
                    w();
                    l.block = r;
                    l.loop = true;
                    var s = l;
                    r.body.walk(h);
                    if (l.inserted === r) l = s;
                    r.condition.walk(h);
                    x();
                    return true;
                }
                if (r instanceof un) {
                    if (r.init) r.init.walk(h);
                    w();
                    l.block = r;
                    l.loop = true;
                    if (r.condition) r.condition.walk(h);
                    r.body.walk(h);
                    if (r.step) r.step.walk(h);
                    x();
                    return true;
                }
                if (r instanceof cn) {
                    r.object.walk(h);
                    w();
                    l.block = r;
                    l.loop = true;
                    r.init.walk(h);
                    r.body.walk(h);
                    x();
                    return true;
                }
                if (r instanceof jn) {
                    r.condition.walk(h);
                    w();
                    r.body.walk(h);
                    x();
                    if (r.alternative) {
                        w();
                        r.alternative.walk(h);
                        x();
                    }
                    return true;
                }
                if (r instanceof rn) {
                    w();
                    l.block = r;
                    var s = l;
                    r.body.walk(h);
                    if (l.inserted === r) l = s;
                    x();
                    return true;
                }
                if (r instanceof pn) {
                    w();
                    l.block = r;
                    if (r === c) p = l;
                    if (r instanceof vn) {
                        if (r.name) v[r.name.definition().id] = false;
                        var t = r.uses_arguments && !h.has_directive("use strict") ? function(e) {
                            if (e instanceof kt) v[e.definition().id] = false;
                        } : function(e) {
                            if (e instanceof kt) k(e);
                        };
                        var f = new Bt(function(e) {
                            if (e instanceof bt) v[e.definition().id] = false;
                            if (!(e instanceof Dt)) return;
                            var n = e.definition();
                            var t = r.variables.get(e.name);
                            if (t && (t === n || n.undeclared || r.parent_scope.find_variable(e.name) === n)) {
                                v[n.id] = false;
                                v[t.id] = false;
                            } else {
                                var i = l;
                                x();
                                k(e, true);
                                l = i;
                            }
                            return true;
                        });
                        r.argnames.forEach(function(e) {
                            e.mark_symbol(t, f);
                        });
                        if (r.rest) r.rest.mark_symbol(t, f);
                    }
                    gn(r, h);
                    x();
                    return true;
                }
                if (r instanceof qn) {
                    r.expression.walk(h);
                    var s = l;
                    r.body.forEach(function(e) {
                        if (e instanceof Nn) return;
                        e.expression.walk(h);
                        if (s === l) w();
                    });
                    l = s;
                    r.body.forEach(function(e) {
                        w();
                        l.block = r;
                        var n = l;
                        en(e, h);
                        if (l.inserted === r) l = n;
                        x();
                    });
                    return true;
                }
                if (r instanceof Dt) {
                    k(r, true);
                    return true;
                }
                if (r instanceof Pn) {
                    w();
                    l.block = r;
                    en(r, h);
                    x();
                    if (r.bcatch) {
                        if (r.bcatch.argname) r.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof Tt) {
                                var n = e.definition();
                                v[n.id] = false;
                                if (n = n.redefined()) v[n.id] = false;
                            }
                        }, h);
                        w();
                        if (r.bfinally) l.block = r.bcatch;
                        en(r.bcatch, h);
                        x();
                    }
                    if (r.bfinally) r.bfinally.walk(h);
                    return true;
                }
                if (r instanceof nt) {
                    if (!Jt[r.operator]) return;
                    var u = r.expression;
                    if (!(u instanceof Dt)) return;
                    k(u, true);
                    return true;
                }
                if (r instanceof Vn) {
                    if (r.value) r.value.walk(h);
                    r.name.mark_symbol(r.value ? function(e) {
                        if (!(e instanceof bt)) return;
                        if (e instanceof xt) {
                            k(e);
                        } else {
                            v[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof bt)) return;
                        var n = e.definition().id;
                        if (!(e instanceof xt)) {
                            v[n] = false;
                        } else if (!(n in v)) {
                            d.add(n, e);
                        } else if (v[n]) {
                            v[n].push(e);
                        }
                        return true;
                    }, h);
                    return true;
                }
                if (r instanceof fn) {
                    w();
                    l.block = r;
                    l.loop = true;
                    e();
                    x();
                    return true;
                }
            });
            h.directives = Object.create(a.directives);
            c.walk(h);
            var e = Object.create(null);
            while (o.length && s.length) {
                var n = o.pop();
                var t = n.definition;
                if (!(t.id in u)) continue;
                if (!v[t.id]) continue;
                var i = {
                    start: v[t.id].start
                };
                while (t.id in e) t = e[t.id];
                i.end = v[t.id].end;
                var r = [];
                do {
                    var m = s.pop();
                    if (!m) continue;
                    if (m.index > n.index) continue;
                    var _ = m.definition.id;
                    var g = v[_];
                    if (!g) continue;
                    if (i.start.block !== g.start.block || !T(i, g) || i.start.loop && !T(g, i) || !Be(g, function(e) {
                        return e.scope.find_variable(t.name) === t;
                    })) {
                        r.unshift(m);
                        continue;
                    }
                    var b = [], y = [];
                    g.forEach(function(e) {
                        e.thedef = t;
                        e.name = t.name;
                        if (e instanceof Dt) {
                            y.push(e);
                        } else {
                            b.push(e);
                        }
                    });
                    t.orig = b.concat(t.orig);
                    t.references = y.concat(t.references);
                    t.fixed = m.definition.fixed && t.fixed;
                    e[_] = t;
                    break;
                } while (s.length);
                if (r.length) s = s.concat(r);
            }
            function w() {
                l = Object.create(l);
            }
            function x() {
                l = Object.getPrototypeOf(l);
            }
            function k(e, n) {
                var t = e.definition(), i;
                if (t.id in v) {
                    var r = v[t.id];
                    if (!r) return;
                    if (r.start.block !== l.block) return v[t.id] = false;
                    r.push(e);
                    r.end = l;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!n) {
                        return;
                    }
                } else if ((i = c.variables.get(t.name)) !== t) {
                    if (i && p === l) v[i.id] = false;
                    return v[t.id] = false;
                } else if (a.exposed(t) || e.name == "arguments" || e.name == "await") {
                    return v[t.id] = false;
                } else {
                    var r = d.get(t.id) || [];
                    r.push(e);
                    v[t.id] = r;
                    if (!n) {
                        r.start = l;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (l.block !== c) return v[t.id] = false;
                    r.start = p;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function E(e) {
                var n = [];
                while (true) {
                    if (Le(l, "block")) {
                        var t = l.block;
                        if (t instanceof rn) t = t.body;
                        if (t === e) break;
                    }
                    n.push(l);
                    x();
                }
                l.inserted = l.block;
                w();
                while (n.length) {
                    var i = n.pop();
                    w();
                    if (Le(i, "block")) l.block = i.block;
                    if (Le(i, "loop")) l.loop = i.loop;
                }
            }
            function S(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function T(e, n) {
                return S(e.start, e.end) || S(e.start, n.start);
            }
        });
        function de(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = we(Ht, e);
            }
        }
        pn.DEFMETHOD("drop_unused", function(E) {
            if (!E.option("unused")) return;
            var S = this;
            var T = !(S instanceof dn) || E.toplevel.funcs;
            var D = !(S instanceof dn) || E.toplevel.vars;
            var O = /keep_assign/.test(E.option("unused")) ? je : function(e, n) {
                var t, i = false;
                if (e instanceof ot) {
                    if (e.write_only || e.operator == "=") t = e.left;
                } else if (e instanceof nt) {
                    if (e.write_only) t = e.expression;
                }
                if (/strict/.test(E.option("pure_getters"))) {
                    while (t instanceof Kn && !t.expression.may_throw_on_access(E)) {
                        if (t instanceof Zn) n.unshift(t.property);
                        t = t.expression;
                        i = true;
                    }
                }
                if (!(t instanceof Dt)) return;
                if (E.exposed(t.definition())) return;
                if (!be(t, i)) return;
                return t;
            };
            var A = Object.create(null);
            var d = function(e) {
                d = o(S, 0, Fe);
                return d(e);
                function o(e, n, i) {
                    var t = E.parent(n);
                    if (!t) return i;
                    if (t instanceof lt) {
                        var r = E.parent(n + 1);
                        if (t.key === e) {
                            var a = E.parent(n + 2);
                            if (a instanceof vn) {
                                return o(a, n + 3, a.argnames.indexOf(r) >= 0 ? function(e) {
                                    var n = i(e);
                                    if (n) return n;
                                    n = a.variables.get(e);
                                    if (n) {
                                        var t = n.orig[0];
                                        if (t instanceof kt || t instanceof St) return n;
                                    }
                                } : function(e) {
                                    return i(e) || a.variables.get(e);
                                });
                            }
                        }
                        return o(r, n + 2, i);
                    }
                    return o(t, n + 1, t.variables ? function(e) {
                        return i(e) || t.variables.get(e);
                    } : i);
                }
            };
            var $ = Object.create(null);
            var v = [];
            var z = Object.create(null);
            var h = Object.create(null);
            var m = Object.create(null);
            var M = Object.create(null);
            if (S instanceof dn && E.top_retain) {
                S.variables.each(function(e) {
                    if (E.top_retain(e) && !(e.id in z)) {
                        z[e.id] = true;
                        v.push(e);
                    }
                });
            }
            var _ = new Ye();
            var g = new Ye();
            var F = this;
            var b = new Bt(function(a, e) {
                if (a instanceof vn && a.uses_arguments && !b.has_directive("use strict")) {
                    a.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in z)) {
                            z[n.id] = true;
                            v.push(n);
                        }
                    });
                }
                if (a === S) return;
                if (F === S) {
                    if (En(a)) {
                        var n = a.name.definition();
                        if (!T && !(n.id in z)) {
                            z[n.id] = true;
                            v.push(n);
                        }
                        g.add(n.id, a);
                        return true;
                    }
                    if (a instanceof Un) {
                        a.definitions.forEach(function(i) {
                            var r = i.value && (i.name instanceof ut || i.value.has_side_effects(E));
                            i.name.mark_symbol(function(e) {
                                if (!(e instanceof bt)) return;
                                var n = e.definition();
                                M[n.id] = (M[n.id] || 0) + 1;
                                if (a instanceof Ln && n.orig[0] instanceof Tt) {
                                    var t = n.redefined();
                                    if (t) M[t.id] = (M[t.id] || 0) + 1;
                                }
                                if (!(n.id in z) && (!D || (a instanceof Bn ? n.redefined() : n.const_redefs) || !(a instanceof Ln || G(n)))) {
                                    z[n.id] = true;
                                    v.push(n);
                                }
                                if (i.value) {
                                    if (!r) g.add(n.id, i.value);
                                    _.add(n.id, i);
                                }
                                return true;
                            }, b);
                            if (r) i.value.walk(b);
                        });
                        return true;
                    }
                    if (a instanceof kt) {
                        var n = a.definition();
                        M[n.id] = (M[n.id] || 0) + 1;
                        _.add(n.id, a);
                        return true;
                    }
                }
                return t(a, e, true);
            });
            b.directives = Object.create(E.directives);
            S.walk(b);
            b = new Bt(t);
            for (var e = 0; e < v.length; e++) {
                var n = g.get(v[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(b);
                });
            }
            Object.keys(A).forEach(function(e) {
                var t = A[e];
                if (!t) {
                    delete A[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Pe(n, e);
                    });
                    return n;
                }, []);
                var n = (_.get(e) || []).filter(function(n) {
                    return Me(n instanceof nt ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof nt) return false;
                        return i(e) === i(n);
                    }, t);
                });
                if (t.length == n.length) {
                    A[e] = n;
                } else {
                    delete A[e];
                }
            });
            var j = E.option("keep_fnames") ? je : E.option("ie8") ? function(e) {
                return !E.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in z)) return true;
                if (e.orig.length < 2) return false;
                if (e.orig[1] instanceof kt) return true;
                return Be(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            var q = [];
            var C = [];
            var N = [];
            var H = [];
            var P = new Yt(function(i) {
                if (i instanceof Wn) return l(P, i);
                if (i instanceof ut && i.rest) i.rest = i.rest.transform(P);
                if (i instanceof ct) {
                    var e = !i.rest;
                    for (var n = i.elements.length; --n >= 0; ) {
                        var t = i.elements[n].transform(P);
                        if (t) {
                            i.elements[n] = t;
                            e = false;
                        } else if (e) {
                            i.elements.pop();
                        } else {
                            i.elements[n] = we(Ht, i.elements[n]);
                        }
                    }
                    return i;
                }
                if (i instanceof pt) {
                    var r = [];
                    i.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof We) {
                            e.key = e.key.transform(I);
                            n = e.key.has_side_effects(E);
                        }
                        if ((n || i.rest) && c(e.value)) {
                            e.value = e.value.transform(I);
                            r.push(e);
                        } else {
                            var t = e.value.transform(P);
                            if (!t && i.rest) {
                                if (e.value instanceof ct) {
                                    t = we(ct, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = we(pt, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                r.push(e);
                            }
                        }
                    });
                    i.properties = r;
                    return i;
                }
                if (i instanceof bt) return i.definition().id in z ? i : null;
            });
            var I = new Yt(function(d, e, n) {
                var v = I.parent();
                if (D) {
                    var t = [], i = O(d, t);
                    if (i) {
                        var r = i.definition();
                        var a = r.id in z;
                        var o;
                        if (d instanceof ot) {
                            if (!a || d.left === i && Y(r, d) < 0) {
                                o = L(d);
                                if (d.write_only === true) {
                                    o = o.drop_side_effect_free(E) || we(Mt, d, {
                                        value: 0
                                    });
                                }
                            }
                        } else if (!a || d.expression === i && Y(r, d) < 0) {
                            o = we(Mt, d, {
                                value: 0
                            });
                        }
                        if (o) {
                            if (v instanceof Xn && v.tail_node() !== d) {
                                o = o.drop_side_effect_free(E);
                            }
                            if (o) t.push(o);
                            switch (t.length) {
                              case 0:
                                return He.skip;

                              case 1:
                                return xe(E, v, d, t[0].transform(I));

                              default:
                                return ie(d, t.map(function(e) {
                                    return e.transform(I);
                                }));
                            }
                        }
                    } else if (d instanceof it && d.expression instanceof Dt && Y(d.expression.definition(), d) < 0) {
                        return we(tt, d, {
                            operator: "+",
                            expression: d.expression
                        });
                    }
                }
                if (d instanceof Jn) N.push(d);
                if (F !== S) return;
                if (d instanceof vn) {
                    if (T && d !== S && En(d)) {
                        var r = d.name.definition();
                        if (!(r.id in z)) {
                            R(d.name, "Dropping unused function {name}");
                            r.eliminated++;
                            return n ? He.skip : we(Ke, d);
                        }
                    }
                    if (_n(d) && d.name && j(d.name.definition())) {
                        C.push(d);
                    }
                    if (!(d instanceof hn)) {
                        if (d.rest) {
                            d.rest = d.rest.transform(P);
                            if (!(d.uses_arguments && !I.has_directive("use strict")) && (d.rest instanceof ct && d.rest.elements.length == 0 || d.rest instanceof pt && d.rest.properties.length == 0)) {
                                d.rest = null;
                            }
                        }
                        var s = d.argnames;
                        var f = E.drop_fargs(d, v) && !d.rest;
                        var u = f ? -1 : d.length();
                        for (var c = s.length; --c >= 0; ) {
                            var i = s[c];
                            if (!(i instanceof kt)) {
                                var l = i.transform(P);
                                if (l) {
                                    f = false;
                                } else if (f) {
                                    R(i.name, "Dropping unused default argument {name}");
                                    s.pop();
                                } else if (c > u) {
                                    R(i.name, "Dropping unused default argument assignment {name}");
                                    i.name.__unused = true;
                                    s[c] = i.name;
                                } else {
                                    R(i.name, "Dropping unused default argument value {name}");
                                    i.value = we(Mt, i, {
                                        value: 0
                                    });
                                }
                                continue;
                            }
                            var r = i.definition();
                            if (r.id in z) {
                                f = false;
                                if (Y(r, i) < 0) i.__unused = null;
                            } else if (f) {
                                R(i, "Dropping unused function argument {name}");
                                s.pop();
                            } else {
                                i.__unused = true;
                            }
                        }
                        H.push(d);
                    }
                }
                if (d instanceof In && d.argname instanceof ut) {
                    d.argname.transform(P);
                }
                if (d instanceof Un && !(v instanceof cn && v.init === d)) {
                    var h = [], m = [], _ = [];
                    var g = [];
                    var b = 0;
                    var y = d instanceof Ln;
                    d.definitions.forEach(function(n) {
                        if (n.value) n.value = n.value.transform(I);
                        var t = n.value;
                        if (n.name instanceof ut) {
                            var e = V(n.name, t, function(e) {
                                if (!D) return e;
                                if (e.definition().id in z) return e;
                                if (u(e)) return e;
                                if (y && !be(e)) return e;
                                return null;
                            });
                            if (e) {
                                p();
                            } else {
                                t = t.drop_side_effect_free(E);
                                if (t) g.push(t);
                            }
                            return;
                        }
                        var i = n.name.definition();
                        var r = y ? be(n.name) : G(i);
                        if (!r || !D || i.id in z) {
                            if (t && Y(i, n) < 0) {
                                var a = t.write_only;
                                t = t.drop_side_effect_free(E);
                                if (n.value !== t) {
                                    if (t) {
                                        We.warn("Side effects in last use of variable {name} [{file}:{line},{col}]", U(n.name));
                                        g.push(t);
                                    }
                                    t = null;
                                    q.push(n);
                                } else if (t.write_only !== a) {
                                    t.write_only = a;
                                }
                            }
                            var o;
                            if (!t && !(d instanceof Yn)) {
                                if (r && M[i.id] > 1) {
                                    We.info("Dropping declaration of variable {name} [{file}:{line},{col}]", U(n.name));
                                    M[i.id]--;
                                    i.eliminated++;
                                } else {
                                    m.push(n);
                                }
                            } else if (E.option("functions") && !E.option("ie8") && d instanceof Ln && M[i.id] == 1 && i.assignments == 0 && (t instanceof xn || t instanceof kn) && (i.references.length ? Be(i.references, function(e) {
                                return t === e.fixed_value();
                            }) : t === n.name.fixed_value()) && (!t.name || (o = t.name.definition()).assignments == 0 && (o.name == n.name.name || Be(o.references, function(e) {
                                return e.scope.find_variable(n.name.name) === n.name.definition();
                            }))) && l() && c(t, n.name.name)) {
                                We.warn("Declaring {name} as function [{file}:{line},{col}]", U(n.name));
                                var s = we(t instanceof kn ? Tn : Sn, n, t);
                                s.name = we(Et, n.name, n.name);
                                var f = n.name.scope.resolve().def_function(s.name);
                                if (o) o.forEach(function(e) {
                                    e.name = f.name;
                                    e.thedef = f;
                                    e.reference({});
                                });
                                h.push(s);
                            } else {
                                if (r && M[i.id] > 1 && i.orig.indexOf(n.name) > i.eliminated) {
                                    M[i.id]--;
                                    b++;
                                }
                                p();
                            }
                        } else if (u(n.name)) {
                            t = t && t.drop_side_effect_free(E);
                            if (t) g.push(t);
                            if (M[i.id] > 1) {
                                We.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", U(n.name));
                                M[i.id]--;
                                i.eliminated++;
                            } else {
                                n.value = null;
                                m.push(n);
                            }
                        } else {
                            t = t && !t.single_use && t.drop_side_effect_free(E);
                            if (t) {
                                We.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", U(n.name));
                                g.push(t);
                            } else {
                                R(n.name, "Dropping unused variable {name}");
                            }
                            i.eliminated++;
                        }
                        function u(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof Tt && n.scope.resolve() === e.scope.resolve();
                        }
                        function c(e, n) {
                            var t = e.variables.get(n);
                            return !t || e.name && t === e.name.definition();
                        }
                        function l() {
                            if (E.has_directive("use strict")) return v instanceof pn;
                            return v instanceof nn || v instanceof un && v.init === d || v instanceof jn;
                        }
                        function p() {
                            if (g.length > 0) {
                                if (_.length == 0) {
                                    h.push(we(Qe, d, {
                                        body: ie(d, g)
                                    }));
                                } else if (t) {
                                    g.push(t);
                                    n.value = ie(t, g);
                                } else {
                                    n.value = we(tt, n, {
                                        operator: "void",
                                        expression: ie(n, g)
                                    });
                                }
                                g = [];
                            }
                            _.push(n);
                        }
                    });
                    switch (m.length) {
                      case 0:
                        if (_.length == 0) break;
                        if (_.length == b) {
                            [].unshift.apply(g, _.map(function(e) {
                                We.warn("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", U(e.name));
                                var n = e.name.definition();
                                var t = we(Dt, e.name, e.name);
                                n.references.push(t);
                                var i = we(ot, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var r = Y(n, e);
                                if (r >= 0) A[n.id][r] = i;
                                n.eliminated++;
                                return i;
                            }));
                            break;
                        }

                      case 1:
                        if (_.length == 0) {
                            var p = m[0].name.definition().id;
                            if (p in $) {
                                d.definitions = m;
                                $[p].init = d;
                                break;
                            }
                        }

                      default:
                        d.definitions = m.concat(_);
                        h.push(d);
                    }
                    if (g.length > 0) {
                        h.push(we(Qe, d, {
                            body: ie(d, g)
                        }));
                    }
                    return B(h, d, n);
                }
                if (d instanceof ot) {
                    e(d, I);
                    if (d.left instanceof ut) {
                        var w = V(d.left, d.right, function(e) {
                            return e;
                        });
                        if (!w) return d.right;
                        d.left = w;
                    }
                    return d;
                }
                if (d instanceof rn && d.body instanceof un) {
                    e(d, I);
                    if (d.body instanceof tn) {
                        var x = d.body;
                        d.body = x.body.pop();
                        x.body.push(d);
                        return n ? He.splice(x.body) : x;
                    }
                    return d;
                }
                if (d instanceof pn) {
                    var k = F;
                    F = d;
                    e(d, I);
                    F = k;
                    return d;
                }
            }, function(e, n) {
                if (e instanceof tn) {
                    return J(e, n);
                } else if (e instanceof un) {
                    var t;
                    if (e.init instanceof tn) {
                        t = e.init;
                        e.init = t.body.pop();
                        t.body.push(e);
                    }
                    if (e.init instanceof Tn) {
                        if (!t) {
                            t = we(tn, e, {
                                body: [ e ]
                            });
                        }
                        t.body.splice(-1, 0, e.init);
                        e.init = null;
                    } else if (e.init instanceof Qe) {
                        e.init = e.init.body;
                    } else if (oe(e.init)) {
                        e.init = null;
                    }
                    return !t ? e : n ? He.splice(t.body) : t;
                } else if (e instanceof cn) {
                    if (!D || !E.option("loops")) return;
                    if (!oe(e.body)) return;
                    var i = k(e);
                    if (!i) return;
                    var r = i.definition();
                    if (r.id in z) return;
                    R(i, "Dropping unused loop variable {name}");
                    if ($[r.id] === e) delete $[r.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(E);
                    if (o) {
                        We.warn("Side effects in object of for-in loop [{file}:{line},{col}]", o.start);
                        a.push(we(Qe, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof Un && r.orig[0] instanceof Tt) {
                        a.push(e.init);
                    }
                    return B(a, e, n);
                } else if (e instanceof Xn) {
                    if (e.expressions.length == 1) return e.expressions[0];
                }
            });
            I.push(E.parent());
            S.transform(I);
            if (S instanceof vn && S.body.length == 1 && S.body[0] instanceof Xe && S.body[0].value == "use strict") {
                S.body.length = 0;
            }
            q.forEach(function(e) {
                e.value = null;
            });
            C.forEach(function(e) {
                e.name = null;
            });
            N.forEach(function(e) {
                Te(e, E, H);
            });
            function R(e, n) {
                We[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", U(e));
            }
            function U(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function i(e) {
                return e[e instanceof ot ? "right" : "value"];
            }
            function B(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? He.skip : we(Ke, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? He.splice(e) : we(tn, n, {
                        body: e
                    });
                }
            }
            function y(e, n) {
                if (e.scope !== S) return false;
                if (!e.fixed || !n.fixed) A[e.id] = false;
                return A[e.id] !== false;
            }
            function w(e, n) {
                if (!A[e.id]) A[e.id] = [];
                if (n.fixed.assigns) Pe(A[e.id], n.fixed.assigns);
            }
            function Y(e, n) {
                var t = A[e.id];
                return t && t.indexOf(n);
            }
            function x(e, n, t) {
                if (e.id in z) return;
                if (n && t) {
                    z[e.id] = true;
                    v.push(e);
                } else {
                    h[e.id] = n;
                    m[e.id] = t;
                }
            }
            function L(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof rt && Se[n.operator])) return n;
                if (!(n.left instanceof Dt)) return n;
                if (!(e.left instanceof Dt)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(E)) return n;
                if (y(t, n.left)) w(t, n.left);
                return n.right;
            }
            function k(e) {
                var n = e.init;
                if (n instanceof Un) {
                    n = n.definitions[0].name;
                    return n instanceof bt && n;
                }
                while (n instanceof Kn) n = n.expression.tail_node();
                if (n instanceof Dt) return n;
            }
            function t(e, n, t) {
                if (e instanceof ot && e.left instanceof Dt) {
                    var i = e.left.definition();
                    if (i.scope === S) _.add(i.id, e);
                }
                if (e instanceof nt && e.expression instanceof Dt) {
                    var i = e.expression.definition();
                    if (i.scope === S) _.add(i.id, e);
                }
                var r, a = [], o = O(e, a);
                if (o && S.variables.get(o.name) === (r = o.definition()) && !(_e(r) && !Be(S.argnames, function(e) {
                    return !e.match_symbol(function(e) {
                        if (e instanceof kt) {
                            var n = e.definition();
                            return n.references.length > n.replaced;
                        }
                    }, true);
                }))) {
                    a.forEach(function(e) {
                        e.walk(b);
                    });
                    if (e instanceof ot) {
                        if (e.write_only === "p" && e.right.may_throw_on_access(E)) return;
                        var s = L(e);
                        if (t && e.write_only === true && r.scope === S && !s.has_side_effects(E)) {
                            g.add(r.id, s);
                        } else {
                            s.walk(b);
                        }
                        if (e.left === o) {
                            if (!e.write_only) {
                                x(r, true, m[r.id]);
                            }
                        } else {
                            var f = o.fixed_value();
                            if (!f || !f.is_constant()) {
                                x(r, h[r.id], true);
                            }
                        }
                    }
                    if (y(r, o) && Qt(o, e) !== o) w(r, o);
                    return true;
                }
                if (e instanceof cn) {
                    if (e.init instanceof Dt && F === S) {
                        var u = e.init.definition().id;
                        if (!(u in $)) $[u] = e;
                    }
                    if (!D || !E.option("loops")) return;
                    if (!oe(e.body)) return;
                    if (e.init.has_side_effects(E)) return;
                    var o = k(e);
                    if (!o) return;
                    var i = o.definition();
                    if (i.scope !== S) {
                        var c = d(o.name);
                        if (c === i || c && c.redefined() === i) return;
                    }
                    e.object.walk(b);
                    return true;
                }
                if (e instanceof Dt) {
                    r = e.definition();
                    if (!(r.id in z)) {
                        z[r.id] = true;
                        v.push(r);
                    }
                    if (W(r.scope, e.scope)) {
                        var l = r.redefined();
                        if (l && !(l.id in z)) {
                            z[l.id] = true;
                            v.push(l);
                        }
                    }
                    if (y(r, e)) w(r, e);
                    return true;
                }
                if (e instanceof pn) {
                    var p = F;
                    F = e;
                    n();
                    F = p;
                    return true;
                }
            }
            function c(e) {
                return (e instanceof Wn ? e.name : e) instanceof bt;
            }
            function l(e, n) {
                n.value = n.value.transform(I);
                var t = n.name.transform(e);
                if (!t) {
                    var i = n.value.drop_side_effect_free(E);
                    if (!i) return null;
                    t = n.name;
                    if (t instanceof ut) {
                        t = t.clone();
                        t[t instanceof ct ? "elements" : "properties"] = [];
                        if (!(i instanceof ft || i.is_string(E) || t instanceof pt && (i instanceof dt || i.is_boolean(E) || i.is_number(E)))) {
                            i = we(ft, i, {
                                elements: [ i ]
                            });
                        }
                        n.name = t;
                    } else {
                        R(t, "Side effects in default value of unused variable {name}");
                    }
                    n.value = i;
                }
                return n;
            }
            function V(e, s, f) {
                var u = new Yt(function(i) {
                    if (i instanceof Wn) {
                        if (E.option("default_values") && s && s.is_defined(E)) {
                            i = i.name;
                        } else {
                            return l(u, i);
                        }
                    }
                    if (i instanceof ct) {
                        var e = s;
                        if (s instanceof Dt) s = s.fixed_value();
                        var r = s instanceof ft && s.elements;
                        var t = [];
                        i.elements.forEach(function(e, n) {
                            s = r && r[n];
                            if (s instanceof et) s = r = null;
                            if (e instanceof Ht) return;
                            e = e.transform(u);
                            if (e) t[n] = e;
                        });
                        if (i.rest) {
                            if (E.option("rests")) {
                                s = r && we(ft, e, {
                                    elements: r.slice(i.elements.length)
                                });
                                i.rest = i.rest.transform(u);
                            } else {
                                i.rest = i.rest.transform(I);
                            }
                        }
                        s = e;
                        if (i.rest) {
                            t.length = i.elements.length;
                        } else if (r && t.length == 0) {
                            return null;
                        }
                        de(i, t);
                        i.elements = t;
                        return i;
                    }
                    if (i instanceof pt) {
                        var e = s;
                        if (s instanceof Dt) s = s.fixed_value();
                        var r;
                        if (s instanceof dt) {
                            r = Object.create(null);
                            for (var n = 0; n < s.properties.length; n++) {
                                var a = s.properties[n];
                                if (typeof a.key != "string") {
                                    r = null;
                                    break;
                                }
                                r[a.key] = a.value;
                            }
                        }
                        var o = [];
                        i.properties.forEach(function(e) {
                            var n;
                            if (e.key instanceof We) {
                                e.key = e.key.transform(I);
                                s = null;
                                n = e.key.has_side_effects(E);
                            } else {
                                s = r && r[e.key];
                                n = false;
                            }
                            if ((n || i.rest) && c(e.value)) {
                                e.value = e.value.transform(I);
                                o.push(e);
                            } else {
                                var t = e.value.transform(u);
                                if (!t && i.rest) {
                                    if (e.value instanceof ct) {
                                        t = we(ct, e.value, {
                                            elements: []
                                        });
                                    } else {
                                        t = we(pt, e.value, {
                                            properties: []
                                        });
                                    }
                                }
                                if (t) {
                                    e.value = t;
                                    o.push(e);
                                }
                            }
                        });
                        if (i.rest) {
                            if (E.option("rests")) {
                                s = r && we(dt, e, {
                                    properties: []
                                });
                                i.rest = i.rest.transform(u);
                            } else {
                                i.rest = i.rest.transform(I);
                            }
                        }
                        s = e;
                        if (o.length == 0 && !i.rest && s && !s.may_throw_on_access(E)) {
                            return null;
                        }
                        i.properties = o;
                        return i;
                    }
                    return f(i);
                });
                return e.transform(u);
            }
        });
        pn.DEFMETHOD("hoist_declarations", function(r) {
            if (r.has_directive("use asm")) return;
            var a = r.option("hoist_funs");
            var o = r.option("hoist_vars");
            var s = this;
            if (o) {
                var n = 0;
                s.walk(new Bt(function(e) {
                    if (n > 1) return true;
                    if (e instanceof pn && e !== s) return true;
                    if (e instanceof Ln) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) o = false;
            }
            if (!a && !o) return;
            var f = Object.create(null);
            var u = [];
            var c = [];
            var l = new Ye(), p = 0;
            var d = new Yt(function(e) {
                if (e === s) return;
                if (e instanceof Xe) {
                    u.push(e);
                    return we(Ke, e);
                }
                if (a && e instanceof Tn && (d.parent() === s || !r.has_directive("use strict"))) {
                    c.push(e);
                    return we(Ke, e);
                }
                if (o && e instanceof Ln) {
                    if (!Be(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof xt && !f[n.name] && s.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        l.set(e.name.name, e);
                        ++p;
                    });
                    var n = e.to_assignments();
                    var t = d.parent();
                    if (t instanceof cn && t.init === e) {
                        if (n) return n;
                        var i = e.definitions[0].name;
                        return we(Dt, i, i);
                    }
                    if (t instanceof un && t.init === e) return n;
                    if (!n) return we(Ke, e);
                    return we(Qe, e, {
                        body: n
                    });
                }
                if (e instanceof pn) return e;
                if (e instanceof yt) {
                    f[e.name] = true;
                    return e;
                }
            });
            s.transform(d);
            if (p > 0) {
                var v = [];
                l.each(function(e, n) {
                    if (s instanceof vn && !Be(s.argnames, function(e) {
                        return e.name != n;
                    })) {
                        l.del(n);
                    } else {
                        e = e.clone();
                        e.value = null;
                        v.push(e);
                        l.set(n, e);
                    }
                });
                if (v.length > 0) {
                    h(s.body);
                    v = we(Ln, s, {
                        definitions: v
                    });
                    c.push(v);
                }
            }
            s.body = u.concat(c, s.body);
            function h(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof Qe) {
                        var t = n.body, i, r;
                        if (t instanceof ot && t.operator == "=" && (i = t.left) instanceof gt && l.has(i.name)) {
                            var a = l.get(i.name);
                            if (a.value) break;
                            a.value = t.right;
                            Re(v, a);
                            v.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Xn && (r = t.expressions[0]) instanceof ot && r.operator == "=" && (i = r.left) instanceof gt && l.has(i.name)) {
                            var a = l.get(i.name);
                            if (a.value) break;
                            a.value = r.right;
                            Re(v, a);
                            v.push(a);
                            n.body = ie(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof Ke) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof tn && !h(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function O(n, t) {
            n.walk(new Bt(function(e) {
                if (e instanceof An) {
                    t(e);
                    return true;
                }
                if (e instanceof pn && e !== n) return true;
            }));
        }
        function F(e) {
            var i = Object.create(null);
            O(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Dt) {
                    var t = n.definition().id;
                    i[t] = (i[t] || 0) + 1;
                }
            });
            return i;
        }
        function j(e, n, t) {
            return e.bool_fn + (n[e.id] || 0) === e.references.length - e.replaced && !t.exposed(e);
        }
        function q(e, i) {
            O(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = n.is_truthy() || n.evaluate(i, true);
                    if (!t) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? ie(e.value, [ n, we(Mt, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (t && !(t instanceof We)) {
                        n = n.drop_side_effect_free(i);
                        e.value = n ? ie(e.value, [ n, we(Mt, e.value, {
                            value: 1
                        }) ]) : we(Mt, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        pn.DEFMETHOD("process_boolean_returns", Fe);
        Tn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = F(this);
            if (!j(this.name.definition(), n, e)) return;
            q(this, e);
        });
        kn.DEFMETHOD("process_boolean_returns", function(e) {
            if (!e.option("booleans")) return;
            var n = F(this);
            if (this.name && !j(this.name.definition(), n, e)) return;
            var t = e.parent();
            if (t instanceof ot) {
                if (t.operator != "=") return;
                var i = t.left;
                if (!(i instanceof Dt)) return;
                if (!j(i.definition(), n, e)) return;
            } else if (t instanceof Jn && t.expression !== this) {
                var r = t.expression;
                if (r instanceof Dt) r = r.fixed_value();
                if (!(r instanceof vn)) return;
                if (r.uses_arguments || r.pinned()) return;
                var i = r.argnames[t.args.indexOf(this)];
                if (i instanceof Wn) i = i.name;
                if (i instanceof kt && !j(i.definition(), n, e)) return;
            } else if (t.TYPE == "Call") {
                e.pop();
                var a = e.in_boolean_context();
                e.push(this);
                if (!a) return;
            } else return;
            q(this, e);
        });
        Ze.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = Object.create(null);
                this.enclosed.forEach(function(e) {
                    t[e.name] = true;
                });
                this.variables.each(function(e, n) {
                    t[n] = true;
                });
            }
            return t;
        });
        pn.DEFMETHOD("make_var", function(e, n, t) {
            var i = [ this ];
            if (n instanceof bt) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (ze(n, i)) return;
                do {
                    Pe(i, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/(?:^[^a-z_$]|[^a-z0-9_$])/gi, "_");
            var r = t;
            for (var a = 0; !Be(i, function(e) {
                return !e.var_names()[r];
            }); a++) r = t + "$" + a;
            var o = we(e, n, {
                name: r,
                scope: this
            });
            var s = this.def_variable(o);
            i.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names()[r] = true;
            });
            return o;
        });
        pn.DEFMETHOD("hoist_properties", function(e) {
            if (!e.option("hoist_props") || e.has_directive("use asm")) return;
            var f = this;
            var r = f instanceof dn && e.top_retain || je;
            var u = Object.create(null);
            f.transform(new Yt(function(i, e) {
                if (i instanceof ot) {
                    if (i.operator != "=") return;
                    if (!i.write_only) return;
                    if (i.left.scope !== f) return;
                    if (!t(i.left, i.right, 1)) return;
                    e(i, this);
                    var r = new Ye();
                    var a = [];
                    var o = [];
                    i.right.properties.forEach(function(e) {
                        var n = s(i.left, e.key);
                        o.push(we(Vn, i, {
                            name: n,
                            value: null
                        }));
                        var t = we(Dt, i, {
                            name: n.name,
                            scope: f,
                            thedef: n.definition()
                        });
                        t.reference({});
                        a.push(we(ot, i, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    u[i.left.definition().id] = r;
                    f.body.splice(f.body.indexOf(this.stack[1]) + 1, 0, we(Ln, i, {
                        definitions: o
                    }));
                    return ie(i, a);
                }
                if (i instanceof pn) return i === f ? undefined : i;
                if (i instanceof Vn) {
                    if (!t(i.name, i.value, 0)) return;
                    e(i, this);
                    var r = new Ye();
                    var n = [];
                    i.value.properties.forEach(function(e) {
                        n.push(we(Vn, i, {
                            name: s(i.name, e.key),
                            value: e.value
                        }));
                    });
                    u[i.name.definition().id] = r;
                    return He.splice(n);
                }
                function s(e, n) {
                    var t = f.make_var(xt, e, e.name + "_" + n);
                    r.set(n, t.definition());
                    return t;
                }
            }));
            f.transform(new Yt(function(i, e) {
                if (i instanceof rt) return a("right");
                if (i instanceof Kn) {
                    if (!(i.expression instanceof Dt)) return;
                    var n = u[i.expression.definition().id];
                    if (!n) return;
                    var t = n.get(i.getProperty());
                    var r = we(Dt, i, {
                        name: t.name,
                        scope: i.expression.scope,
                        thedef: t
                    });
                    r.reference({});
                    return r;
                }
                if (i instanceof nt) {
                    if (Kt[i.operator]) return;
                    return a("expression");
                }
                function a(e) {
                    var n = i[e];
                    if (!(n instanceof Dt)) return;
                    if (!(n.definition().id in u)) return;
                    var t = i.clone();
                    t[e] = we(dt, n, {
                        properties: []
                    });
                    return t;
                }
            }));
            function t(e, n, t) {
                if (!(e instanceof gt)) return;
                var i = e.definition();
                if (i.assignments != t) return;
                if (i.direct_access) return;
                if (i.escaped.depth == 1) return;
                if (i.references.length - i.replaced == t) return;
                if (i.single_use) return;
                if (r(i)) return;
                if (e.fixed_value() !== n) return;
                return n instanceof dt && n.properties.length > 0 && Be(n.properties, function(e) {
                    return e instanceof ht && typeof e.key == "string";
                }) && Be(i.references, function(e) {
                    return e.fixed_value() === n;
                }) && be(e);
            }
        });
        function ve(e, n) {
            if (!e.name || !n.option("ie8")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return Be(t.references, function(e) {
                return !(e instanceof Dt);
            });
        }
        (function(e) {
            function u(e, n, t, i) {
                var r = e.length;
                if (!r) return null;
                var a = [], o = false;
                for (var s = 0; s < r; s++) {
                    var f = e[s];
                    var u;
                    if (i && f instanceof et) {
                        u = i(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return o ? a.length ? a : null : e;
            }
            function c(e, n, t) {
                var i = e.expression;
                if (!i.is_string(n)) return e;
                return i.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof et ? we(ft, e, {
                    elements: [ e ]
                }) : e;
            }
            e(We, Ce);
            e(hn, Ne);
            e(ft, function(e, n) {
                var t = u(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && Be(t, function(e) {
                    return e instanceof et;
                })) return this;
                return ie(this, t.map(l));
            });
            e(bn, Ne);
            e(ot, function(e) {
                var n = this.left;
                if (n instanceof Kn) {
                    var t = n.expression;
                    if (t instanceof ot && t.operator == "=" && !t.may_throw_on_access(e)) {
                        t.write_only = "p";
                    }
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                this.write_only = true;
                if (ke(n).is_constant_expression(e.find_parent(pn))) {
                    return this.right.drop_side_effect_free(e);
                }
                return this;
            });
            e(wn, Ne);
            e(xn, Ne);
            e(st, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression.drop_side_effect_free(e);
                if (n === this.expression) return this;
                var t = this.clone();
                t.expression = n || we(Mt, this, {
                    value: 0
                });
                return t;
            });
            e(rt, function(e, n) {
                if (this.operator == "in" && !De(this.right)) {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (t === this.left) return this;
                    var i = this.clone();
                    i.left = t || we(Mt, this.left, {
                        value: 0
                    });
                    return i;
                }
                var r = this.right.drop_side_effect_free(e, n);
                if (!r) return this.left.drop_side_effect_free(e, n);
                if (Se[this.operator] && !(r instanceof kn)) {
                    var i = this;
                    if (r !== i.right) {
                        i = this.clone();
                        i.right = r.drop_side_effect_free(e);
                    }
                    return (n ? s : ce)(i, we(rt, this, {
                        operator: i.operator == "&&" ? "||" : "&&",
                        left: i.left.negate(e, n),
                        right: i.right
                    }));
                } else {
                    var t = this.left.drop_side_effect_free(e, n);
                    if (!t) return r;
                    return ie(this, [ t, r.drop_side_effect_free(e) ]);
                }
            });
            e(Jn, function(t, e) {
                var n = this;
                if (n.is_expr_pure(t)) {
                    if (n.pure) We.warn("Dropping __PURE__ call [{file}:{line},{col}]", n.start);
                    var i = u(n.args, t, e, c);
                    return i && ie(n, i.map(l));
                }
                var r = n.expression;
                if (n.is_call_pure(t)) {
                    var a = n.args.slice();
                    a.unshift(r.expression);
                    a = u(a, t, e, c);
                    return a && ie(n, a.map(l));
                }
                var o;
                if ((mn(r) && !r.value || r instanceof xn || r instanceof kn) && !(r.name && (o = r.name.definition()).references.length > o.replaced)) {
                    r.process_expression(false, function(e) {
                        var n = e.value && e.value.drop_side_effect_free(t, true);
                        return n ? we(Qe, e, {
                            body: n
                        }) : we(Ke, e);
                    });
                    O(r, function(e) {
                        if (e.value) e.value = e.value.drop_side_effect_free(t);
                    });
                    n = n.clone();
                    n.expression = r.clone();
                }
                if (n instanceof Gn) {
                    var s = r;
                    if (s instanceof Dt) s = s.fixed_value();
                    if (s instanceof vn) {
                        s.new = true;
                        var f = Be(s.body, function(e) {
                            return !e.has_side_effects(t);
                        });
                        delete s.new;
                        if (f) {
                            var a = n.args.slice();
                            a.unshift(r);
                            a = u(a, t, e, c);
                            return a && ie(n, a.map(l));
                        }
                        if (!s.contains_this()) return we(Jn, n, n);
                    }
                }
                return n;
            });
            e(at, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var i;
                if (e.option("ie8")) {
                    i = [];
                    if (n instanceof kn) {
                        i.push(n);
                        n = null;
                    }
                    if (t instanceof kn) {
                        i.push(t);
                        t = null;
                    }
                }
                var r;
                if (!n) {
                    r = t ? we(rt, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    r = we(rt, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    r = this.clone();
                    r.consequent = n;
                    r.alternative = t;
                }
                if (!e.option("ie8")) return r;
                if (r) i.push(r);
                return i.length == 0 ? null : ie(this, i);
            });
            e($t, Ne);
            e(Qn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(kn, function(e) {
                return ve(this, e) ? null : this;
            });
            e(dt, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof et) {
                        t.push(e);
                    } else {
                        if (e.key instanceof We) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var i = u(t, e, n, function(e, n, t) {
                    var i = e.expression;
                    return y(i) ? e : i.drop_side_effect_free(n, t);
                });
                if (!i) return null;
                if (i === t && !Be(i, function(e) {
                    return !(e instanceof et);
                })) return this;
                return ie(this, i.map(function(e) {
                    return e instanceof et ? we(dt, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Xn, function(e, n) {
                var t = u(this.expressions, e, n);
                if (!t) return null;
                var i = t.length - 1;
                var r = t[i];
                if (e.option("awaits") && i > 0 && r instanceof st && r.expression.is_constant()) {
                    t = t.slice(0, -1);
                    i--;
                    r.expression = t[i];
                    t[i] = r;
                }
                var a, o, s;
                if (e.option("conditionals") && i > 0 && (a = t[i - 1]) instanceof ot && a.operator == "=" && (s = a.left) instanceof Dt && (o = B(e, s.definition(), a.right, r))) {
                    a = a.clone();
                    a.right = o;
                    t = t.slice(0, -2);
                    t.push(a);
                }
                return t === this.expressions ? this : ie(this, t);
            });
            e(Zn, function(e, n) {
                if (this.expression.may_throw_on_access(e)) return this;
                var t = this.expression.drop_side_effect_free(e, n);
                if (!t) return this.property.drop_side_effect_free(e, n);
                var i = this.property.drop_side_effect_free(e);
                if (!i) return t;
                return ie(this, [ t, i ]);
            });
            e(Dt, function(e) {
                return this.is_declared(e) && be(this) ? null : this;
            });
            e(At, function(e, n) {
                if (this.tag && !Ae(e, this.tag)) return this;
                var t = this.expressions;
                if (t.length == 0) return null;
                return ie(this, t).drop_side_effect_free(e, n);
            });
            e(Ot, Ne);
            e(nt, function(e, n) {
                var t = this.expression;
                if (Kt[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Dt && be(t)) return null;
                var i = t.drop_side_effect_free(e, n);
                if (n && i && se(i)) {
                    if (i === t && this.operator == "!") return this;
                    return i.negate(e, n);
                }
                return i;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(Qe, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var i = t.drop_side_effect_free(n, true);
                if (!i) {
                    We.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return we(Ke, e);
                }
                if (i !== t) {
                    return we(Qe, e, {
                        body: i
                    });
                }
            }
            return e;
        });
        e(fn, function(e, n) {
            return n.option("loops") ? we(un, e, e).optimize(n) : e;
        });
        function C(n, e, t) {
            if (!t) t = zn;
            var i = false;
            var r = new Bt(function(e) {
                if (i || e instanceof pn) return true;
                if (e instanceof t && r.loopcontrol_target(e) === n) {
                    return i = true;
                }
            });
            if (e instanceof rn) r.push(e);
            r.push(n);
            n.body.walk(r);
            return i;
        }
        e(sn, function(t, e) {
            if (!e.option("loops")) return t;
            var n = t.condition.is_truthy() || t.condition.evaluate(e, true);
            if (!(n instanceof We)) {
                if (n && !C(t, e.parent(), Fn)) return we(un, t, {
                    body: we(tn, t.body, {
                        body: [ t.body, we(Qe, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!C(t, e.parent())) return we(tn, t.body, {
                    body: [ t.body, we(Qe, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof tn && !C(t, e.parent(), Fn)) {
                var i = t.body.body;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a instanceof jn && !a.alternative && a.body instanceof Mn && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = we(rt, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        i.splice(r, 1);
                    } else if (a instanceof Qe) {
                        if (o(a.body)) break;
                        t.condition = ie(t, [ a.body, t.condition ]);
                        i.splice(r, 1);
                    } else if (!z(a)) {
                        break;
                    }
                }
                t.body = J(t.body);
            }
            if (t.body instanceof Ke) return we(un, t, t).optimize(e);
            if (t.body instanceof Qe) return we(un, t, {
                condition: ie(t.condition, [ t.body.body, t.condition ]),
                body: we(Ke, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Bt(function(e) {
                    if (n) return true;
                    if (e instanceof Dt) {
                        if (!ze(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function N(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof Mn || e instanceof Fn && s(e) || e instanceof On)) {
                var i = [];
                if (n.init instanceof Je) {
                    i.push(n.init);
                } else if (n.init) {
                    i.push(we(Qe, n.init, {
                        body: n.init
                    }));
                }
                var r = s(e) || e instanceof On;
                if (n.condition && r) {
                    i.push(we(jn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    i.push(we(Qe, n.condition, {
                        body: n.condition
                    }));
                } else if (r) {
                    i.push(e);
                }
                k(t, n.body, i);
                return we(tn, n, {
                    body: i
                });
            }
            if (e instanceof jn) {
                var a = o(e.body);
                if (a instanceof Mn && !s(a)) {
                    if (n.condition) {
                        n.condition = we(rt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var i = A(e.alternative);
                    k(t, e.body, i);
                    return f(i);
                }
                a = o(e.alternative);
                if (a instanceof Mn && !s(a)) {
                    if (n.condition) {
                        n.condition = we(rt, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var i = A(e.body);
                    k(t, e.alternative, i);
                    return f(i);
                }
            }
            return n;
            function o(e) {
                return e instanceof tn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof tn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = we(tn, n.body, {
                        body: e
                    }).transform(t);
                }
                return N(n, t);
            }
        }
        e(un, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = e.condition.evaluate(n);
                if (t instanceof We) {
                    t = e.condition.is_truthy() || e.condition.evaluate(n, true);
                } else if (t) {
                    e.condition = null;
                } else if (!n.option("dead_code")) {
                    var i = e.condition;
                    e.condition = re(t, e.condition);
                    e.condition = ce(e.condition.transform(n), i);
                }
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (e.init instanceof Je) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(we(Qe, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(we(Qe, e.condition, {
                            body: e.condition
                        }));
                        k(n, e.body, r);
                        return we(tn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (e.condition && !(t instanceof We)) {
                    e.body = we(tn, e.body, {
                        body: [ we(Qe, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return N(e, n);
        });
        e(cn, function(e, n) {
            if (n.option("varify") && (e.init instanceof Bn || e.init instanceof Yn)) {
                var t = e.init.definitions[0].name;
                if ((t instanceof ut || t instanceof wt) && !t.match_symbol(function(e) {
                    if (e instanceof bt) return I(n, e.definition());
                }, true)) {
                    e.init = R(e.init);
                }
            }
            return e;
        });
        function H(e, n, t) {
            if (!(e instanceof rt)) return;
            if (!(e.left instanceof zt)) {
                switch (e.operator) {
                  case "&&":
                    H(e.left, n);
                    H(e.right, n);
                    break;

                  case "||":
                    H(f(e.left), t);
                    H(f(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof tt)) return;
            if (e.right.operator != "typeof") return;
            var i = e.right.expression;
            if (!fe(i)) return;
            var r;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                r = a ? t : n;
                break;

              case "!=":
                r = a ? n : t;
                break;

              default:
                return;
            }
            if (!r) return;
            var o = i.definition();
            var s = new Bt(function(e) {
                if (e instanceof pn) {
                    var n = s.parent();
                    if (n instanceof Jn && n.expression === e) return;
                    return true;
                }
                if (e instanceof Dt && e.definition() === o) e.defined = true;
            });
            r.walk(s);
            function f(e) {
                if (!(e instanceof rt)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        e(jn, function(e, f) {
            if (oe(e.alternative)) e.alternative = null;
            if (!f.option("conditionals")) return e;
            var n = e.condition.evaluate(f);
            if (!f.option("dead_code") && !(n instanceof We)) {
                var t = e.condition;
                e.condition = re(n, t);
                e.condition = ce(e.condition.transform(f), t);
            }
            if (f.option("dead_code")) {
                if (n instanceof We) {
                    n = e.condition.is_truthy() || e.condition.evaluate(f, true);
                }
                if (!n) {
                    We.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var i = [ we(Qe, e.condition, {
                        body: e.condition
                    }) ];
                    k(f, e.body, i);
                    if (e.alternative) i.push(e.alternative);
                    return we(tn, e, {
                        body: i
                    }).optimize(f);
                } else if (!(n instanceof We)) {
                    We.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var i = [ we(Qe, e.condition, {
                        body: e.condition
                    }), e.body ];
                    if (e.alternative) k(f, e.alternative, i);
                    return we(tn, e, {
                        body: i
                    }).optimize(f);
                }
            }
            var r = e.condition.negate(f);
            var a = e.condition.print_to_string().length;
            var o = r.print_to_string().length;
            var s = o < a;
            if (e.alternative && s) {
                s = false;
                e.condition = r;
                var u = e.body;
                e.body = e.alternative || we(Ke, e);
                e.alternative = u;
            }
            var i = [], c = [], l = [];
            var p = m(e.body, i, c, l);
            var d = m(e.alternative, i, c, l);
            if (p && d) {
                if (c.length > 0) i.push(we(Ln, e, {
                    definitions: c
                }));
                if (p.length == 0) {
                    i.push(we(Qe, e.condition, {
                        body: d.length > 0 ? we(rt, e, {
                            operator: "||",
                            left: e.condition,
                            right: ie(e.alternative, d)
                        }).transform(f) : e.condition.clone()
                    }).optimize(f));
                } else if (d.length == 0) {
                    if (a === o && !s && e.condition instanceof rt && e.condition.operator == "||") {
                        s = true;
                    }
                    i.push(we(Qe, e, {
                        body: we(rt, e, {
                            operator: s ? "||" : "&&",
                            left: s ? r : e.condition,
                            right: ie(e.body, p)
                        }).transform(f)
                    }).optimize(f));
                } else {
                    i.push(we(Qe, e, {
                        body: we(at, e, {
                            condition: e.condition,
                            consequent: ie(e.body, p),
                            alternative: ie(e.alternative, d)
                        })
                    }).optimize(f));
                }
                l.forEach(function(e) {
                    e.definition().references.push(e);
                });
                return we(tn, e, {
                    body: i
                }).optimize(f);
            }
            if (oe(e.body)) {
                e = we(jn, e, {
                    condition: r,
                    body: e.alternative,
                    alternative: null
                });
            }
            if (e.body instanceof On && e.alternative instanceof On && e.body.TYPE == e.alternative.TYPE) {
                var v = we(e.body.CTOR, e, {
                    value: we(at, e, {
                        condition: e.condition,
                        consequent: e.body.value || we(Nt, e.body).transform(f),
                        alternative: e.alternative.value || we(Nt, e.alternative).transform(f)
                    })
                });
                if (v instanceof An) {
                    v.in_bool = e.body.in_bool || e.alternative.in_bool;
                }
                return v;
            }
            if (e.body instanceof jn && !e.body.alternative && !e.alternative) {
                e = we(jn, e, {
                    condition: we(rt, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (M(e.body)) {
                if (e.alternative) {
                    var h = e.alternative;
                    e.alternative = null;
                    return we(tn, e, {
                        body: [ e, h ]
                    }).optimize(f);
                }
            }
            if (M(e.alternative)) {
                var i = e.body;
                e.body = e.alternative;
                e.condition = s ? r : e.condition.negate(f);
                e.alternative = null;
                return we(tn, e, {
                    body: [ e, i ]
                }).optimize(f);
            }
            if (f.option("typeofs")) H(e.condition, e.body, e.alternative);
            return e;
            function m(e, n, t, i) {
                if (e == null) return [];
                if (e instanceof tn) {
                    var r = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (En(o)) {
                            n.push(o);
                        } else if (o instanceof Ke) {
                            continue;
                        } else if (o instanceof Qe) {
                            if (!f.option("sequences") && r.length > 0) return;
                            r.push(o.body);
                        } else if (o instanceof Ln) {
                            if (!f.option("sequences") && r.length > 0) return;
                            o.remove_initializers(f, t);
                            o.definitions.forEach(s);
                        } else {
                            return;
                        }
                    }
                    return r;
                }
                if (En(e)) {
                    n.push(e);
                    return [];
                }
                if (e instanceof Ke) return [];
                if (e instanceof Qe) return [ e.body ];
                if (e instanceof Ln) {
                    var r = [];
                    e.remove_initializers(f, t);
                    e.definitions.forEach(s);
                    return r;
                }
                function s(e) {
                    if (!e.value) return;
                    r.push(we(ot, e, {
                        operator: "=",
                        left: e.name.convert_symbol(Dt, function(e) {
                            i.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(qn, function(i, t) {
            if (!t.option("switches")) return i;
            var e;
            var n = i.expression.evaluate(t);
            if (!(n instanceof We)) {
                var r = i.expression;
                i.expression = re(n, r);
                i.expression = ce(i.expression.transform(t), r);
            }
            if (!t.option("dead_code")) return i;
            if (n instanceof We) {
                n = i.expression.evaluate(t, true);
            }
            var a = [];
            var o = [];
            var s;
            var f;
            for (var u = 0, c = i.body.length; u < c && !f; u++) {
                e = i.body[u];
                if (e instanceof Nn) {
                    var l = o[o.length - 1];
                    if (s || b(e.body[0], t) && (!l || M(l))) {
                        w(e, l);
                        continue;
                    } else {
                        s = e;
                    }
                } else if (!(n instanceof We)) {
                    var p = e.expression.evaluate(t);
                    if (!(p instanceof We) && p !== n) {
                        w(e, o[o.length - 1]);
                        continue;
                    }
                    if (p instanceof We) p = e.expression.evaluate(t, true);
                    if (p === n) {
                        f = e;
                        if (s) {
                            var d = o.indexOf(s);
                            o.splice(d, 1);
                            w(s, o[d - 1]);
                            s = null;
                        }
                    }
                }
                if (M(e)) {
                    var l = o[o.length - 1];
                    if (M(l) && l.body.length == e.body.length && we(tn, l, l).equivalent_to(we(tn, e, e))) {
                        l.body = [];
                    }
                }
                o.push(e);
            }
            while (u < c) w(i.body[u++], o[o.length - 1]);
            while (e = o[o.length - 1]) {
                var v = e.body[e.body.length - 1];
                if (b(v, t)) e.body.pop();
                if (e === s) {
                    if (!x(e)) break;
                } else if (e.expression.has_side_effects(t)) {
                    break;
                } else if (s) {
                    if (!x(s)) break;
                    if (o[o.length - 2] !== s) break;
                    s.body = s.body.concat(e.body);
                    e.body = [];
                } else if (!x(e)) break;
                w(e);
                if (o.pop() === s) s = null;
            }
            if (o.length == 0) {
                return we(tn, i, {
                    body: a.concat(we(Qe, i.expression, {
                        body: i.expression
                    }))
                }).optimize(t);
            }
            o[0].body = a.concat(o[0].body);
            i.body = o;
            if (t.option("conditionals")) switch (o.length) {
              case 1:
                if (!y(o[0])) break;
                var p = o[0].expression;
                var h = o[0].body.slice();
                if (o[0] !== s && o[0] !== f) return we(jn, i, {
                    condition: we(rt, i, {
                        operator: "===",
                        left: i.expression,
                        right: p
                    }),
                    body: we(tn, i, {
                        body: h
                    }),
                    alternative: null
                }).optimize(t);
                if (p) h.unshift(we(Qe, p, {
                    body: p
                }));
                h.unshift(we(Qe, i.expression, {
                    body: i.expression
                }));
                return we(tn, i, {
                    body: h
                }).optimize(t);

              case 2:
                if (!ze(s, o) || !y(o[1])) break;
                var h = o[0].body.slice();
                var m = h.length && b(h[h.length - 1], t);
                if (m) h.pop();
                if (!Be(h, y)) break;
                var _ = o[1].body.length && we(tn, o[1], o[1]);
                var g = we(jn, i, {
                    condition: we(rt, i, o[0] === s ? {
                        operator: "!==",
                        left: i.expression,
                        right: o[1].expression
                    } : {
                        operator: "===",
                        left: i.expression,
                        right: o[0].expression
                    }),
                    body: we(tn, o[0], {
                        body: h
                    }),
                    alternative: m && _ || null
                });
                if (!m && _) g = we(tn, i, {
                    body: [ g, _ ]
                });
                return g.optimize(t);
            }
            return i;
            function b(e, n) {
                return e instanceof Mn && n.loopcontrol_target(e) === i;
            }
            function y(e) {
                var n = false;
                var t = new Bt(function(e) {
                    if (n || e instanceof vn || e instanceof Qe) return true;
                    if (b(e, t)) n = true;
                });
                t.push(i);
                e.walk(t);
                return !n;
            }
            function w(e, n) {
                if (n && !M(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    k(t, e, a);
                }
            }
        });
        e(Pn, function(e, n) {
            e.body = u(e.body, n);
            if (n.option("dead_code")) {
                if (x(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof Tt && !be(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        k(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof Ln)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(we(tn, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(we(tn, e.bfinally, e.bfinally).optimize(n));
                    }
                    return we(tn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && x(e.bfinally)) {
                    var t = we(tn, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return we(tn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function P(r) {
            return function(n, t) {
                var i = false;
                this.definitions.forEach(function(e) {
                    if (e.value) i = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof bt) t.push(we(Vn, e, {
                            name: e,
                            value: r(n, e)
                        }));
                    }, true);
                });
                return i;
            };
        }
        Bn.DEFMETHOD("remove_initializers", P(function(e, n) {
            return we(Nt, n).optimize(e);
        }));
        Yn.DEFMETHOD("remove_initializers", P(Ne));
        Ln.DEFMETHOD("remove_initializers", P(Ne));
        Un.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, n) {
                var t = n.name.definition();
                if (n.value) {
                    var i = we(Dt, n.name, n.name);
                    e.push(we(ot, n, {
                        operator: "=",
                        left: i,
                        right: n.value
                    }));
                    t.references.push(i);
                }
                t.eliminated++;
                t.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return ie(this, e);
        });
        function G(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof St ? 3 : 2);
        }
        function I(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var i = n.scope; i !== t; ) {
                i = i.parent_scope;
                if (i.var_names()[n.name]) return true;
            }
        }
        function R(e) {
            return we(Ln, e, {
                definitions: e.definitions.map(function(e) {
                    return we(Vn, e, {
                        name: e.name.convert_symbol(xt, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var i = t.scope.resolve();
                            if (t.scope === i) return;
                            t.scope = i;
                            i.variables.set(t.name, t);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function U(e, t) {
            return t.option("varify") && Be(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof bt) {
                        var n = e.definition();
                        return !e.fixed_value() || !G(n) || I(t, n);
                    }
                }, true);
            }) ? R(e) : e;
        }
        e(Bn, U);
        e(Yn, U);
        function he(e, n) {
            var t = e.expression;
            if (!(t instanceof Xn)) return e;
            var i = t.expressions.slice();
            var r = e.clone();
            r.expression = i.pop();
            i.push(r);
            return ie(e, i);
        }
        function Te(e, t, n) {
            var i = e.expression;
            var r = i instanceof Dt ? i.fixed_value() : i;
            if (!(r instanceof vn)) return;
            if (r.uses_arguments) return;
            if (r.pinned()) return;
            if (n && n.indexOf(r) < 0) return;
            var a = e.args;
            if (!Be(a, function(e) {
                return !(e instanceof et);
            })) return;
            var o = r === i && !r.name;
            if (r.rest) {
                if (!(o && t.option("rests"))) return;
                var s = r.argnames.length;
                a = a.slice(0, s);
                while (a.length < s) a.push(we(Nt, e).optimize(t));
                a.push(we(ft, e, {
                    elements: e.args.slice(s)
                }));
                e.args = a;
                r.argnames = r.argnames.concat(r.rest);
                r.rest = null;
            }
            var f = 0, u = 0;
            var c = o && t.option("default_values");
            var l = o && t.drop_fargs(r, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof ct) {
                    return e.elements.length == 0 && !e.rest && n instanceof ft;
                }
                if (e instanceof pt) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.__unused;
            } : je;
            var p = [];
            for (var d = 0; d < a.length; d++) {
                var v = r.argnames[d];
                if (c && v instanceof Wn && a[d].is_defined(t)) {
                    r.argnames[d] = v = v.name;
                }
                if (!v || "__unused" in v) {
                    var h = a[d].drop_side_effect_free(t);
                    if (l(v)) {
                        if (v) r.argnames.splice(d, 1);
                        a.splice(d, 1);
                        if (h) p.push(h);
                        d--;
                        continue;
                    } else if (h) {
                        p.push(h);
                        a[f++] = ie(e, p);
                        p = [];
                    } else if (v) {
                        if (p.length) {
                            a[f++] = ie(e, p);
                            p = [];
                        } else {
                            a[f++] = we(Mt, a[d], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (v && l(v, a[d])) {
                    var h = a[d].drop_side_effect_free(t);
                    r.argnames.splice(d, 1);
                    a.splice(d, 1);
                    if (h) p.push(h);
                    d--;
                    continue;
                } else {
                    p.push(a[d]);
                    a[f++] = ie(e, p);
                    p = [];
                }
                u = f;
            }
            for (;d < r.argnames.length; d++) {
                if (l(r.argnames[d])) r.argnames.splice(d--, 1);
            }
            a.length = u;
            if (!p.length) return;
            var m = ie(e, p);
            a.push(a.length < r.argnames.length ? we(tt, e, {
                operator: "void",
                expression: m
            }) : m);
        }
        e(Jn, function(l, u) {
            var o = l.expression;
            if (u.option("sequences")) {
                if (o instanceof Kn) {
                    var e = he(o, u);
                    if (e !== o) {
                        var n = l.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(u);
                    }
                } else if (!ae(u, o.tail_node())) {
                    var e = he(l, u);
                    if (e !== l) return e.optimize(u);
                }
            }
            if (u.option("unused")) Te(l, u);
            if (u.option("unsafe")) {
                if (fe(o)) switch (o.name) {
                  case "Array":
                    if (l.args.length == 1) {
                        var t = l.args[0];
                        if (t instanceof Mt) try {
                            var i = t.value;
                            if (i > 6) break;
                            var r = Array(i);
                            for (var a = 0; a < i; a++) r[a] = we(Ht, l);
                            return we(ft, l, {
                                elements: r
                            });
                        } catch (e) {
                            We.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: i,
                                file: l.start.file,
                                line: l.start.line,
                                col: l.start.col
                            });
                            break;
                        }
                        if (!t.is_boolean(u) && !t.is_string(u)) break;
                    }
                    return we(ft, l, {
                        elements: l.args
                    });

                  case "Object":
                    if (l.args.length == 0) return we(dt, l, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (l.args.length == 0) return we(zt, l, {
                        value: ""
                    });
                    if (l.args.length == 1) return we(rt, l, {
                        operator: "+",
                        left: we(zt, l, {
                            value: ""
                        }),
                        right: l.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (l.args.length == 0) return we(Mt, l, {
                        value: 0
                    });
                    if (l.args.length == 1) return we(tt, l, {
                        operator: "+",
                        expression: we(rt, l, {
                            operator: "+",
                            left: we(zt, l, {
                                value: ""
                            }),
                            right: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (l.args.length == 0) return we(Rt, l).optimize(u);
                    if (l.args.length == 1) return we(tt, l, {
                        operator: "!",
                        expression: we(tt, l, {
                            operator: "!",
                            expression: l.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var s = [];
                    if (Be(l.args, function(e) {
                        var n = e.evaluate(u);
                        s.unshift(n);
                        return e !== n;
                    })) try {
                        return le(u, l, we(jt, l, {
                            value: RegExp.apply(RegExp, s)
                        }));
                    } catch (e) {
                        We.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: l,
                            file: l.start.file,
                            line: l.start.line,
                            col: l.start.col
                        });
                    }
                    break;
                } else if (o instanceof Qn) switch (o.property) {
                  case "toString":
                    if (l.args.length == 0 && !o.expression.may_throw_on_access(u)) {
                        return we(rt, l, {
                            operator: "+",
                            left: we(zt, l, {
                                value: ""
                            }),
                            right: o.expression
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (o.expression instanceof ft && l.args.length < 2) e: {
                        var f = l.args[0];
                        if (o.expression.elements.length == 0) return f ? ie(l, [ f, we(zt, l, {
                            value: ""
                        }) ]).optimize(u) : we(zt, l, {
                            value: ""
                        });
                        if (f) {
                            f = f.evaluate(u);
                            if (f instanceof We) break e;
                        }
                        var r = [];
                        var c = [];
                        o.expression.elements.forEach(function(e) {
                            var n = e.evaluate(u);
                            if (n !== e) {
                                c.push(n);
                            } else {
                                if (c.length > 0) {
                                    r.push(we(zt, l, {
                                        value: c.join(f)
                                    }));
                                    c.length = 0;
                                }
                                r.push(e);
                            }
                        });
                        if (c.length > 0) r.push(we(zt, l, {
                            value: c.join(f)
                        }));
                        if (r.length == 1) {
                            if (r[0].is_string(u)) return r[0];
                            return we(rt, r[0], {
                                operator: "+",
                                left: we(zt, l, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (f == "") {
                            var t;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                t = r.shift();
                            } else {
                                t = we(zt, l, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return we(rt, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(u);
                        }
                        var p = l.clone();
                        p.expression = p.expression.clone();
                        p.expression.expression = p.expression.expression.clone();
                        p.expression.expression.elements = r;
                        return le(u, l, p);
                    }
                    break;

                  case "charAt":
                    if (l.args.length < 2) {
                        var p = we(Zn, l, {
                            expression: o.expression,
                            property: l.args.length ? we(rt, l.args[0], {
                                operator: "|",
                                left: we(Mt, l, {
                                    value: 0
                                }),
                                right: l.args[0]
                            }) : we(Mt, l, {
                                value: 0
                            })
                        });
                        p.is_string = qe;
                        return p.optimize(u);
                    }
                    break;

                  case "apply":
                    if (l.args.length == 2 && l.args[1] instanceof ft) {
                        var d = l.args[1].elements.slice();
                        d.unshift(l.args[0]);
                        return we(Jn, l, {
                            expression: we(Qn, o, {
                                expression: o.expression,
                                property: "call"
                            }),
                            args: d
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var v = o.expression;
                    if (v instanceof Dt) {
                        v = v.fixed_value();
                    }
                    if (v instanceof vn && !v.contains_this()) {
                        return (l.args.length ? ie(this, [ l.args[0], we(Jn, l, {
                            expression: o.expression,
                            args: l.args.slice(1)
                        }) ]) : we(Jn, l, {
                            expression: o.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && fe(o) && o.name == "Function") {
                if (l.args.length == 0) return we(kn, l, {
                    argnames: [],
                    body: []
                }).init_vars(o.scope);
                if (Be(l.args, function(e) {
                    return e instanceof zt;
                })) {
                    try {
                        var h = "n(function(" + l.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + l.args[l.args.length - 1].value + "})";
                        var m = Xt(h);
                        var _ = {
                            ie8: u.option("ie8")
                        };
                        m.figure_out_scope(_);
                        var g = new Zt(u.options);
                        m = m.transform(g);
                        m.figure_out_scope(_);
                        m.compute_char_frequency(_);
                        m.mangle_names(_);
                        var b;
                        m.walk(new Bt(function(e) {
                            if (b) return true;
                            if (e instanceof vn) {
                                b = e;
                                return true;
                            }
                        }));
                        var h = ei();
                        tn.prototype._codegen.call(b, h);
                        l.args = [ we(zt, l, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), we(zt, l.args[l.args.length - 1], {
                            value: h.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return l;
                    } catch (e) {
                        if (e instanceof Wt) {
                            We.warn("Error parsing code passed to new Function [{file}:{line},{col}]", l.args[l.args.length - 1].start);
                            We.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = o instanceof Dt ? o.fixed_value() : o;
            var w = y instanceof vn && (!yn(y) || u.option("awaits") && u.parent() instanceof st);
            var x = w && y.first_statement();
            var k = 0, E = false;
            var S = !Be(l.args, function(e) {
                return !(e instanceof et);
            });
            var T = w && Be(y.argnames, function(e, n) {
                if (k == 1 && l.args[n] instanceof et) k = 2;
                if (e instanceof Wn) {
                    if (!k) k = 1;
                    var t = k == 1 && l.args[n];
                    if (t && !Ee(t)) k = 2;
                    if (P(e.value)) return false;
                    e = e.name;
                }
                if (e instanceof ut) {
                    E = true;
                    if (P(e)) return false;
                }
                return true;
            });
            var D = T && u.option("inline") && !l.is_expr_pure(u);
            if (D && x instanceof An) {
                var O = x.value;
                if (o === y && (!O || O.is_constant_expression() && U(O))) {
                    return ie(l, R(O)).optimize(u);
                }
            }
            if (w) {
                var A, O, $ = false;
                if (D && !y.uses_arguments && !y.pinned() && !(y.name && _n(y)) && (o === y || !Oe(u, A = o.definition()) && y.is_constant_expression(te(u))) && !S && (O = Y(x)) && !y.contains_this()) {
                    var z = o === y || A.single_use && A.references.length - A.replaced == 1;
                    if (V()) {
                        var d = l.args.slice();
                        var M = [];
                        d.push(O.clone(true).transform(new Yt(function(e) {
                            if (e instanceof Dt) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    M.push(e);
                                    return e;
                                }
                                var t = L(n);
                                var i = d[t];
                                if (!i) return we(Nt, l);
                                d[t] = null;
                                var r = this.parent();
                                return r ? xe(u, r, e, i) : i;
                            }
                        })));
                        var F = y.inlined;
                        if (o !== y) y.inlined = true;
                        var p = ie(l, d.filter(function(e) {
                            return e;
                        })).optimize(u);
                        y.inlined = F;
                        p = xe(u, u.parent(), u.self(), p);
                        if (z || ce(p, l) === p) {
                            M.forEach(function(e) {
                                var n = e.definition();
                                n.references.push(e);
                                if (z) {
                                    n.replaced++;
                                } else {
                                    n.single_use = false;
                                }
                            });
                            return p;
                        }
                    }
                    var j, q, C, N;
                    if (z && X()) {
                        y._squeezed = true;
                        if (o !== y) y.parent_scope = o.scope;
                        var p = ie(l, ne()).optimize(u);
                        return xe(u, u.parent(), u.self(), p);
                    }
                }
                if (u.option("side_effects") && T && Be(y.body, oe) && (y === o ? ve(y, u) : !k && !E && !y.rest) && !(mn(y) && y.value)) {
                    return ie(l, R()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (o instanceof Kn) {
                    var H = o.expression;
                    while (H.expression) {
                        H = H.expression;
                    }
                    if (fe(H) && H.name == "console") {
                        return we(Nt, l).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && u.parent() instanceof Qe && se(l)) {
                return l.negate(u, true);
            }
            return pe(u, l);
            function P(e) {
                var n = false;
                e.walk(new Bt(function(e) {
                    if (n) return true;
                    if (e instanceof Dt && y.variables.get(e.name) === e.definition()) {
                        return n = true;
                    }
                }));
                return n;
            }
            function I(e) {
                return we(Zn, e, {
                    expression: we(Mt, e, {
                        value: 0
                    }),
                    property: we(Mt, e, {
                        value: 0
                    })
                });
            }
            function R(e) {
                var n = l.args.slice();
                var t = k > 1 || E || y.rest;
                if (t || S) n = [ we(ft, l, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Yt(function(i, e) {
                        if (i instanceof Wn) return we(Wn, i, {
                            name: i.name.transform(o) || I(i),
                            value: i.value
                        });
                        if (i instanceof ct) {
                            var t = [];
                            i.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            de(i, t);
                            return we(ct, i, {
                                elements: t
                            });
                        }
                        if (i instanceof pt) {
                            var r = [], a = [];
                            i.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    a.push(n instanceof We ? n : re(n, e));
                                    r.push(we(lt, e, {
                                        key: ie(i, a),
                                        value: t
                                    }));
                                    a = [];
                                } else if (n instanceof We) {
                                    a.push(n);
                                }
                            });
                            if (a.length) r.push(we(lt, i, {
                                key: ie(i, a),
                                value: I(i)
                            }));
                            return we(pt, i, {
                                properties: r
                            });
                        }
                        if (i instanceof kt) return null;
                    });
                    var i = [];
                    y.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) i[n] = e;
                    });
                    var r = y.rest && y.rest.transform(o);
                    if (r) i.length = y.argnames.length;
                    de(y, i);
                    n[0] = we(ot, l, {
                        operator: "=",
                        left: we(ct, y, {
                            elements: i,
                            rest: r
                        }),
                        right: n[0]
                    });
                } else y.argnames.forEach(function(e) {
                    if (e instanceof Wn) n.push(e.value);
                });
                n.push(e || we(Nt, l));
                return n;
            }
            function U(e) {
                if (!yn(N || u.find_parent(pn))) return true;
                var t = true;
                var i = new Bt(function(e) {
                    if (!t) return true;
                    if (e instanceof pn) {
                        if (e === y) return;
                        if (mn(e)) {
                            for (var n = 0; t && n < e.argnames.length; n++) e.argnames[n].walk(i);
                        } else if (En(e) && e.name.name == "await") {
                            t = false;
                        }
                        return true;
                    }
                    if (e instanceof gt && e.name == "await" && e !== y.name) t = false;
                });
                e.walk(i);
                return t;
            }
            function B(e) {
                if (!e) return we(Nt, l);
                if (e instanceof An) return e.value || we(Nt, l);
                if (e instanceof Qe) return we(tt, e, {
                    operator: "void",
                    expression: e.body
                });
            }
            function Y(e) {
                var n = y.body.length;
                if (n < 2) {
                    e = B(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var i = y.body[t];
                    if (i instanceof Ln) {
                        var r = $ || !Be(i.definitions, function(e) {
                            return !e.value;
                        });
                        if (r) {
                            $ = true;
                            if (e) return false;
                        }
                    } else if (i instanceof Sn || i instanceof Tn || i instanceof Ke) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = i;
                    }
                }
                return B(e);
            }
            function L(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function V() {
                if (k || E || $ || y.rest) return;
                if (u.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof kt;
                })) return;
                var r = false;
                var a;
                var o = [];
                var s = false;
                var f = true;
                O.walk(new Bt(function(e, n) {
                    if (r) return true;
                    if (e instanceof rt && Se[e.operator] || e instanceof at) {
                        o = null;
                        return;
                    }
                    if (e instanceof pn) return r = true;
                    if (f && e instanceof gt && e.name == "await") {
                        if (yn(u.find_parent(pn))) return r = true;
                        f = false;
                    }
                    if (e instanceof Dt) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            o = null;
                            return;
                        }
                        if (En(t.init)) return r = true;
                        if (Qt(e, this.parent())) return r = true;
                        var i = L(t);
                        if (!(a < i)) a = i;
                        if (!o) return;
                        if (s) {
                            o = null;
                        } else {
                            o.push(y.argnames[i]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        s = true;
                        return true;
                    }
                }));
                if (r) return;
                var e = l.args.length;
                if (o && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > a && y.argnames[e] === o.pop()) ;
                    e++;
                }
                var n = s && !o && u.find_parent(pn);
                return e <= a || Be(l.args.slice(a, e), n ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function W(e, n) {
                return e[n] || ue[n] || N.var_names()[n];
            }
            function J(n, t, i) {
                var r = false;
                y.each_argname(function(e) {
                    if (r) return;
                    if (e.__unused) return;
                    if (e instanceof Wn) e = e.name;
                    if (!i || W(n, e.name)) return r = true;
                    t[e.name] = true;
                    if (C) C.push(e.definition());
                });
                return !r;
            }
            function G(n, e, t) {
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (En(r)) {
                        if (!t || W(e, r.name.name)) return false;
                        if (!Be(r.enclosed, function(e) {
                            return e.scope === r || !n[e.name];
                        })) return false;
                        continue;
                    }
                    if (!(r instanceof Ln)) continue;
                    if (!t) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var o = r.definitions[a].name;
                        if (W(n, o.name)) return false;
                        if (C) C.push(o.definition());
                    }
                }
                return true;
            }
            function X() {
                var n = Object.create(null);
                var e = 0, t;
                N = u.self();
                do {
                    if (N.variables) N.variables.each(function(e) {
                        n[e.name] = true;
                    });
                    t = N;
                    N = u.parent(e++);
                    if (N instanceof on) {
                        C = [];
                    } else if (N instanceof un) {
                        if (N.init === t) continue;
                        C = [];
                    } else if (N instanceof cn) {
                        if (N.init === t) continue;
                        if (N.object === t) continue;
                        C = [];
                    } else if (N instanceof Dt) {
                        if (N.fixed_value() instanceof pn) return false;
                    }
                } while (!(N instanceof pn));
                q = N.body.indexOf(t) + 1;
                if (!q) return false;
                if (!U(y)) return false;
                var i = o !== y || y.parent_scope.resolve() === N;
                if (N instanceof dn) {
                    if (u.toplevel.vars) {
                        n["arguments"] = true;
                    } else {
                        i = false;
                    }
                }
                var r = u.option("inline");
                j = Object.create(n);
                if (!J(n, j, r >= 2 && i)) return false;
                var a = Object.create(j);
                if (!G(n, a, r >= 3 && i)) return false;
                return !C || C.length == 0 || !$e(y, C);
            }
            function K(e, n, t, i) {
                var r = t.definition();
                N.variables.set(t.name, r);
                N.enclosed.push(r);
                if (!N.var_names()[t.name]) {
                    N.var_names()[t.name] = true;
                    e.push(we(Vn, t, {
                        name: t,
                        value: null
                    }));
                }
                if (!i) return;
                var a = we(Dt, t, t);
                r.references.push(a);
                n.push(we(ot, l, {
                    operator: "=",
                    left: a,
                    right: i
                }));
            }
            function Q(e, n) {
                var t = y.argnames.length;
                for (var i = l.args.length; --i >= t; ) {
                    n.push(l.args[i]);
                }
                var r = [];
                for (i = t; --i >= 0; ) {
                    var a = y.argnames[i];
                    var o;
                    if (a instanceof Wn) {
                        r.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = l.args[i];
                    if (o.__unused || N.var_names()[o.name]) {
                        if (s) n.push(s);
                    } else {
                        var f = we(xt, o, o);
                        o.definition().orig.push(f);
                        if ("__unused" in o) {
                            K(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && C && a === o) s = we(Nt, l);
                            K(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (i = r.length; --i >= 0; ) {
                    var u = r[i];
                    if ("__unused" in u.name) {
                        n.push(u.value);
                    } else {
                        var c = we(Dt, u.name, u.name);
                        u.name.definition().references.push(c);
                        n.push(we(ot, u, {
                            operator: "=",
                            left: c,
                            right: u.value
                        }));
                    }
                }
            }
            function Z(i, r) {
                r.push(we(ot, l, {
                    operator: "=",
                    left: we(ct, l, {
                        elements: y.argnames.map(function(e) {
                            return e.convert_symbol(Dt, n);
                        }),
                        rest: y.rest && y.rest.convert_symbol(Dt, n)
                    }),
                    right: we(ft, l, {
                        elements: l.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = we(xt, n, n);
                    n.definition().orig.push(t);
                    K(i, r, t);
                }
            }
            function ee(e, n) {
                var t = n.length;
                for (var i = 0; i < y.body.length; i++) {
                    var r = y.body[i];
                    if (!(r instanceof Ln)) continue;
                    for (var a = 0; a < r.definitions.length; a++) {
                        var o = r.definitions[a];
                        var s = o.name;
                        var f = s.definition().redefined();
                        if (f) {
                            s = s.clone();
                            s.thedef = f;
                        }
                        K(e, n, s, o.value);
                        if (C && !Le(j, s.name)) {
                            var u = y.variables.get(s.name);
                            var c = we(Dt, s, s);
                            u.references.push(c);
                            n.splice(t++, 0, we(ot, o, {
                                operator: "=",
                                left: c,
                                right: we(Nt, s)
                            }));
                        }
                    }
                }
            }
            function ne() {
                var e = [];
                var n = [];
                if (k > 1 || E || y.rest) {
                    Z(e, n);
                } else {
                    Q(e, n);
                }
                ee(e, n);
                n.push(O);
                var t = y.body.filter(function(e) {
                    if (En(e)) {
                        var n = e.name.definition();
                        N.functions.set(n.name, n);
                        N.variables.set(n.name, n);
                        N.enclosed.push(n);
                        N.var_names()[n.name] = true;
                        return true;
                    }
                });
                t.unshift(q, 0);
                if (e.length) t.push(we(Ln, y, {
                    definitions: e
                }));
                [].splice.apply(N.body, t);
                y.enclosed.forEach(function(e) {
                    if (N.var_names()[e.name]) return;
                    N.enclosed.push(e);
                    N.var_names()[e.name] = true;
                });
                return n;
            }
        });
        e(Gn, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unsafe")) {
                var i = e.expression;
                if (fe(i)) {
                    switch (i.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return we(Jn, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function B(t, i, e, n) {
            if (!(n instanceof rt)) return;
            if (!Se[n.operator]) return;
            if (!(n.right instanceof ot)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Dt)) return;
            if (n.right.left.definition() !== i) return;
            if (e.has_side_effects(t)) return;
            if (!r(n.left)) return;
            if (!r(n.right.right)) return;
            i.replaced++;
            return n.operator == "&&" ? we(at, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : we(at, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function r(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Bt(function(e) {
                    if (n) return true;
                    if (e instanceof Dt && e.definition() === i) return n = true;
                }));
                return !n;
            }
        }
        e(Xn, function(e, a) {
            var r = n();
            var o = r.length - 1;
            i();
            t();
            if (o == 0) {
                e = xe(a, a.parent(), a.self(), r[0]);
                if (!(e instanceof Xn)) e = e.optimize(a);
                return e;
            }
            e.expressions = r;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var i = Ve(a);
                var r = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < r) e = e.drop_side_effect_free(a, i);
                    if (e) {
                        m(t, e);
                        i = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (o > 0 && Ee(r[o], a)) o--;
                if (o < r.length - 1) {
                    r[o] = we(tt, e, {
                        operator: "void",
                        expression: r[o]
                    });
                    r.length = o + 1;
                }
            }
            function i() {
                if (!a.option("conditionals")) return;
                for (var e = 1; e < o; e++) {
                    var n = r[e - 1];
                    if (!(n instanceof ot)) continue;
                    if (n.operator != "=") continue;
                    if (!(n.left instanceof Dt)) continue;
                    var t = n.left.definition();
                    var i = B(a, t, n.right, r[e]);
                    if (!i) continue;
                    n.right = i;
                    r.splice(e, 1);
                    o--;
                }
            }
        });
        e(it, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            return pe(n, e);
        });
        var Y = Ue("+ -");
        var L = Ue("* / %");
        e(tt, function(e, n) {
            var t = e.operator;
            var i = e.expression;
            if (n.option("evaluate") && t == "delete" && !(i instanceof Dt || i instanceof Kn || o(i))) {
                if (i instanceof Xn) {
                    i = i.expressions.slice();
                    i.push(we(Ut, e));
                    return ie(e, i).optimize(n);
                }
                return ie(e, [ i, we(Ut, e) ]).optimize(n);
            }
            if (n.option("sequences") && !(t == "typeof" && fe(i.tail_node()))) {
                var r = he(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("side_effects") && t == "void") {
                i = i.drop_side_effect_free(n);
                if (!i) return we(Nt, e).optimize(n);
                e.expression = i;
                return e;
            }
            if (n.option("booleans")) {
                if (t == "!" && i.is_truthy()) {
                    return ie(e, [ i, we(Rt, e) ]).optimize(n);
                } else if (n.in_boolean_context()) switch (t) {
                  case "!":
                    if (i instanceof tt && i.operator == "!") {
                        return i.expression;
                    }
                    if (i instanceof rt) {
                        e = le(n, e, i.negate(n, Ve(n)));
                    }
                    break;

                  case "typeof":
                    We.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                    var a = [ we(Ut, e) ];
                    if (!(i instanceof Dt && be(i))) a.unshift(i);
                    return ie(e, a).optimize(n);
                }
            }
            if (t == "-" && i instanceof Pt) i = i.transform(n);
            if (n.option("evaluate") && i instanceof rt && Y[t] && L[i.operator] && (i.left.is_constant() || !i.right.has_side_effects(n))) {
                return we(rt, e, {
                    operator: i.operator,
                    left: we(tt, i.left, {
                        operator: t,
                        expression: i.left
                    }),
                    right: i.right
                });
            }
            return t == "-" && (i instanceof Mt || i instanceof Pt) ? e : pe(n, e);
        });
        e(st, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var i = e.expression;
                if (i instanceof st) return i;
                if (i instanceof tt) {
                    if (i.expression instanceof st) return i;
                    if (i.operator == "void") return we(tt, e, {
                        operator: "void",
                        expression: we(st, e, {
                            expression: i.expression
                        })
                    });
                }
            }
            return e;
        });
        rt.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Kn) {
                if (!(this.left.expression instanceof Xn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return ie(this, n);
            }
            if (this.left instanceof Xn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return ie(this, n);
            }
            if (this.right instanceof Xn) {
                if (this.left.has_side_effects(e)) return this;
                var i = this.operator == "=" && this.left instanceof Dt;
                var n = this.right.expressions;
                var r = n.length - 1;
                for (var a = 0; a < r; a++) {
                    if (!i && n[a].has_side_effects(e)) break;
                }
                if (a == r) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return ie(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = ie(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return ie(this, n);
                }
            }
            return this;
        });
        var V = Ue("indexOf lastIndexOf");
        var X = Ue("== === != !== * & | ^");
        function De(e) {
            if (e instanceof ot) return e.operator == "=" && De(e.right);
            if (e instanceof Xn) return De(e.tail_node());
            if (e instanceof Dt) return De(e.fixed_value());
            return e instanceof ft || e instanceof vn || e instanceof Gn || e instanceof dt;
        }
        function K(e, n) {
            if (n instanceof Qn) return K(e, n.expression);
            if (n instanceof Zn) {
                return K(e, n.expression) && K(e, n.property);
            }
            if (n instanceof gt) return true;
            return !n.has_side_effects(e);
        }
        e(rt, function(i, o) {
            function t() {
                return i.left.is_constant() || i.right.is_constant() || !i.left.has_side_effects(o) && !i.right.has_side_effects(o);
            }
            function e(e) {
                if (t()) {
                    if (e) i.operator = e;
                    var n = i.left;
                    i.left = i.right;
                    i.right = n;
                }
            }
            function n() {
                var e = i.right;
                i.left = we(rt, i, {
                    operator: i.operator,
                    left: i.left,
                    right: e.left,
                    start: i.left.start,
                    end: e.left.end
                });
                i.right = e.right;
                i.left = i.left.transform(o);
            }
            if (X[i.operator] && i.right.is_constant() && !i.left.is_constant() && !(i.left instanceof rt && Gt[i.left.operator] >= Gt[i.operator])) {
                e();
            }
            if (o.option("sequences")) {
                var r = i.lift_sequences(o);
                if (r !== i) return r.optimize(o);
            }
            if (o.option("assignments") && Se[i.operator]) {
                var a = i.right;
                if (i.left instanceof Dt && a instanceof ot && a.operator == "=" && i.left.equivalent_to(a.left)) {
                    i.right = a.right;
                    a.right = i;
                    return a;
                }
            }
            if (o.option("comparisons")) switch (i.operator) {
              case "===":
              case "!==":
                if (Ee(i.left, o) && i.right.is_defined(o)) {
                    We.warn("Expression always defined [{file}:{line},{col}]", i.start);
                    return ie(i, [ i.right, we(i.operator == "===" ? Rt : Ut, i) ]).optimize(o);
                }
                var s = true;
                if (i.left.is_string(o) && i.right.is_string(o) || i.left.is_number(o) && i.right.is_number(o) || i.left.is_boolean(o) && i.right.is_boolean(o) || K(o, i.left) && i.left.equivalent_to(i.right)) {
                    i.operator = i.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && Ee(i.left, o)) {
                    i.left = we(qt, i.left);
                } else if (o.option("typeofs") && i.left instanceof zt && i.left.value == "undefined" && i.right instanceof tt && i.right.operator == "typeof") {
                    var f = i.right.expression;
                    if (f instanceof Dt ? f.is_declared(o) : !(f instanceof Kn && o.option("ie8"))) {
                        i.right = f;
                        i.left = we(Nt, i.left).optimize(o);
                        if (i.operator.length == 2) i.operator += "=";
                    }
                } else if (i.left instanceof Dt && i.right instanceof Dt && i.left.definition() === i.right.definition() && De(i.left)) {
                    return we(i.operator[0] == "=" ? Ut : Rt, i).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var u = i.left;
                if (u.operator == i.operator) {
                    u = u.right;
                }
                if (u instanceof rt && u.operator == (i.operator == "&&" ? "!==" : "===") && i.right instanceof rt && u.operator == i.right.operator && (Ee(u.left, o) && i.right.left instanceof qt || u.left instanceof qt && Ee(i.right.left, o)) && !u.right.has_side_effects(o) && u.right.equivalent_to(i.right.right)) {
                    var c = we(rt, i, {
                        operator: u.operator.slice(0, -1),
                        left: we(qt, i),
                        right: u.right
                    });
                    if (u !== i.left) {
                        c = we(rt, i, {
                            operator: i.operator,
                            left: i.left.left,
                            right: c
                        });
                    }
                    return c;
                }
                break;
            }
            var l = o.option("booleans") && o.in_boolean_context();
            if (l) switch (i.operator) {
              case "+":
                var p = i.left.evaluate(o);
                var d = i.right.evaluate(o);
                if (p && typeof p == "string") {
                    We.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return ie(i, [ i.right, we(Ut, i) ]).optimize(o);
                }
                if (d && typeof d == "string") {
                    We.warn("+ in boolean context always true [{file}:{line},{col}]", i.start);
                    return ie(i, [ i.left, we(Ut, i) ]).optimize(o);
                }
                break;

              case "==":
                if (i.left instanceof zt && i.left.value == "" && i.right.is_string(o)) {
                    return we(tt, i, {
                        operator: "!",
                        expression: i.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (i.left instanceof zt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                break;
            }
            var v = o.parent();
            if (o.option("comparisons") && i.is_boolean(o)) {
                if (!(v instanceof rt) || v instanceof ot) {
                    var h = le(o, i, we(tt, i, {
                        operator: "!",
                        expression: i.negate(o, Ve(o))
                    }));
                    if (h !== i) return h;
                }
                switch (i.operator) {
                  case ">":
                    e("<");
                    break;

                  case ">=":
                    e("<=");
                    break;
                }
            }
            if (o.option("conditionals") && Se[i.operator] && i.right instanceof rt && i.operator == i.right.operator) {
                n();
            }
            if (o.option("strings") && i.operator == "+") {
                if (i.right instanceof zt && i.right.value == "" && i.left.is_string(o)) {
                    return i.left.optimize(o);
                }
                if (i.left instanceof zt && i.left.value == "" && i.right.is_string(o)) {
                    return i.right.optimize(o);
                }
                if (i.left instanceof rt && i.left.operator == "+" && i.left.left instanceof zt && i.left.left.value == "" && i.right.is_string(o)) {
                    i.left = i.left.right;
                    return i.optimize(o);
                }
                if (i.right instanceof rt && i.operator == i.right.operator && (i.left.is_string(o) && i.right.is_string(o) || i.right.left.is_string(o) && (i.left.is_constant() || !i.right.right.has_side_effects(o)))) {
                    n();
                }
            }
            if (o.option("evaluate")) {
                var m = true;
                switch (i.operator) {
                  case "&&":
                    var p = D(i.left);
                    if (!p) {
                        We.warn("Condition left of && always false [{file}:{line},{col}]", i.start);
                        return xe(o, v, o.self(), i.left).optimize(o);
                    } else if (!(p instanceof We)) {
                        We.warn("Condition left of && always true [{file}:{line},{col}]", i.start);
                        return ie(i, [ i.left, i.right ]).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l) {
                            We.warn("Boolean && always false [{file}:{line},{col}]", i.start);
                            return ie(i, [ i.left, we(Rt, i) ]).optimize(o);
                        } else i.falsy = true;
                    } else if (!(d instanceof We)) {
                        if (l || v.operator == "&&" && v.left === o.self()) {
                            We.warn("Dropping side-effect-free && [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    }
                    if (i.left.operator == "||") {
                        var _ = i.left.right.evaluate(o, true);
                        if (!_) return we(at, i, {
                            condition: i.left.left,
                            consequent: i.right,
                            alternative: i.left.right
                        }).optimize(o);
                    }
                    break;

                  case "||":
                    var p = D(i.left);
                    if (!p) {
                        We.warn("Condition left of || always false [{file}:{line},{col}]", i.start);
                        return ie(i, [ i.left, i.right ]).optimize(o);
                    } else if (!(p instanceof We)) {
                        We.warn("Condition left of || always true [{file}:{line},{col}]", i.start);
                        return xe(o, v, o.self(), i.left).optimize(o);
                    }
                    var d = i.right.evaluate(o);
                    if (!d) {
                        if (l || v.operator == "||" && v.left === o.self()) {
                            We.warn("Dropping side-effect-free || [{file}:{line},{col}]", i.start);
                            return i.left.optimize(o);
                        }
                    } else if (!(d instanceof We)) {
                        if (l) {
                            We.warn("Boolean || always true [{file}:{line},{col}]", i.start);
                            return ie(i, [ i.left, we(Ut, i) ]).optimize(o);
                        } else i.truthy = true;
                    }
                    if (i.left.operator == "&&") {
                        var _ = i.left.right.is_truthy() || i.left.right.evaluate(o, true);
                        if (_ && !(_ instanceof We)) return we(at, i, {
                            condition: i.left.left,
                            consequent: i.left.right,
                            alternative: i.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (i.left instanceof $t && i.right instanceof rt && i.right.operator == "+" && i.right.left instanceof $t && i.right.is_string(o)) {
                        i = we(rt, i, {
                            operator: "+",
                            left: we(zt, i.left, {
                                value: "" + i.left.value + i.right.left.value,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                    }
                    if (i.right instanceof $t && i.left instanceof rt && i.left.operator == "+" && i.left.right instanceof $t && i.left.is_string(o)) {
                        i = we(rt, i, {
                            operator: "+",
                            left: i.left.left,
                            right: we(zt, i.right, {
                                value: "" + i.left.right.value + i.right.value,
                                start: i.left.right.start,
                                end: i.right.end
                            })
                        });
                    }
                    if (i.right instanceof tt && i.right.operator == "-" && i.left.is_number(o)) {
                        i = we(rt, i, {
                            operator: "-",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }
                    if (i.left instanceof tt && i.left.operator == "-" && t() && i.right.is_number(o)) {
                        i = we(rt, i, {
                            operator: "-",
                            left: i.right,
                            right: i.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && i.left instanceof rt && Gt[i.left.operator] == Gt[i.operator] && i.right.is_constant() && (i.right.is_boolean(o) || i.right.is_number(o)) && i.left.is_number(o) && !i.left.right.is_constant() && (i.left.left.is_boolean(o) || i.left.left.is_number(o))) {
                        i = we(rt, i, {
                            operator: i.left.operator,
                            left: we(rt, i, {
                                operator: i.operator,
                                left: i.right,
                                right: i.left.left
                            }),
                            right: i.left.right
                        });
                        break;
                    }

                  case "-":
                    if (i.right instanceof tt && i.right.operator == "-" && i.left.is_number(o) && i.right.expression.is_number(o)) {
                        i = we(rt, i, {
                            operator: "+",
                            left: i.left,
                            right: i.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    m = o.option("unsafe_math");
                    if (i.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = i[e];
                        if (n instanceof tt && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                i[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (i.operator != "-" && i.operator != "/" && (i.left.is_boolean(o) || i.left.is_number(o)) && (i.right.is_boolean(o) || i.right.is_number(o)) && t() && !(i.left instanceof rt && i.left.operator != i.operator && Gt[i.left.operator] >= Gt[i.operator])) {
                        var g = we(rt, i, {
                            operator: i.operator,
                            left: i.right,
                            right: i.left
                        });
                        if (i.right instanceof $t && !(i.left instanceof $t)) {
                            i = le(o, g, i);
                        } else {
                            i = le(o, i, g);
                        }
                    }
                    if (!m || !i.is_number(o)) break;
                    if (i.right instanceof rt && i.right.operator != "%" && Gt[i.right.operator] == Gt[i.operator] && i.right.is_number(o) && (i.operator != "+" || i.right.left.is_boolean(o) || i.right.left.is_number(o)) && (i.operator != "-" || !i.left.is_negative_zero()) && (i.right.left.is_constant_expression() || !i.right.right.has_side_effects(o)) && !E(i.right.right)) {
                        i = we(rt, i, {
                            operator: S(i.operator, i.right.operator),
                            left: we(rt, i.left, {
                                operator: i.operator,
                                left: i.left,
                                right: i.right.left,
                                start: i.left.start,
                                end: i.right.left.end
                            }),
                            right: i.right.right
                        });
                        if (i.operator == "+" && !i.right.is_boolean(o) && !i.right.is_number(o)) {
                            i.right = we(tt, i.right, {
                                operator: "+",
                                expression: i.right
                            });
                        }
                    }
                    if (i.right instanceof $t && i.left instanceof rt && i.left.operator != "%" && Gt[i.left.operator] == Gt[i.operator] && i.left.is_number(o)) {
                        if (i.left.left instanceof $t) {
                            var u = T(i.left, i.operator, i.left.left, i.right, i.left.left.start, i.right.end);
                            i = T(i, i.left.operator, pe(o, u), i.left.right);
                        } else if (i.left.right instanceof $t) {
                            var b = S(i.left.operator, i.operator);
                            var y = pe(o, T(i.left, b, i.left.right, i.right));
                            if (y.is_constant() && !(i.left.operator == "-" && i.right.value != 0 && +y.value == 0 && i.left.left.is_negative_zero())) {
                                i = T(i, i.left.operator, i.left.left, y);
                            }
                        }
                    }
                    break;
                }
                if (!(v instanceof tt && v.operator == "delete")) {
                    if (i.left instanceof Mt && !i.right.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.left.value == 0) {
                            if (i.right.is_boolean(o)) return we(tt, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                            if (i.right.is_number(o) && !i.right.is_negative_zero()) return i.right;
                        }
                        break;

                      case "*":
                        if (i.left.value == 1) {
                            return i.right.is_number(o) ? i.right : we(tt, i, {
                                operator: "+",
                                expression: i.right
                            }).optimize(o);
                        }
                        break;
                    }
                    if (i.right instanceof Mt && !i.left.is_constant()) switch (i.operator) {
                      case "+":
                        if (i.right.value == 0) {
                            if (i.left.is_boolean(o)) return we(tt, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                            if (i.left.is_number(o) && !i.left.is_negative_zero()) return i.left;
                        }
                        break;

                      case "-":
                        if (i.right.value == 0) {
                            return i.left.is_number(o) ? i.left : we(tt, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;

                      case "/":
                        if (i.right.value == 1) {
                            return i.left.is_number(o) ? i.left : we(tt, i, {
                                operator: "+",
                                expression: i.left
                            }).optimize(o);
                        }
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (i.operator) {
              case "&&":
                H(i.left, i.right, null);
                break;

              case "||":
                H(i.left, null, i.right);
                break;
            }
            if (o.option("unsafe")) {
                var w = O(i.right);
                if (l && w && (i.operator == "==" || i.operator == "!=") && i.left instanceof Mt && i.left.value == 0) {
                    return (i.operator == "==" ? we(tt, i, {
                        operator: "!",
                        expression: i.right
                    }) : i.right).optimize(o);
                }
                var x = O(i.left);
                if (o.option("comparisons") && A()) {
                    var k = we(tt, i, {
                        operator: "!",
                        expression: we(tt, i, {
                            operator: "~",
                            expression: x ? i.left : i.right
                        })
                    });
                    switch (i.operator) {
                      case "<":
                        if (x) break;

                      case "<=":
                      case "!=":
                        k = we(tt, i, {
                            operator: "!",
                            expression: k
                        });
                        break;
                    }
                    return k.optimize(o);
                }
            }
            return pe(o, i);
            function E(e) {
                var n = false;
                e.walk(new Bt(function(e) {
                    if (n) return true;
                    if (e instanceof ot) {
                        if (e.left instanceof Kn) return n = true;
                    } else if (e instanceof nt) {
                        if (Kt[e.operator] && e.expression instanceof Kn) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function S(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function T(e, n, t, i, r, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = we(tt, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!i.is_boolean(o) && !i.is_number(o)) {
                        i = we(tt, i, {
                            operator: "+",
                            expression: i
                        });
                    }
                }
                return we(rt, e, {
                    operator: n,
                    left: t,
                    right: i,
                    start: r,
                    end: a
                });
            }
            function D(e) {
                if (e.truthy) return true;
                if (e.falsy) return false;
                if (e.is_truthy()) return true;
                return e.evaluate(o, true);
            }
            function O(e) {
                return e.TYPE == "Call" && e.expression instanceof Qn && V[e.expression.property];
            }
            function A() {
                switch (i.operator) {
                  case "<=":
                    return w && i.left instanceof Mt && i.left.value == 0;

                  case "<":
                    if (x && i.right instanceof Mt && i.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!w) return false;
                    return i.left instanceof Mt && i.left.value == -1 || i.left instanceof tt && i.left.operator == "-" && i.left.expression instanceof Mt && i.left.expression.value == 1;
                }
            }
        });
        function Oe(e, n) {
            var t = 0, i = e.self();
            do {
                if (i instanceof vn && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(t++));
        }
        e(Dt, function(e, n) {
            if (!n.option("ie8") && fe(e) && !(e.scope.resolve().uses_with && n.find_parent(ln))) {
                switch (e.name) {
                  case "undefined":
                    return we(Nt, e).optimize(n);

                  case "NaN":
                    return we(Ct, e).optimize(n);

                  case "Infinity":
                    return we(Pt, e).optimize(n);
                }
            }
            var t = n.parent();
            if (n.option("reduce_vars") && Qt(n.self(), t) !== n.self()) {
                var i = e.definition();
                var r = e.fixed_value();
                var a = i.single_use && !(t instanceof Jn && t.is_expr_pure(n));
                if (a) {
                    if (r instanceof vn) {
                        if ((i.scope !== e.scope.resolve() || i.in_loop) && (!n.option("reduce_funcs") || i.escaped.depth == 1 || r.inlined)) {
                            a = false;
                        } else if (Oe(n, i)) {
                            a = false;
                        } else if (r.name && r.name.definition() !== i) {
                            a = false;
                        } else if (r.parent_scope !== e.scope.resolve() || ge(i)) {
                            a = r.is_constant_expression(e.scope);
                            if (a == "f") {
                                var o = e.scope;
                                do {
                                    if (En(o) || _n(o)) o.inlined = true;
                                } while (o = o.parent_scope);
                            }
                        } else if (r.name && r.name.name == "await" && yn(r)) {
                            a = false;
                        }
                        if (a) r.parent_scope = e.scope;
                    } else if (!r || !r.is_constant_expression() || r.drop_side_effect_free(n)) {
                        a = false;
                    }
                }
                if (a) {
                    i.single_use = false;
                    r._squeezed = true;
                    r.single_use = true;
                    if (r instanceof Sn) {
                        r = we(xn, r, r);
                        r.name = we(St, r.name, r.name);
                    } else if (r instanceof Tn) {
                        r = we(kn, r, r);
                        r.name = we(St, r.name, r.name);
                    }
                    if (r instanceof vn) {
                        var o = e.scope.resolve();
                        r.enclosed.forEach(function(e) {
                            if (r.variables.has(e.name)) return;
                            if (o.var_names()[e.name]) return;
                            o.enclosed.push(e);
                            o.var_names()[e.name] = true;
                        });
                    }
                    var s;
                    if (i.recursive_refs > 0) {
                        s = r.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        if (!(c instanceof St)) {
                            c = we(St, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s.def_function(c);
                            u.recursive_refs = i.recursive_refs;
                        }
                        s.walk(new Bt(function(e) {
                            if (!(e instanceof Dt)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = u;
                                u.references.push(e);
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (!(t instanceof vn)) return;
                                if (!t.name) return;
                                if (t.name.definition() !== n) return;
                                if (n.scope !== t.name.scope) return;
                                if (r.variables.get(t.name.name) !== n) return;
                                t.name = t.name.clone();
                                var i = s.variables.get(t.name.name) || s.def_function(t.name);
                                e.thedef = i;
                                i.references.push(e);
                            }
                        }));
                    } else {
                        s = r.optimize(n);
                        if (s === r) s = s.transform(new Yt(function(e, n) {
                            if (e instanceof pn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    i.replaced++;
                    return s;
                }
                var l = e.fixed !== i.fixed;
                if (r && (l || i.should_replace !== false)) {
                    var p;
                    if (r instanceof Ot) {
                        if (!ge(i) && g(i)) {
                            p = r;
                        }
                    } else {
                        var d = r.evaluate(n, true);
                        if (d !== r && typeof d != "function" && (typeof d != "object" || d instanceof RegExp && n.option("unsafe_regexp") && !i.cross_loop && g(i))) {
                            p = re(d, r);
                        }
                    }
                    if (p) {
                        if (!l && i.should_replace === undefined) {
                            var v = p.optimize(n).print_to_string().length;
                            if (!b(r)) {
                                v = Math.min(v, r.print_to_string().length);
                            }
                            var h = i.name.length;
                            if (n.option("unused") && !n.exposed(i)) {
                                var m = i.references.length - i.replaced;
                                h += (h + 2 + v) / (m - i.assignments);
                            }
                            var _ = v - Math.floor(h);
                            i.should_replace = _ < n.eval_threshold;
                        }
                        if (l || i.should_replace) {
                            var s;
                            if (b(r)) {
                                s = p.optimize(n);
                                if (s === p) s = s.clone(true);
                            } else {
                                s = ce(p.optimize(n), r);
                                if (s === p || s === r) s = s.clone(true);
                            }
                            i.replaced++;
                            return s;
                        }
                    }
                }
            }
            return e;
            function g(e) {
                var n = e.scope.resolve();
                return Be(e.references, function(e) {
                    return n === e.scope.resolve();
                });
            }
            function b(e) {
                var n;
                e.walk(new Bt(function(e) {
                    if (e instanceof Dt) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Ae(e, n) {
            return e.option("unsafe") && n instanceof Qn && n.property == "raw" && fe(n.expression) && n.expression.name == "String";
        }
        e(At, function(e, n) {
            if (!n.option("templates")) return e;
            if (!e.tag || Ae(n, e.tag)) {
                var t = e.expressions;
                var i = e.strings;
                for (var r = t.length; --r >= 0; ) {
                    var a = t[r];
                    var o = a.evaluate(n);
                    if (o === a) continue;
                    o = ("" + o).replace(/\r|\\|`/g, function(e) {
                        return "\\" + (e == "\r" ? "r" : e);
                    });
                    if (o.length > a.print_to_string().length + 3) continue;
                    var s = i[r] + o + i[r + 1];
                    if (typeof we(At, e, {
                        expressions: [],
                        strings: [ s ],
                        tag: e.tag
                    }).evaluate(n) != typeof we(At, e, {
                        expressions: [ a ],
                        strings: i.slice(r, r + 2),
                        tag: e.tag
                    }).evaluate(n)) continue;
                    t.splice(r, 1);
                    i.splice(r, 2, s);
                }
            }
            return pe(n, e);
        });
        function Q(e, n) {
            return e instanceof Dt || e.TYPE === n.TYPE;
        }
        e(Nt, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = te(n).find_variable("undefined");
                if (t) {
                    var i = we(Dt, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    i.is_undefined = true;
                    return i;
                }
            }
            var r = Qt(n.self(), n.parent());
            if (r && Q(r, e)) return e;
            return we(tt, e, {
                operator: "void",
                expression: we(Mt, e, {
                    value: 0
                })
            });
        });
        e(Pt, function(e, n) {
            var t = Qt(n.self(), n.parent());
            if (t && Q(t, e)) return e;
            if (n.option("keep_infinity") && !t && !te(n).find_variable("Infinity")) {
                return e;
            }
            return we(rt, e, {
                operator: "/",
                left: we(Mt, e, {
                    value: 1
                }),
                right: we(Mt, e, {
                    value: 0
                })
            });
        });
        e(Ct, function(e, n) {
            var t = Qt(n.self(), n.parent());
            if (t && Q(t, e)) return e;
            if (!t && !te(n).find_variable("NaN")) return e;
            return we(rt, e, {
                operator: "/",
                left: we(Mt, e, {
                    value: 0
                }),
                right: we(Mt, e, {
                    value: 0
                })
            });
        });
        function $e(t, n) {
            var i = false;
            var r = new Bt(function(e) {
                if (i) return true;
                if (e instanceof Dt && ze(e.definition(), n)) {
                    return i = true;
                }
            });
            var a = new Bt(function(e) {
                if (i) return true;
                if (e instanceof pn && e !== t) {
                    var n = a.parent();
                    if (n instanceof Jn && n.expression === e) return;
                    e.walk(r);
                    return true;
                }
            });
            t.walk(a);
            return i;
        }
        var Z = Ue("+ - * / % >> << >>> | ^ &");
        var ee = Ue("* | ^ &");
        e(ot, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Kn) {
                    if (a.operator == "=") {
                        if (a.__drop) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof Zn) e.push(a.left.property);
                            e.push(a.right);
                            return ie(a, e).optimize(o);
                        }
                        if (a.left.equivalent_to(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof vn || !o.has_directive("use strict") && n instanceof $t && !n.may_throw_on_access(o)) {
                            return a.left instanceof Qn ? a.right : ie(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof Dt && Be(a.left.definition().orig, function(e) {
                    return !(e instanceof yt);
                })) {
                    var t;
                    if (a.operator == "=" && a.left.equivalent_to(a.right) && !((t = o.parent()) instanceof tt && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return v();
                    var i = a.left.definition();
                    var s = i.scope.resolve();
                    var r = s === o.find_parent(vn);
                    var f = 0, u;
                    t = o.self();
                    do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof ot) {
                            var c = false;
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Kn) return true;
                                if (!c && e instanceof Dt && e.definition() === i) {
                                    if (d(f, t)) return true;
                                    i.fixed = false;
                                    c = true;
                                }
                            })) break;
                            if (c) return v();
                        } else if (t instanceof On) {
                            if (!r) break;
                            if (d(f, t)) break;
                            if ($e(s, [ i ])) break;
                            i.fixed = false;
                            return v();
                        } else if (t instanceof Vn) {
                            if (!(t.name instanceof bt)) continue;
                            if (t.name.definition() !== i) continue;
                            if (d(f, t)) break;
                            i.fixed = false;
                            return v();
                        }
                    } while (t instanceof rt && t.right === u || t instanceof at && t.condition !== u || t instanceof Xn && t.tail_node() === u || t instanceof tt);
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof Dt && a.right instanceof rt) {
                    if (a.right.left instanceof Dt && a.right.left.name == a.left.name && Z[a.right.operator]) {
                        return we(ot, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if (a.right.right instanceof Dt && a.right.right.name == a.left.name && ee[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        return we(ot, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof Mt && a.right.value == 1) {
                    var p = a.operator.slice(0, -1);
                    return we(tt, a, {
                        operator: p + p,
                        expression: a.left
                    });
                }
            }
            return pe(o, a);
            function d(e, n) {
                var t = a.right;
                a.right = we(qt, t);
                var i = n.may_throw(o);
                a.right = t;
                var r;
                while (r = o.parent(e++)) {
                    if (r === s) return false;
                    if (r instanceof Pn) {
                        if (r.bfinally) return true;
                        if (i && r.bcatch) return true;
                    }
                }
            }
            function v() {
                return (a.operator != "=" ? we(rt, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : xe(o, o.parent(), a, a.right)).optimize(o);
            }
        });
        e(at, function(a, n) {
            if (n.option("sequences") && a.condition instanceof Xn) {
                var e = a.condition.expressions.slice();
                a.condition = e.pop();
                e.push(a);
                return ie(a, e);
            }
            if (!n.option("conditionals")) return a;
            var o = a.condition.is_truthy() || a.condition.evaluate(n, true);
            if (!o) {
                We.warn("Condition always false [{file}:{line},{col}]", a.start);
                return ie(a, [ a.condition, a.alternative ]).optimize(n);
            } else if (!(o instanceof We)) {
                We.warn("Condition always true [{file}:{line},{col}]", a.start);
                return ie(a, [ a.condition, a.consequent ]).optimize(n);
            }
            var t = o.negate(n, Ve(n));
            if (le(n, o, t) === t) {
                a = we(at, a, {
                    condition: t,
                    consequent: a.alternative,
                    alternative: a.consequent
                });
                t = o;
                o = a.condition;
            }
            var i = a.consequent;
            var r = a.alternative;
            if (K(n, o)) {
                if (o.equivalent_to(i)) return we(rt, a, {
                    operator: "||",
                    left: o,
                    right: r
                }).optimize(n);
                if (o.equivalent_to(r)) return we(rt, a, {
                    operator: "&&",
                    left: o,
                    right: i
                }).optimize(n);
            }
            var s = i.tail_node();
            if (s instanceof ot) {
                var f = s.operator == "=";
                var u = f ? r.tail_node() : r;
                if ((f || i === s) && u instanceof ot && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof Dt || !o.has_side_effects(n) && w(i) && w(r))) {
                    return we(ot, a, {
                        operator: s.operator,
                        left: s.left,
                        right: we(at, a, {
                            condition: o,
                            consequent: x(i),
                            alternative: x(r)
                        })
                    });
                }
            }
            if (i.equivalent_to(r)) return ie(a, [ o, i ]).optimize(n);
            var c = y(i, r, true);
            if (c) return c;
            var l;
            if (i instanceof Jn && r.TYPE == i.TYPE && (l = g(i, r)) >= 0 && i.expression.equivalent_to(r.expression) && !o.has_side_effects(n) && !i.expression.has_side_effects(n)) {
                var p = i.clone();
                var d = i.args[l];
                p.args[l] = d instanceof et ? we(et, a, {
                    expression: we(at, a, {
                        condition: o,
                        consequent: d.expression,
                        alternative: r.args[l].expression
                    })
                }) : we(at, a, {
                    condition: o,
                    consequent: d,
                    alternative: r.args[l]
                });
                return p;
            }
            if (i instanceof at && i.alternative.equivalent_to(r)) {
                return we(at, a, {
                    condition: we(rt, a, {
                        left: o,
                        operator: "&&",
                        right: i.condition
                    }),
                    consequent: i.consequent,
                    alternative: r
                });
            }
            if (i instanceof at && i.consequent.equivalent_to(r)) {
                return we(at, a, {
                    condition: we(rt, a, {
                        left: t,
                        operator: "||",
                        right: i.condition
                    }),
                    consequent: r,
                    alternative: i.alternative
                });
            }
            if (r instanceof at && i.equivalent_to(r.consequent)) {
                return we(at, a, {
                    condition: we(rt, a, {
                        left: o,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: i,
                    alternative: r.alternative
                });
            }
            if (r instanceof at && i.equivalent_to(r.alternative)) {
                return we(at, a, {
                    condition: we(rt, a, {
                        left: t,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: i
                });
            }
            if ((i instanceof Xn || r instanceof Xn) && i.tail_node().equivalent_to(r.tail_node())) {
                return ie(a, [ we(at, a, {
                    condition: o,
                    consequent: k(i),
                    alternative: k(r)
                }), i.tail_node() ]).optimize(n);
            }
            if (i instanceof rt && i.operator == "&&" && i.right.equivalent_to(r)) {
                return we(rt, a, {
                    operator: "&&",
                    left: we(rt, a, {
                        operator: "||",
                        left: t,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (i instanceof rt && i.operator == "||" && i.right.equivalent_to(r)) {
                return we(rt, a, {
                    operator: "||",
                    left: we(rt, a, {
                        operator: "&&",
                        left: o,
                        right: i.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (r instanceof rt && r.operator == "&&" && r.right.equivalent_to(i)) {
                return we(rt, a, {
                    operator: "&&",
                    left: we(rt, a, {
                        operator: "||",
                        left: o,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            if (r instanceof rt && r.operator == "||" && r.right.equivalent_to(i)) {
                return we(rt, a, {
                    operator: "||",
                    left: we(rt, a, {
                        operator: "&&",
                        left: t,
                        right: r.left
                    }),
                    right: i
                }).optimize(n);
            }
            var v = n.option("booleans") && n.in_boolean_context();
            if (m(i)) {
                if (_(r)) {
                    return h(o);
                }
                return we(rt, a, {
                    operator: "||",
                    left: h(o),
                    right: r
                });
            }
            if (_(i)) {
                if (m(r)) {
                    return h(o.negate(n));
                }
                return we(rt, a, {
                    operator: "&&",
                    left: h(o.negate(n)),
                    right: r
                });
            }
            if (m(r)) {
                return we(rt, a, {
                    operator: "||",
                    left: h(o.negate(n)),
                    right: i
                });
            }
            if (_(r)) {
                return we(rt, a, {
                    operator: "&&",
                    left: h(o),
                    right: i
                });
            }
            if (n.option("typeofs")) H(o, i, r);
            return a;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return we(tt, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Ut || v && e instanceof $t && e.value || e instanceof tt && e.operator == "!" && e.expression instanceof $t && !e.expression.value;
            }
            function _(e) {
                return e instanceof Rt || v && (e instanceof $t && !e.value || e instanceof tt && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof tt && e.operator == "!" && e.expression instanceof $t && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var i = n.args;
                var r = t.length;
                if (r != i.length) return -2;
                for (var a = 0; a < r; a++) {
                    if (!t[a].equivalent_to(i[a])) {
                        for (var o = a + 1; o < r; o++) {
                            if (!t[o].equivalent_to(i[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e instanceof Jn) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Kn || n.expression instanceof Kn) || b(e.expression, n.expression);
                }
                if (e instanceof Qn) return e.property == n.property;
                if (e instanceof Zn) return e.property.equivalent_to(n.property);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && we(at, a, {
                    condition: o,
                    consequent: e,
                    alternative: n
                });
                var i = y(e.expression, n.expression);
                if (!i) return;
                var r = e.clone();
                r.expression = i;
                return r;
            }
            function w(e) {
                return e === e.tail_node() || Be(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof Xn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return ie(e, n);
            }
            function k(e) {
                if (!(e instanceof Xn)) return we(Mt, e, {
                    value: 0
                });
                return ie(e, e.expressions.slice(0, -1));
            }
        });
        e(It, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return we(Mt, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof rt && (t.operator == "==" || t.operator == "!=")) {
                We.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return we(Mt, e, {
                    value: +e.value
                });
            }
            return we(tt, e, {
                operator: "!",
                expression: we(Mt, e, {
                    value: 1 - e.value
                })
            });
        });
        e(et, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof ft && !(n.parent() instanceof dt)) {
                return He.splice(t.elements.map(function(e) {
                    return e instanceof Ht ? we(Nt, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function ne(e, n) {
            if (e instanceof Dt) {
                e = e.fixed_value();
            }
            if (!e) return false;
            if (!(e instanceof vn)) return true;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            return !e.contains_this();
        }
        e(Zn, function(e, t) {
            var n = e.expression;
            var i = e.property;
            if (t.option("properties")) {
                var r = i.evaluate(t);
                if (r !== i) {
                    if (typeof r == "string") {
                        if (r == "undefined") {
                            r = undefined;
                        } else {
                            var a = parseFloat(r);
                            if (a.toString() == r) {
                                r = a;
                            }
                        }
                    }
                    i = e.property = ce(i, re(r, i).transform(t));
                    var o = "" + r;
                    if (Lt(o) && o.length <= i.print_to_string().length + 1) {
                        return we(Qn, e, {
                            expression: n,
                            property: o
                        }).optimize(t);
                    }
                }
            }
            var s = t.parent();
            var f = Qt(t.self(), s);
            var u, c, l;
            if (t.option("arguments") && n instanceof Dt && _e(u = n.definition()) && !n.in_arg && i instanceof Mt && (c = u.scope) === E() && c.uses_arguments < (f ? 2 : 3)) {
                var p = i.value;
                if (s instanceof tt && s.operator == "delete") {
                    if (!u.deleted) u.deleted = [];
                    u.deleted[p] = true;
                }
                var d = c.argnames[p];
                if (u.deleted && u.deleted[p]) {
                    d = null;
                } else if (d) {
                    var v;
                    if (!(d instanceof kt) || d.name == "await" || n.scope.find_variable(d.name) !== (v = d.definition())) {
                        d = null;
                    } else if (t.has_directive("use strict") || c.name || c.rest || !(l instanceof Jn && p < l.args.length) || !Be(c.argnames, function(e) {
                        return e instanceof kt;
                    })) {
                        if (!t.option("reduce_vars") || u.reassigned || v.assignments || v.orig.length > 1) {
                            d = null;
                        }
                    }
                } else if (p < c.argnames.length + 5 && t.drop_fargs(c, l) && !c.rest) {
                    while (p >= c.argnames.length) {
                        d = c.make_var(kt, c, "argument_" + c.argnames.length);
                        c.argnames.push(d);
                    }
                }
                if (d && Me(function(e) {
                    return e.name === d.name;
                }, c.argnames) === d) {
                    u.reassigned = false;
                    var h = we(Dt, e, d);
                    h.reference({});
                    delete d.__unused;
                    return h;
                }
            }
            if (f) return e;
            if (t.option("sequences") && s.TYPE != "Call" && !(s instanceof cn && s.init === e)) {
                var m = he(e, t);
                if (m !== e) return m.optimize(t);
            }
            if (r !== i) {
                var _ = e.flatten_object(o, t);
                if (_) {
                    n = e.expression = _.expression;
                    i = e.property = _.property;
                }
            }
            var g;
            if (t.option("properties") && t.option("side_effects") && i instanceof Mt && n instanceof ft && Be(g = n.elements, function(e) {
                return !(e instanceof et);
            })) {
                var p = i.value;
                var b = g[p];
                if (ne(b, t)) {
                    var y = b instanceof Ht;
                    var w = !y;
                    var x = [];
                    for (var k = g.length; --k > p; ) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                            if (w && a.has_side_effects(t)) w = false;
                        }
                    }
                    if (!w) x.unshift(b);
                    while (--k >= 0) {
                        var a = g[k].drop_side_effect_free(t);
                        if (a) {
                            x.unshift(a);
                        } else if (y) {
                            x.unshift(we(Ht, g[k]));
                        } else {
                            p--;
                        }
                    }
                    if (w) {
                        x.push(b);
                        return ie(e, x).optimize(t);
                    } else return we(Zn, e, {
                        expression: we(ft, n, {
                            elements: x
                        }),
                        property: we(Mt, i, {
                            value: p
                        })
                    });
                }
            }
            return pe(t, e);
            function E() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof vn) {
                        if (n instanceof hn) return;
                        if (mn(n)) continue;
                        l = t.parent(e);
                        return n;
                    }
                }
            }
        });
        bn.DEFMETHOD("contains_this", je);
        wn.DEFMETHOD("contains_this", je);
        pn.DEFMETHOD("contains_this", function() {
            var n;
            var t = this;
            t.walk(new Bt(function(e) {
                if (n) return true;
                if (e instanceof Ot) return n = true;
                if (e !== t && e instanceof pn && !mn(e)) return true;
            }));
            return n;
        });
        Kn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            var t = this.expression;
            if (t instanceof dt) {
                var i = t.properties;
                for (var r = i.length; --r >= 0; ) {
                    var a = i[r];
                    if (a.key != e) continue;
                    if (!Be(i, function(e) {
                        return e instanceof ht && typeof e.key == "string";
                    })) break;
                    if (!ne(a.value, n)) break;
                    return we(Zn, this, {
                        expression: we(ft, t, {
                            elements: i.map(function(e) {
                                return e.value;
                            })
                        }),
                        property: we(Mt, this, {
                            value: r
                        })
                    });
                }
            }
        });
        e(Qn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                We.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (Qt(n.self(), t)) return e;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof cn && t.init === e)) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof Qn && e.expression.property == "prototype") {
                var r = e.expression.expression;
                if (fe(r)) switch (r.name) {
                  case "Array":
                    e.expression = we(ft, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = we(kn, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(r.scope);
                    break;

                  case "Number":
                    e.expression = we(Mt, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = we(dt, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = we(jt, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = we(zt, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var a = e.flatten_object(e.property, n);
            if (a) return a.optimize(n);
            return pe(n, e);
        });
        e(ct, function(e, n) {
            if (n.option("rests") && e.rest instanceof ct) {
                e.elements = e.elements.concat(e.rest.elements);
                e.rest = null;
            }
            return e;
        });
        e(lt, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof We) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(dt, function(t, i) {
            if (!i.option("objects")) return t;
            var r = false;
            var a = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = new Ye();
            var u = [];
            t.properties.forEach(function(e) {
                if (!(e instanceof et)) return l(e);
                a = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof dt && Be(n.properties, function(e) {
                    return !(e instanceof _t || e instanceof et);
                })) {
                    r = true;
                    n.properties.forEach(function(e) {
                        l(e instanceof mt ? we(ht, e, {
                            key: e.key,
                            value: we(Nt, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    c();
                    u.push(e);
                }
            });
            c();
            if (!r) return t;
            if (a && o && u.length == 1) {
                var e = u[0];
                if (e instanceof vt && e.key instanceof Mt) {
                    e.key = "" + e.key.value;
                }
            }
            return r ? we(dt, t, {
                properties: u
            }) : t;
            function c() {
                f.each(function(e) {
                    if (e.length == 1) return u.push(e[0]);
                    r = true;
                    var n = s && !o && e.pop();
                    u.push(e.length == 1 ? e[0] : we(ht, t, {
                        key: e[0].key,
                        value: ie(t, e.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (n) u.push(n);
                });
                f = new Ye();
            }
            function l(e) {
                var n = e.key;
                if (n instanceof We) {
                    a = true;
                    n = n.evaluate(i);
                    if (n === e.key) {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (e instanceof ht && typeof n == "string") {
                    if (e.value.has_side_effects(i)) c();
                    f.add(n, e);
                } else {
                    c();
                    u.push(e);
                }
                if (a && !o && typeof n == "string" && D.test(n)) {
                    o = true;
                    if (f.has(n)) e = f.get(n)[0];
                    e.key = we(Mt, e, {
                        value: +n
                    });
                }
            }
        });
        e(An, function(e, n) {
            if (e.value && Ee(e.value, n)) {
                e.value = null;
            }
            return e;
        });
    })(function(e, i) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = i(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function te(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function ei(f) {
        var e = !f;
        f = pe(f, {
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie8: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = je;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var t = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, t - 1), f.comments.substr(t + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = te;
            } else {
                u = qe;
            }
        }
        var r = f.indent_start;
        var a = 0;
        var o = 1;
        var c = 0;
        var s = "";
        var l = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, i = 0; t < e.length; t++) {
                var r = e.charCodeAt(t);
                if (Z(r)) {
                    if (ee(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ee(r)) {
                    continue;
                }
                n += e.slice(i, t) + "\\u" + r.toString(16);
                i = t + 1;
            }
            return i == 0 ? e : n + e.slice(i);
        };
        function i(t, e) {
            var i = 0, r = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++i;
                    return '"';

                  case "'":
                    ++r;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie8 ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            function n() {
                return "'" + t.replace(/\x27/g, "\\'") + "'";
            }
            function a() {
                return '"' + t.replace(/\x22/g, '\\"') + '"';
            }
            t = l(t);
            switch (f.quote_style) {
              case 1:
                return n();

              case 2:
                return a();

              case 3:
                return e == "'" ? n() : a();

              default:
                return i > r ? n() : a();
            }
        }
        function p(e, n) {
            var t = i(e, n);
            if (f.inline_script) {
                t = t.replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                t = t.replace(/\x3c!--/g, "\\x3c!--");
                t = t.replace(/--\x3e/g, "--\\x3e");
            }
            return t;
        }
        function d(e) {
            e = e.toString();
            e = l(e, true);
            return e;
        }
        var v = false;
        var h = 0;
        var m = true;
        var _ = false;
        var g = false;
        var b = false;
        var y = false;
        var w = -1;
        var x = "";
        var k, E, S = f.source_map && [];
        var T = S ? function(n, t) {
            S.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Fe;
        var D = S ? function() {
            S.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            S = [];
        } : Fe;
        function O(e) {
            var n = s.lastIndexOf("\n");
            if (h < n) h = n;
            var t = s.slice(0, h);
            var i = s.slice(h);
            T(e, i.length - a);
            o += e;
            c += e;
            a = i.length;
            s = t;
            while (e--) s += "\n";
            s += i;
        }
        var A = f.max_line_len ? function() {
            if (m) {
                if (a > f.max_line_len) {
                    We.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (a > f.max_line_len) O(1);
            m = true;
            D();
        } : Fe;
        var $ = Ue("( [ + * / - , .");
        function z(e) {
            e = String(e);
            var n = e.charAt(0);
            if (b && n) {
                b = false;
                if (n != "\n") {
                    z("\n");
                    F();
                }
            }
            if (y && n) {
                y = false;
                if (!/[\s;})]/.test(n)) {
                    M();
                }
            }
            w = -1;
            var t = x.slice(-1);
            if (g) {
                g = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    if (f.semicolons || $[n]) {
                        s += ";";
                        a++;
                        c++;
                    } else {
                        A();
                        s += "\n";
                        c++;
                        o++;
                        a = 0;
                        if (/^\s+$/.test(e)) {
                            g = true;
                        }
                    }
                    if (!f.beautify) _ = false;
                }
            }
            if (_) {
                if (ne(t) && (ne(n) || n == "\\") || n == "/" && n == t || (n == "+" || n == "-") && n == x || e == "--" && x == "!" || e == "in" && t == "/" || x == "--" && n == ">") {
                    s += " ";
                    a++;
                    c++;
                }
                if (t != "<" || e != "!") _ = false;
            }
            if (k) {
                S.push({
                    token: k,
                    name: E,
                    line: o,
                    col: a
                });
                k = false;
                if (m) D();
            }
            s += e;
            v = e.slice(-1) == "(";
            c += e.length;
            var i = e.split(/\r?\n/), r = i.length - 1;
            o += r;
            a += i[0].length;
            if (r > 0) {
                A();
                a = i[r].length;
            }
            x = e;
        }
        var M = f.beautify ? function() {
            z(" ");
        } : function() {
            _ = true;
        };
        var F = f.beautify ? function(e) {
            z(K(" ", e ? r - (f.indent_level >> 1) : r));
        } : Fe;
        var j = f.beautify ? function(e, n) {
            if (e === true) e = P();
            var t = r;
            r = e;
            var i = n();
            r = t;
            return i;
        } : function(e, n) {
            return n();
        };
        var q = f.max_line_len || f.preserve_line ? function() {
            A();
            h = s.length;
            m = false;
        } : Fe;
        var C = f.beautify ? function() {
            if (w < 0) return z("\n");
            if (s[w] != "\n") {
                s = s.slice(0, w) + "\n" + s.slice(w);
                c++;
                o++;
            }
            w++;
        } : q;
        var N = f.beautify ? function() {
            z(";");
        } : function() {
            g = true;
        };
        function H() {
            if (g) z(";");
            z(";");
        }
        function P() {
            return r + f.indent_level;
        }
        function I(e) {
            var n;
            z("{");
            C();
            j(P(), function() {
                n = e();
            });
            F();
            z("}");
            return n;
        }
        function R(e) {
            z("(");
            q();
            var n = e();
            q();
            z(")");
            return n;
        }
        function U(e) {
            z("[");
            q();
            var n = e();
            q();
            z("]");
            return n;
        }
        function B() {
            q();
            z(",");
            q();
            M();
        }
        function Y() {
            z(":");
            M();
        }
        var L = S ? function(e, n) {
            k = e;
            E = n;
        } : Fe;
        function V() {
            if (!m) A();
            return s;
        }
        function W() {
            var e = s.lastIndexOf("\n");
            return /^ *$/.test(s.slice(e + 1));
        }
        function J(e) {
            var i = this;
            var r = e instanceof On && e.value;
            var a = s(e);
            if (!a) a = [];
            if (r) {
                var o = new Bt(function(e) {
                    var n = o.parent();
                    if (n instanceof On || n instanceof rt && n.left === e || n.TYPE == "Call" && n.expression === e || n instanceof at && n.condition === e || n instanceof Qn && n.expression === e || n instanceof Xn && n.expressions[0] === e || n instanceof Zn && n.expression === e || n instanceof it) {
                        var t = s(e);
                        if (t) a = a.concat(t);
                    } else {
                        return true;
                    }
                });
                o.push(e);
                e.value.walk(o);
            }
            if (c == 0) {
                if (a.length > 0 && f.shebang && a[0].type == "comment5") {
                    z("#!" + a.shift().value + "\n");
                    F();
                }
                var n = f.preamble;
                if (n) {
                    z(n.replace(/\r\n?|[\n\u2028\u2029]|\s*$/g, "\n"));
                }
            }
            a = a.filter(u, e);
            if (a.length == 0) return;
            var t = W();
            a.forEach(function(e, n) {
                if (!t) {
                    if (e.nlb) {
                        z("\n");
                        F();
                        t = true;
                    } else if (n > 0) {
                        M();
                    }
                }
                if (/comment[134]/.test(e.type)) {
                    z("//" + e.value.replace(/[@#]__PURE__/g, " ") + "\n");
                    F();
                    t = true;
                } else if (e.type == "comment2") {
                    z("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    t = false;
                }
            });
            if (!t) {
                if (e.start.nlb) {
                    z("\n");
                    F();
                } else {
                    M();
                }
            }
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!r) return;
                    e.start = n = new Q();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!r) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === i) return;
                t._dumped = i;
                return t;
            }
        }
        function G(e, t) {
            var n = this;
            var i = e.end;
            if (!i) return;
            var r = i[t ? "comments_before" : "comments_after"];
            if (!r || r._dumped === n) return;
            if (!(e instanceof Je || Be(r, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            r._dumped = n;
            var a = s.length;
            r.filter(u, e).forEach(function(e, n) {
                y = false;
                if (b) {
                    z("\n");
                    F();
                    b = false;
                } else if (e.nlb && (n > 0 || !W())) {
                    z("\n");
                    F();
                } else if (n > 0 || !t) {
                    M();
                }
                if (/comment[134]/.test(e.type)) {
                    z("//" + e.value.replace(/[@#]__PURE__/g, " "));
                    b = true;
                } else if (e.type == "comment2") {
                    z("/*" + e.value.replace(/[@#]__PURE__/g, " ") + "*/");
                    y = true;
                }
            });
            if (s.length > a) w = a;
        }
        var X = [];
        return {
            get: V,
            toString: V,
            indent: F,
            should_break: e ? Fe : function() {
                return f.width && a - r >= f.width;
            },
            has_parens: function() {
                return v;
            },
            newline: C,
            print: z,
            space: M,
            comma: B,
            colon: Y,
            last: function() {
                return x;
            },
            semicolon: N,
            force_semicolon: H,
            to_utf8: l,
            print_name: function(e) {
                z(d(e));
            },
            print_string: function(e, n) {
                z(p(e, n));
            },
            next_indent: P,
            with_indent: j,
            with_block: I,
            with_parens: R,
            with_square: U,
            add_mapping: L,
            option: function(e) {
                return f[e];
            },
            prepend_comments: e ? Fe : J,
            append_comments: e || u === je ? Fe : G,
            line: function() {
                return o;
            },
            col: function() {
                return a;
            },
            pos: function() {
                return c;
            },
            push_node: function(e) {
                X.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = X.pop();
                if (e.start && e.start.line > o) {
                    O(e.start.line - o);
                }
            } : function() {
                X.pop();
            },
            parent: function(e) {
                return X[X.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        We.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(i);
            } else {
                i();
            }
            e.pop_node();
            function i() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        We.DEFMETHOD("print_to_string", function(e) {
            var n = ei(e);
            this.print(n);
            return n.get();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(We, je);
        function t(e) {
            if (!e.has_parens() && Ve(e)) return true;
            if (e.option("webkit")) {
                var n = e.parent();
                if (n instanceof Kn && n.expression === this) return true;
            }
            if (e.option("wrap_iife")) {
                var n = e.parent();
                if (n instanceof Jn && n.expression === this) return true;
            }
        }
        n(xn, t);
        n(kn, t);
        function i(e) {
            return !e.has_parens() && Ve(e, true);
        }
        n(dt, i);
        n(nt, function(e) {
            var n = e.parent();
            if (n instanceof rt) return n.operator == "**" && n.left === this;
            return (n instanceof Jn || n instanceof Kn) && n.expression === this;
        });
        n(Xn, function(e) {
            var n = e.parent();
            return n instanceof ft || mn(n) && n.value === this || n instanceof st || n instanceof rt || n instanceof Jn || n instanceof at || n instanceof Wn || n instanceof lt || n instanceof vt || n instanceof Kn && n.expression === this || n instanceof et || n instanceof nt || n instanceof Vn;
        });
        n(rt, function(e) {
            var n = e.parent();
            if (n instanceof st) return true;
            if (n instanceof rt) {
                var t = n.operator, i = Gt[t];
                var r = this.operator, a = Gt[r];
                return i > a || i == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof Jn) return n.expression === this;
            if (n instanceof Kn) return n.expression === this;
            if (n instanceof nt) return true;
        });
        n(Kn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof Gn && t.expression === n) {
                do {
                    n = n.expression;
                } while (n instanceof Kn);
                return n.TYPE == "Call";
            }
        });
        n(Jn, function(e) {
            var n = e.parent();
            if (n instanceof Gn) return n.expression === this;
            if (e.option("webkit")) {
                var t = e.parent(1);
                return this.expression instanceof kn && n instanceof Kn && n.expression === this && t instanceof ot && t.left === n;
            }
        });
        n(Gn, function(e) {
            if (k(this, e)) return false;
            var n = e.parent();
            if (n instanceof Jn) return n.expression === this;
            if (n instanceof Kn) return true;
            if (n instanceof At) return n.tag === this;
        });
        n(Mt, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Kn && n.expression === this && /^0/.test(S(this.value));
        });
        function r(e, n) {
            var t = n.parent();
            if (t instanceof st) return true;
            if (t instanceof rt) return !(t instanceof ot);
            if (t instanceof Jn) return t.expression === e;
            if (t instanceof at) return t.condition === e;
            if (t instanceof Kn) return t.expression === e;
            if (t instanceof At) return t.tag === e;
            if (t instanceof nt) return true;
        }
        n(bn, function(e) {
            return r(this, e);
        });
        n(ot, function(e) {
            if (r(this, e)) return true;
            if (e.option("v8")) return this.left instanceof ut;
            if (this.left instanceof pt) return i(e);
        });
        n(wn, function(e) {
            return r(this, e);
        });
        n(at, function(e) {
            return r(this, e);
        });
        n(st, function(e) {
            var n = e.parent();
            if (n instanceof rt) return n.operator == "**" && n.left === this;
            if (n instanceof Jn) return n.expression === this;
            if (n instanceof Kn) return n.expression === this;
        });
        e(Xe, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(Ge, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function a(e, t, i, n) {
            var r = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof Xe) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof Ke)) {
                        if (e instanceof Qe && e.body instanceof zt) {
                            i.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof Ke) return;
                i.indent();
                e.print(i);
                if (n == r && t) return;
                i.newline();
                if (t) i.newline();
            });
            s = o;
        }
        e(Je, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        e(dn, function(e) {
            a(this.body, true, e, true);
            e.print("");
        });
        e(rn, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(Qe, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function o(e, n) {
            n.print("{");
            n.with_indent(n.next_indent(), function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function f(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    a(e.body, false, n, t);
                });
            } else o(e, n);
        }
        e(tn, function(e) {
            f(this, e);
        });
        e(Ke, function(e) {
            e.semicolon();
        });
        e(sn, function(e) {
            var n = this;
            e.print("do");
            e.space();
            T(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(fn, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            x(n.body, e);
        });
        e(un, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof Un) {
                        n.init.print(e);
                    } else {
                        _(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            e.space();
            x(n.body, e);
        });
        e(cn, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                n.init.print(e);
                e.space();
                e.print("in");
                e.space();
                n.object.print(e);
            });
            e.space();
            x(n.body, e);
        });
        e(ln, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            e.space();
            x(n.body, e);
        });
        function u(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function c(e, n) {
            if (e.argnames.length == 1 && e.argnames[0] instanceof kt && !e.rest) {
                e.argnames[0].print(n);
            } else {
                u(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                f(e, n, true);
            }
        }
        e(bn, function(e) {
            c(this, e);
        });
        e(wn, function(e) {
            e.print("async");
            e.space();
            c(this, e);
        });
        function l(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            u(e, n);
            n.space();
            f(e, n, true);
        }
        e(vn, function(e) {
            e.print("function");
            l(this, e);
        });
        function p(e) {
            e.print("async");
            e.space();
            e.print("function");
            l(this, e);
        }
        e(Sn, p);
        e(xn, p);
        function d(t, i) {
            return function(e) {
                e.print(t);
                var n = this[i];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(An, d("return", "value"));
        e($n, d("throw", "value"));
        e(Mn, d("break", "label"));
        e(Fn, d("continue", "label"));
        function v(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof Bn || t instanceof Yn) || n.option("ie8") && t instanceof sn) return T(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof jn) {
                    if (!t.alternative) {
                        T(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof O) {
                    t = t.body;
                } else break;
            }
            x(e.body, n);
        }
        e(jn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.space();
            if (n.alternative) {
                v(n, e);
                e.space();
                e.print("else");
                e.space();
                if (n.alternative instanceof jn) n.alternative.print(e); else x(n.alternative, e);
            } else {
                x(n.body, e);
            }
        });
        e(qn, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var i = e.body.length - 1;
            if (i < 0) o(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < i && e.body.length > 0) t.newline();
                });
            });
        });
        function h(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(Nn, function(e) {
            e.print("default:");
            h(this, e);
        });
        e(Hn, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            h(n, e);
        });
        e(Pn, function(e) {
            var n = this;
            e.print("try");
            e.space();
            f(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(In, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            f(n, e);
        });
        e(Rn, function(e) {
            e.print("finally");
            e.space();
            f(this, e);
        });
        function m(i) {
            return function(t) {
                var e = this;
                t.print(i);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (n && n.init !== e || !(n instanceof un || n instanceof cn)) t.semicolon();
            };
        }
        e(Bn, m("const"));
        e(Yn, m("let"));
        e(Ln, m("var"));
        function _(e, n, t) {
            var i = false;
            if (t) e.walk(new Bt(function(e) {
                if (i) return true;
                if (e instanceof rt && e.operator == "in") return i = true;
                if (e instanceof pn && !(mn(e) && e.value)) return true;
            }));
            e.print(n, i);
        }
        e(Vn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var i = t instanceof un || t instanceof cn;
                _(n.value, e, i);
            }
        });
        e(Wn, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function g(e, t) {
            if (e.expression instanceof Jn || e.expression instanceof vn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(Jn, function(e) {
            this.expression.print(e);
            g(this, e);
        });
        e(Gn, function(e) {
            var n = this;
            e.print("new");
            e.space();
            n.expression.print(e);
            if (k(n, e)) g(n, e);
        });
        e(Xn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(Qn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var i = n.property;
            if (e.option("ie8") && A[i]) {
                e.print("[");
                e.add_mapping(n.end);
                e.print_string(i);
                e.print("]");
            } else {
                if (t instanceof Mt && t.value >= 0) {
                    if (!/[xa-f.)]/i.test(e.last())) {
                        e.print(".");
                    }
                }
                e.print(".");
                e.add_mapping(n.end);
                e.print_name(i);
            }
        });
        e(Zn, function(e) {
            this.expression.print(e);
            e.print("[");
            this.property.print(e);
            e.print("]");
        });
        e(et, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(tt, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof tt && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(it, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(rt, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(at, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(st, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(ft, function(t) {
            var e = this.elements, i = e.length;
            t.with_square(i > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === i - 1 && e instanceof Ht) t.comma();
                });
                t.space();
            } : Fe);
        });
        e(ct, function(t) {
            var e = this.elements, n = e.length, i = this.rest;
            t.with_square(n || i ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (i) {
                    if (n) t.comma();
                    t.print("...");
                    i.print(t);
                } else if (e[n - 1] instanceof Ht) {
                    t.comma();
                }
                t.space();
            } : Fe);
        });
        e(lt, y);
        e(pt, function(t) {
            var e = this.properties, n = e.length, i = this.rest;
            if (n || i) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }); else o(this, t);
        });
        e(dt, function(t) {
            var e = this.properties;
            if (e.length > 0) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else o(this, t);
        });
        function b(e, n) {
            var t = e.key;
            if (t instanceof We) {
                n.with_square(function() {
                    t.print(n);
                });
            } else if (n.option("quote_keys")) {
                n.print_string(t);
            } else if ("" + +t == t && t >= 0) {
                n.print(S(t));
            } else {
                var i = e.start && e.start.quote;
                if (A[t] ? !n.option("ie8") : Lt(t)) {
                    if (i && n.option("keep_quoted_props")) {
                        n.print_string(t, i);
                    } else {
                        n.print_name(t);
                    }
                } else {
                    n.print_string(t, i);
                }
            }
        }
        function y(e) {
            var n = this;
            b(n, e);
            e.colon();
            n.value.print(e);
        }
        e(ht, y);
        function w(t) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                b(n, e);
                l(n.value, e);
            };
        }
        e(_t, w("get"));
        e(mt, w("set"));
        e(gt, function(e) {
            var n = this.definition();
            e.print_name(n && n.mangled_name || this.name);
        });
        e(Ht, Fe);
        e(Ot, function(e) {
            e.print("this");
        });
        e(At, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e($t, function(e) {
            e.print(this.value);
        });
        e(zt, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Mt, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(S(this.value));
            }
        });
        e(jt, function(e) {
            var n = this.value;
            var t = n.toString();
            var i = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(i);
            } else if (i == 1) {
                t = "/(?:)" + t.slice(i);
            } else if (t.indexOf("/", 1) < i) {
                t = "/" + t.slice(1, i).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(i);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
            var r = e.parent();
            if (r instanceof rt && /^in/.test(r.operator) && r.left === this) e.print(" ");
        });
        function x(e, n) {
            if (n.option("braces") && !(e instanceof Bn || e instanceof Yn)) {
                T(e, n);
            } else if (!e || e instanceof Ke) {
                n.force_semicolon();
            } else {
                e.print(n);
            }
        }
        function k(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function E(e) {
            var n = e[0], t = n.length;
            for (var i = 1; i < e.length; ++i) {
                if (e[i].length < t) {
                    n = e[i];
                    t = n.length;
                }
            }
            return n;
        }
        function S(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var i, r, a;
            if (i = /^\.0+/.exec(n)) {
                r = i[0].length;
                a = n.slice(r);
                t.push(a + "e-" + (a.length + r - 1));
            } else if (i = /0+$/.exec(n)) {
                r = i[0].length;
                t.push(n.slice(0, -r) + "e" + r);
            } else if (i = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(i[1] + i[2] + "e" + (i[3] - i[2].length));
            }
            return E(t);
        }
        function T(e, n) {
            if (!e || e instanceof Ke) n.print("{}"); else if (e instanceof tn) e.print(n); else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function D(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        D([ We, rn ], Fe);
        D([ ft, tn, In, $t, Ge, Un, ut, Rn, Dn, vn, Gn, dt, O, gt, qn, Cn, Pn ], function(e) {
            e.add_mapping(this.start);
        });
        D([ lt, vt ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var x = e("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var k = x.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function E(e, n) {
        var t = 0;
        var i = 0;
        for (var r = 0, a = 0; r < n.length; r++) {
            var o = k[n[r]];
            t += (o & 31) << i;
            if (o & 32) {
                i += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = i = 0;
            }
        }
        return a;
    }
    function S(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += x[t];
        } while (e);
        return n;
    }
    function T() {
        var n = Object.create(null);
        var t = [];
        t.index = function(e) {
            if (!Le(n, e)) {
                n[e] = t.length;
                t.push(e);
            }
            return n[e];
        };
        return t;
    }
    function D(l) {
        var f = T();
        var a = l.includeSources && Object.create(null);
        var u = T();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, E(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var i = 0; i < n.sources.length; i++) {
                var r = n.sourcesContent[i];
                if (r) a[n.sources[i]] = r;
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, i, r, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[i - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (r >= c) f = s[u];
                        if (r <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        i = f[2];
                        r = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, i, r, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!(e in a)) {
                    a[e] = n;
                }
            } : Fe,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a[e] || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, i, r, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += S(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += S(o - h);
            h = o;
            c += S(i - m);
            m = i;
            c += S(r - _);
            _ = r;
            if (l.names && a != null) {
                var s = u.index(a);
                c += S(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        function n(e) {
            var n = true;
            for (var t = 0; t < e.length; t++) {
                if (n && e[t] instanceof Je && e[t].body instanceof zt) {
                    e[t] = new Xe({
                        start: e[t].start,
                        end: e[t].end,
                        value: e[t].body.value
                    });
                } else if (n && !(e[t] instanceof Je && e[t].body instanceof zt)) {
                    n = false;
                }
            }
            return e;
        }
        var i = {
            Program: function(e) {
                return new dn({
                    start: s(e),
                    end: f(e),
                    body: n(e.body.map(u))
                });
            },
            FunctionDeclaration: function(e) {
                return new Tn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                return new kn({
                    start: s(e),
                    end: f(e),
                    name: u(e.id),
                    argnames: e.params.map(u),
                    body: n(u(e.body).body)
                });
            },
            ExpressionStatement: function(e) {
                return new Qe({
                    start: s(e),
                    end: f(e),
                    body: u(e.expression)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new Pn({
                    start: s(e),
                    end: f(e),
                    body: u(e.block).body,
                    bcatch: u(n[0]),
                    bfinally: e.finalizer ? new Rn(u(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.key;
                var t = {
                    start: s(n),
                    end: f(e.value),
                    key: "" + n[n.type == "Identifier" ? "name" : "value"],
                    value: u(e.value)
                };
                if (e.kind == "init") return new ht(t);
                t.value = new hn(t.value);
                if (e.kind == "get") return new _t(t);
                if (e.kind == "set") return new mt(t);
            },
            ArrayExpression: function(e) {
                return new ft({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Ht() : u(e);
                    })
                });
            },
            ObjectExpression: function(e) {
                return new dt({
                    start: s(e),
                    end: f(e),
                    properties: e.properties.map(function(e) {
                        e.type = "Property";
                        return u(e);
                    })
                });
            },
            SequenceExpression: function(e) {
                return new Xn({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(u)
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? Zn : Qn)({
                    start: s(e),
                    end: f(e),
                    property: e.computed ? u(e.property) : e.property.name,
                    expression: u(e.object)
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Hn : Nn)({
                    start: s(e),
                    end: f(e),
                    expression: u(e.test),
                    body: e.consequent.map(u)
                });
            },
            VariableDeclaration: function(e) {
                return new Ln({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(u)
                });
            },
            Literal: function(e) {
                var n = e.value, t = {
                    start: s(e),
                    end: f(e)
                };
                if (n === null) return new qt(t);
                var i = e.regex;
                if (i && i.pattern) {
                    t.value = new RegExp(i.pattern, i.flags);
                    t.value.raw_source = i.pattern;
                    return new jt(t);
                } else if (i) {
                    t.value = e.regex && e.raw ? e.raw : n;
                    return new jt(t);
                }
                switch (typeof n) {
                  case "string":
                    t.value = n;
                    return new zt(t);

                  case "number":
                    t.value = n;
                    return new Mt(t);

                  case "boolean":
                    return new (n ? Ut : Rt)(t);
                }
            },
            Identifier: function(e) {
                var n = a[a.length - 2];
                return new (n.type == "LabeledStatement" ? de : n.type == "VariableDeclarator" && n.id === e ? xt : n.type == "FunctionExpression" ? n.id === e ? St : kt : n.type == "FunctionDeclaration" ? n.id === e ? Et : kt : n.type == "CatchClause" ? Tt : n.type == "BreakStatement" || n.type == "ContinueStatement" ? ve : Dt)({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            ThisExpression: function(e) {
                return new Ot({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            }
        };
        i.UpdateExpression = i.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? tt : it)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: u(n.argument)
            });
        };
        e("EmptyStatement", Ke);
        e("BlockStatement", tn, "body@body");
        e("IfStatement", jn, "test>condition, consequent>body, alternate>alternative");
        e("LabeledStatement", rn, "label>label, body>body");
        e("BreakStatement", Mn, "label>label");
        e("ContinueStatement", Fn, "label>label");
        e("WithStatement", ln, "object>expression, body>body");
        e("SwitchStatement", qn, "discriminant>expression, cases@body");
        e("ReturnStatement", An, "argument>value");
        e("ThrowStatement", $n, "argument>value");
        e("WhileStatement", fn, "test>condition, body>body");
        e("DoWhileStatement", sn, "test>condition, body>body");
        e("ForStatement", un, "init>init, test>condition, update>step, body>body");
        e("ForInStatement", cn, "left>init, right>object, body>body");
        e("DebuggerStatement", Ge);
        e("VariableDeclarator", Vn, "id>name, init>value");
        e("CatchClause", In, "param>argname, body%body");
        e("BinaryExpression", rt, "operator=operator, left>left, right>right");
        e("LogicalExpression", rt, "operator=operator, left>left, right>right");
        e("AssignmentExpression", ot, "operator=operator, left>left, right>right");
        e("ConditionalExpression", at, "test>condition, consequent>consequent, alternate>alternative");
        e("NewExpression", Gn, "callee>expression, arguments@args");
        e("CallExpression", Jn, "callee>expression, arguments@args");
        c(dn, function e(n) {
            return d("Program", n);
        });
        c(Tn, function e(n) {
            return {
                type: "FunctionDeclaration",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(kn, function e(n) {
            return {
                type: "FunctionExpression",
                id: l(n.name),
                params: n.argnames.map(l),
                body: d("BlockStatement", n)
            };
        });
        c(Xe, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: {
                    type: "Literal",
                    value: n.value
                }
            };
        });
        c(Qe, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: l(n.body)
            };
        });
        c(Cn, function e(n) {
            return {
                type: "SwitchCase",
                test: l(n.expression),
                consequent: n.body.map(l)
            };
        });
        c(Pn, function e(n) {
            return {
                type: "TryStatement",
                block: p(n),
                handler: l(n.bcatch),
                guardedHandlers: [],
                finalizer: l(n.bfinally)
            };
        });
        c(In, function e(n) {
            return {
                type: "CatchClause",
                param: l(n.argname),
                guard: null,
                body: p(n)
            };
        });
        c(Un, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: "var",
                declarations: n.definitions.map(l)
            };
        });
        c(Xn, function e(n) {
            return {
                type: "SequenceExpression",
                expressions: n.expressions.map(l)
            };
        });
        c(Kn, function e(n) {
            var t = n instanceof Zn;
            return {
                type: "MemberExpression",
                object: l(n.expression),
                computed: t,
                property: t ? l(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
        });
        c(nt, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof tt,
                argument: l(n.expression)
            };
        });
        c(rt, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: l(n.left),
                operator: n.operator,
                right: l(n.right)
            };
        });
        c(ft, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(l)
            };
        });
        c(dt, function e(n) {
            return {
                type: "ObjectExpression",
                properties: n.properties.map(l)
            };
        });
        c(vt, function e(n) {
            var t = {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof ht) {
                i = "init";
            } else if (n instanceof _t) {
                i = "get";
            } else if (n instanceof mt) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                key: t,
                value: l(n.value)
            };
        });
        c(gt, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        c(Ot, function e() {
            return {
                type: "ThisExpression"
            };
        });
        c(jt, function e(n) {
            var t = n.value.toString().match(/[gimuy]*$/)[0];
            var i = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: i,
                raw: i,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        c($t, function e(n) {
            var t = n.value;
            if (typeof t === "number" && (t < 0 || t === 0 && 1 / t < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -t,
                        raw: n.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: t,
                raw: n.start.raw
            };
        });
        c(h, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        It.DEFMETHOD("to_mozilla_ast", $t.prototype.to_mozilla_ast);
        qt.DEFMETHOD("to_mozilla_ast", $t.prototype.to_mozilla_ast);
        Ht.DEFMETHOD("to_mozilla_ast", function e() {
            return null;
        });
        nn.DEFMETHOD("to_mozilla_ast", tn.prototype.to_mozilla_ast);
        vn.DEFMETHOD("to_mozilla_ast", kn.prototype.to_mozilla_ast);
        function r(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[0] : e.start,
                raw: r(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var i = e.range;
            return new Q({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: i ? i[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: i ? i[1] : e.end,
                raw: r(e)
            });
        }
        function e(e, n, t) {
            var a = "function From_Moz_" + e + "(M){\n";
            a += "return new U2." + n.name + "({\n" + "start: my_start_token(M),\n" + "end: my_end_token(M)";
            var o = "function To_Moz_" + e + "(M){\n";
            o += "return {\n" + "type: " + JSON.stringify(e);
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], i = n[2], r = n[3];
                a += ",\n" + r + ": ";
                o += ",\n" + t + ": ";
                switch (i) {
                  case "@":
                    a += "M." + t + ".map(from_moz)";
                    o += "M." + r + ".map(to_moz)";
                    break;

                  case ">":
                    a += "from_moz(M." + t + ")";
                    o += "to_moz(M." + r + ")";
                    break;

                  case "=":
                    a += "M." + t;
                    o += "M." + r;
                    break;

                  case "%":
                    a += "from_moz(M." + t + ").body";
                    o += "to_moz_block(M)";
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            a += "\n})\n}";
            o += "\n}\n}";
            a = new Function("U2", "my_start_token", "my_end_token", "from_moz", "return(" + a + ")")(v, s, f, u);
            o = new Function("to_moz", "to_moz_block", "to_moz_scope", "return(" + o + ")")(l, p, d);
            i[e] = a;
            c(n, o);
        }
        var a = null;
        function u(e) {
            a.push(e);
            var n = e != null ? i[e.type](e) : null;
            a.pop();
            return n;
        }
        We.from_mozilla_ast = function(e) {
            var n = a;
            a = [];
            var t = u(e);
            a = n;
            t.walk(new Bt(function(e) {
                if (e instanceof ve) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof pn) break;
                        if (t instanceof rn && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var i = e.start;
                        me("Undefined label " + e.name, i.file, i.line, i.col, i.pos);
                    }
                }
            }));
            return t;
        };
        function t(e, n, t) {
            var i = e.start;
            var r = e.end;
            if (i.pos != null && r.endpos != null) {
                n.range = [ i.pos, r.endpos ];
            }
            if (i.line) {
                n.loc = {
                    start: {
                        line: i.line,
                        column: i.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (i.file) {
                    n.loc.source = i.file;
                }
            }
            return n;
        }
        function c(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return t(this, n(this));
            });
        }
        function l(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function p(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(l)
            };
        }
        function d(e, n) {
            var t = n.body.map(l);
            if (n.body[0] instanceof Qe && n.body[0].body instanceof zt) {
                t.unshift(l(new Ke(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var $ = function() {
        var n = [];
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return Ue(n);
        function t(e) {
            n.push(e);
        }
    }();
    function z(e, n) {
        e.walk(new Bt(function(e) {
            if (e instanceof vt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof Zn) {
                Y(e.property, t);
            }
        }));
        function t(e) {
            Pe(n, e);
        }
    }
    function Y(e, n) {
        if (e instanceof at) {
            Y(e.consequent, n);
            Y(e.alternative, n);
        } else if (e instanceof Xn) {
            Y(e.tail_node(), n);
        } else if (e instanceof zt) {
            n(e.value);
        }
    }
    function L(e, t) {
        t = pe(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = Object.create(t.builtins ? null : $);
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n[e] = true;
        });
        var i = -1;
        var r;
        if (t.cache) {
            r = t.cache.props;
            r.each(function(e) {
                n[e] = true;
            });
        } else {
            r = new Ye();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = Object.create(null);
        var u = Object.create(n);
        e.walk(new Bt(function(e) {
            if (e instanceof rt) {
                if (e.operator == "in") Y(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Dt)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    Y(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    Y(e.args[0], p);
                    break;
                }
            } else if (e instanceof Qn) {
                p(e.property);
            } else if (e instanceof vt) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof Zn) {
                Y(e.property, p);
            }
        }));
        e.walk(new Bt(function(e) {
            if (e instanceof rt) {
                if (e.operator == "in") v(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof Qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Dt)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    v(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    v(e.args[0]);
                    break;
                }
            } else if (e instanceof Qn) {
                e.property = d(e.property);
            } else if (e instanceof vt) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof Zn) {
                if (!t.keep_quoted) v(e.property);
            }
        }));
        function c(e) {
            if (u[e]) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n[e]) return false;
            if (a && !a.test(e)) return false;
            return r.has(e) || f[e];
        }
        function p(e) {
            if (c(e)) f[e] = true;
            if (!l(e)) u[e] = true;
        }
        function d(e) {
            if (!l(e)) {
                return e;
            }
            var n = r.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = w(++i);
                } while (!c(n));
                r.set(e, n);
            }
            return n;
        }
        function v(e) {
            if (e instanceof Xn) {
                v(e.expressions.tail_node());
            } else if (e instanceof zt) {
                e.value = d(e.value);
            } else if (e instanceof at) {
                v(e.consequent);
                v(e.alternative);
            }
        }
    }
    "use strict";
    var V, W;
    if (typeof Buffer == "undefined") {
        V = atob;
        W = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        V = function(e) {
            return new Buffer(e, "base64").toString();
        };
        W = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        V = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        W = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function J(e, n) {
        var t = n.end.comments_after;
        for (var i = t.length; --i >= 0; ) {
            var r = t[i];
            if (r.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(r.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,(\S+)$/.exec(a[2]);
                if (!a) break;
                return V(a[2]);
            }
        }
        We.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function G(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function X(n, t, e) {
        if (t[n]) {
            e.forEach(function(e) {
                if (t[e]) {
                    if (typeof t[e] != "object") t[e] = {};
                    if (!(n in t[e])) t[e][n] = t[n];
                }
            });
        }
    }
    function ie(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new Ye();
        } else if (!(e.props instanceof Ye)) {
            e.props = Ye.fromObject(e.props);
        }
    }
    function re(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ae(i, r) {
        try {
            r = pe(r, {
                compress: {},
                enclose: false,
                ie8: false,
                keep_fnames: false,
                mangle: {},
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: false,
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (r.validate) We.enable_validation();
            var e = r.timings && {
                start: Date.now()
            };
            if (r.rename === undefined) {
                r.rename = r.compress && r.mangle;
            }
            X("ie8", r, [ "compress", "mangle", "output" ]);
            X("keep_fnames", r, [ "compress", "mangle" ]);
            X("toplevel", r, [ "compress", "mangle" ]);
            X("v8", r, [ "mangle", "output" ]);
            X("webkit", r, [ "mangle", "output" ]);
            var n;
            if (r.mangle) {
                r.mangle = pe(r.mangle, {
                    cache: r.nameCache && (r.nameCache.vars || {}),
                    eval: false,
                    ie8: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (r.mangle.properties) {
                    if (typeof r.mangle.properties != "object") {
                        r.mangle.properties = {};
                    }
                    if (r.mangle.properties.keep_quoted) {
                        n = r.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        r.mangle.properties.reserved = n;
                    }
                    if (r.nameCache && !("cache" in r.mangle.properties)) {
                        r.mangle.properties.cache = r.nameCache.props || {};
                    }
                }
                ie(r.mangle.cache);
                ie(r.mangle.properties.cache);
            }
            if (r.sourceMap) {
                r.sourceMap = pe(r.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (r.warnings) We.log_function(function(e) {
                t.push(e);
            }, r.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (i instanceof dn) {
                a = i;
            } else {
                if (typeof i == "string") {
                    i = [ i ];
                }
                r.parse = r.parse || {};
                r.parse.toplevel = null;
                var o = r.sourceMap && r.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = G(o);
                }
                if (o) r.sourceMap.orig = Object.create(null);
                for (var s in i) if (Le(i, s)) {
                    r.parse.filename = s;
                    r.parse.toplevel = a = Xt(i[s], r.parse);
                    if (o == "inline") {
                        var f = J(s, a);
                        if (f) {
                            r.sourceMap.orig[s] = G(f);
                        }
                    } else if (o) {
                        r.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                z(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = r[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                i[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (r.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (r.rename) {
                a.figure_out_scope(r.mangle);
                a.expand_names(r.mangle);
            }
            if (e) e.compress = Date.now();
            if (r.compress) {
                a = new Zt(r.compress).compress(a);
                if (r.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (r.mangle) a.figure_out_scope(r.mangle);
            if (e) e.mangle = Date.now();
            if (r.mangle) {
                a.compute_char_frequency(r.mangle);
                a.mangle_names(r.mangle);
            }
            if (e) e.properties = Date.now();
            if (r.mangle && r.mangle.properties) L(a, r.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            if (r.output.ast) {
                u.ast = a;
            }
            if (!Le(r.output, "code") || r.output.code) {
                if (r.sourceMap) {
                    r.output.source_map = D(r.sourceMap);
                    if (r.sourceMap.includeSources) {
                        if (i instanceof dn) {
                            throw new Error("original source content unavailable");
                        } else for (var s in i) if (Le(i, s)) {
                            r.output.source_map.setSourceContent(s, i[s]);
                        }
                    }
                }
                delete r.output.ast;
                delete r.output.code;
                var c = ei(r.output);
                a.print(c);
                u.code = c.get();
                if (r.sourceMap) {
                    u.map = r.output.source_map.toString();
                    var l = r.sourceMap.url;
                    if (l) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (l == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + W(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + l;
                        }
                    }
                }
            }
            if (r.nameCache && r.mangle) {
                if (r.mangle.cache) r.nameCache.vars = re(r.mangle.cache);
                if (r.mangle.properties && r.mangle.properties.cache) {
                    r.nameCache.props = re(r.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            We.log_function();
            We.disable_validation();
        }
    }
    v["Dictionary"] = Ye;
    v["List"] = He;
    v["minify"] = ae;
    v["parse"] = Xt;
    v["push_uniq"] = Pe;
    v["TreeTransformer"] = Yt;
    v["TreeWalker"] = Bt;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
